import express from 'express';
import emailController from './email.controller';
import { validateBody, schemas } from '../../../middleware/validator';

export const emailRouter = express.Router();
emailRouter.route('/eml').post(emailController.create);
emailRouter.route('/find').post(validateBody(schemas.checkEmailSchema), emailController.find);
emailRouter.route('/disableImap').post(emailController.disableImap);
emailRouter.route('/enableImap').post(emailController.enableImap);
emailRouter.route('/parseheader').post(emailController.parseHeader);
emailRouter.route('/notSpam').post(emailController.notSpam);
emailRouter.route('/checkConfig').get(emailController.checkConfig);
emailRouter.route('/parseEmal64').post(emailController.parseEmal64);
emailRouter.route('/parseEmal64').options(emailController.parseEmal64Options);
emailRouter.route('/getheaders').post(emailController.getHeaders);
emailRouter.route('/movetojunk').post(emailController.moveMail);