var inspect = require('util').inspect;
var fs = require('fs');
import Dashboard from './modules/Dashboard'
import path from 'path';
import { queue } from './kue';
import imap from './imap';
import TAB from './modules/TAB';
const simpleParser = require('mailparser').simpleParser;
const _ = require('lodash');
import Blowfish from 'egoroof-blowfish';
var bf = new Blowfish(toString(process.env.APP_SECRET), Blowfish.MODE.ECB, Blowfish.PADDING.NULL);
const fromHexString = hexString => new Uint8Array(hexString.match(/.{1,2}/g).map(byte => parseInt(byte, 16)));
var base64 = require('file-base64');
const { Base64Decode } = require("base64-stream");

var imaps = require('imap-simple');

var makeid = () => {
  var text = "";
  var possible = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";
  for (var i = 0; i < 7; i++)
    text += possible.charAt(Math.floor(Math.random() * possible.length));
  return text;
}

function toUpper(thing) { return thing && thing.toUpperCase ? thing.toUpperCase() : thing; }

export default {
  init: () => {
    new Dashboard().findImapEnabled()
      .then(r => {
        console.log("Imap result",r);
        if (r) {
          return r.imapIsEnabled.reduce((p, value) => {
            imap.create(value);
          }, Promise.resolve())
        }
        else throw new Error("No ")
      })
      .catch(err => {
        console.log(err)
      })

  },
  create: async (companyId) => {
    var r = await new Dashboard().findImapConfig({ companyCode: companyId })
    for (var i = 1; i < r.config.length; i++) {
      if (r.config[i].key == 'imap_userID') var userId = r.config[i].value;
      else if (r.config[i].key == 'imap_password') { var imap_password = bf.decode(fromHexString(r.config[i].value)); }
      else if (r.config[i].key == 'imap_host') var imap_host = r.config[i].value;
      else if (r.config[i].key == 'imap_port') var imap_port = r.config[i].value;
      else if (r.config[i].key == 'imap_tls') var imap_tls = r.config[i].value;
    }
    console.log(userId, imap_password, imap_host, imap_port, imap_tls)
    var config = {
      imap: {
        user: userId,
        password: 'pA$$grpRep&o@577',
        host: imap_host,
        port: imap_port,
        tls: imap_tls,
        tlsOptions: { servername: imap_host },
        authTimeout: 3000
      },
      onmail: function (numNewMail) {
        global.imapList[companyId].openBox('INBOX').then(function (box) {
          var searchCriteria = [box.messages.total + ':*'];
          //  var fetchOptions = { bodies: ['HEADER.FIELDS (FROM TO SUBJECT DATE)'], struct: true , markSeen: true};
          var fetchOptions = { bodies: ['HEADER', 'TEXT', ''], struct: true, markSeen: true };

          // retrieve only the headers of the messages
          return global.imapList[companyId].search(searchCriteria, fetchOptions);
        })
          .then(function (messages) {
            var attachments = [];
            //  messages.forEach(function (messages) 
            var parts = imaps.getParts(messages[0].attributes.struct);
            attachments = attachments.concat(parts.filter(function (part) {
              return part.disposition && part.disposition.type.toUpperCase() === 'ATTACHMENT';
            }).map(function (part) {
              return global.imapList[companyId].getPartData(messages, part)
                .then(function (partData) {
                  if (part.disposition.params == undefined) return { filename: new Date().getTime() + ".eml", data: partData };
                  else return { filename: part.disposition.params.filename, data: partData };
                });
            }));
            //  });
            return Promise.all(attachments);
          }).then(function (attachments) {
            console.log(attachments[0].filename, "length")
            var filePath = path.join(appRoot, '..', 'mail-files', 'emls', attachments[0].filename);
            fs.writeFile(filePath, attachments[0].data, function (err) {
              if (err) return console.log(err);
              console.log("EML File Saved in mail-files directory with filename:" + attachments[0].filename);
              if (attachments[0].filename.split('.')[1] == "eml") queue.create('convert-eml-to-header-body', { path: filePath, companyCode: companyId }).save();
              else queue.create('convert-txt-file-to-header-body', { path: filePath, companyCode: companyId }).save();
            });
          });

      },
    };
    imaps.connect(config).then(function (connection) {
      global.imapList[companyId] = connection;
      global.imapList[companyId].openBox('INBOX').then(function () {
      })
        .then(function (messages) {
        });
    });
  },

  close: (companyId) => {
    try {
      global.imapList[companyId].end();
    } catch (error) {
      console.log("Error while closing imap",error);
    }
  }
}