import BaseJoi from 'joi';
import DateExtension from 'joi-date-extensions';
const Joi = BaseJoi.extend(DateExtension);

export var validateBody = (schema) => {
	return (req, res, next) => {
		const result = req.method != 'GET' ? Joi.validate(req.body, schema) : Joi.validate(req.query, schema);
		if (result.error) {
			return res.status(400).json(result.error);
		}

		if (!req.value) {
			req.value = {};
		}
		req.value['body'] = result.value;
		next();
	}
}

export var schemas = {
	emailSchema: Joi.object().keys({
		token: Joi.string().required(),
		header: Joi.string().optional(),//.required(),
		body: Joi.string().required(),
		to: Joi.string().required(),
		from: Joi.string().required(),
		fromJMETER: Joi.string().optional().allow(null).empty(''),
		attachments: Joi.array().optional().allow(null).empty('')
	}),
	checkEmailSchema: Joi.object().keys({
		token: Joi.string().required(),
		header: Joi.string().optional(),
		//.required(),
		body: Joi.string().required(),
	})
}