import API from './API';
import config from '../config';
import md5 from 'md5';
import { queue } from '../kue';
import Dashboard from '../modules/Dashboard';
export default class TAB extends API {
	constructor() {
		super()
	}
	processFile(data) {
		return super.post(config.tab.url + '/api/email', data);
	}

	getFile(code, data) {
		return super.get(config.tab.url + `/api/email/${code}`, data);
	}

	create(data) {
		return new Promise((resolve, reject) => {
			let { header, body, attachment, to, from, token } = data;
			let filename = md5(header) + '.' + md5((body && body.length) ? body : 'null');
			console.log('Recieved New Report with token', token, 'and filename', filename);
			//Create new Queue
			queue.create('process-request', { header: header, body: body, token: token, to: to, attachments: attachment, fileName: filename }).save();
			resolve()
		})
	}

	checkSpamHam(data) {
		return super.post(config.tab.url + `/api/scan/checkSpamHam`, data);
	}
	
	notSpam(data){
		return super.post(config.tab.url + `/api/scan/notSpam`, data);
	}
}

