import { db } from '../../../models'
import cuid from 'cuid';
import request from 'request';

function trackIP(ip) {
    return new Promise((resolve, reject) => {
        request.get({
                url: 'https://www.iplocate.io/api/lookup/' + ip,
                method: 'GET',
            },
            function(error, response, body) {
                if (!error && response.statusCode == 200) {
                    body = JSON.parse(body)
                    resolve({ country: body.country, continent: body.continent });
                } else {
                    resolve({ 'body': body ? body.RestException : null });
                }
            });
    })
}

export default {
    async saveAuditLog(req, res, next) {
        if (req.body.IP == '1' || req.body.IP == '127.0.0.1')
            req.body.country = "India";
        else
            req.body.country = await trackIP(req.body.IP);
        console.log("Inside saveAuditLog", req.body);
        return db.AuditLogs.create({
            userId: req.body.userId,
            companyId: req.body.companyId,
            EmployeeId: req.body.EmployeeId,
            oldData: JSON.stringify(req.body.oldData),
            newData: JSON.stringify(req.body.newData),
            metaData: JSON.stringify(req.body.metaData),
            activity: req.body.activity,
            activitycode: cuid(),
            ip: req.body.IP,
            country: req.body.country.country && req.body.country.country != null ? req.body.country.country : (req.body.country && req.body.country.country != null ? req.body.country : "NA"),
        }).then(r => {
            console.log("New audit log added");
            res.send("Auditing connected")
        });
    },
    async getAuditList(req, res, next) {
        console.log("Insde getAuditList", req.body);
        return db.AuditLogs.findAll({
                order: [
                    ['id', 'DESC']
                ]
            })
            .then(r => {
                res.send(r)
            }).catch(err => {
                console.log("Error while fetching audit list", err);
                res.send([]);
            })
    }
}