function query(e, t, n, r, success, error, showError = true) {

    if (typeof mprogress != 'undefined') {
        mprogress.start();
    }
    var params = {}
    if (t == 'GET' && n != undefined) {
        params = $.extend({}, params, n);
        n = undefined;
    }
    return $.ajax({
        url: "/api" + e + "?" + jQuery.param(params),
        async: r,
        method: t,
        data: n != undefined ? JSON.stringify(n) : '',
        dataType: "json",
        contentType: "application/json",
        success: function(msg) {
            if (typeof mprogress != 'undefined') {
                mprogress.end(true);
            }
            success(msg);
        },
        error: function(jqXHR, textStatus, errorThrown) {
            if (typeof mprogress != 'undefined') {
                mprogress.end(true);
            }
            if (showError)
                showAPIError(jqXHR.status, (jqXHR.responseJSON ? jqXHR.responseJSON : (jqXHR.responseText === "Unauthorized" ? { errors: ['Invalid Credentials'] } : jqXHR.responseText)));
            if (error != undefined) error(jqXHR.responseJSON);
        }
    })
}

function dataQuery(e, t, n, tableId, column_data) {
    var params = {}
    if (t == 'GET' && n != undefined) {
        params = $.extend({}, params, n);
        n = undefined;
    }
    return $('#' + tableId).DataTable({
        "ajax": {
            url: "/dashapi" + e + "?" + jQuery.param(params),
        },
        "rowCallback": function(nRow, cssaData, iDisplayIndex) {
            $('#' + tableId).show();
            var oSettings = this.fnSettings();
            $("td:first", nRow).html(oSettings._iDisplayStart + iDisplayIndex + 1);
            return nRow;
        },
        "columns": column_data,
        "bDestroy": true
    });
}


// function mediaQuery(e, t, n, r, success, error) {
//     if(typeof mprogress != 'undefined'){
//         mprogress.start();
//     }
//     return $.ajax({
//         /* xhr: function () {
//             var xhr = new window.XMLHttpRequest();
//             xhr.upload.addEventListener("progress", function (evt) {
//                 if (evt.lengthComputable) {
//                     var percentComplete = evt.loaded / evt.total;
//                     $('.ajax-file-loading').css({
//                         width: percentComplete * 100 + '%'
//                     });
//                     if (percentComplete === 1) {
//                         $('.ajax-file-loading').addClass('hide');
//                     }
//                 }
//             }, false);
//             xhr.addEventListener("progress", function (evt) {
//                 if (evt.lengthComputable) {
//                     var percentComplete = evt.loaded / evt.total;
//                     console.log(percentComplete);
//                     $('.ajax-file-loading').css({
//                         width: percentComplete * 100 + '%'
//                     });
//                 }
//             }, false);
//             return xhr;
//         }, */
//         url: "/api" + e,
//         async: r,
//         method: t,
//         data: n != undefined ? n : '',
//         processData: false,
//         contentType: false,
//         success: function(msg){
//             if(typeof mprogress != 'undefined'){
//                 mprogress.end(true);
//             }
//             success(msg);
//         },        
//         error: function(jqXHR, textStatus, errorThrown){
//             if(typeof mprogress != 'undefined'){
//                 mprogress.end(true);
//             }
//             showAPIError(jqXHR.status, (jqXHR.responseJSON?jqXHR.responseJSON:(jqXHR.responseText === "Unauthorized"?{errors: ['Invalid Credentials']}:jqXHR.responseText)));
//             if(error != undefined) error(jqXHR.responseJSON);
//         }
//     })
// }

function queryURL(e, t, n, r, success, error) {
    if (typeof mprogress != 'undefined') {
        mprogress.start();
    }
    return $.ajax({
        url: e,
        async: r,
        method: t,
        data: n != undefined ? n : '',
        processData: false,
        contentType: false,
        success: function(msg) {
            if (typeof mprogress != 'undefined') {
                mprogress.end(true);
            }
            success(msg);
        },
        error: function(jqXHR, textStatus, errorThrown) {
            if (typeof mprogress != 'undefined') {
                mprogress.end(true);
            }
            showAPIError(jqXHR.status, (jqXHR.responseJSON ? jqXHR.responseJSON : (jqXHR.responseText === "Unauthorized" ? { errors: ['Invalid Credentials'] } : jqXHR.responseText)));
            if (error != undefined) error(jqXHR.responseJSON);
        }
    })
}

var api = {
    auth: {
        post: function(data, success, error) {
            return query('/auth/register/', "POST", data, 1, success, error)
        },
        login: function(data, success, error) {
            return query('/auth/login/', "POST", data, 1, success, error)
        },
        rootLogin: function(data, success, error) {
            return query('/auth/rootLogin/', "POST", data, 1, success, error)
        },
        rootCheck: function(data, success, error) {
            return query('/auth/rootCheck/', "POST", data, 1, success, error)
        },
        changePassword: function(data, success, error) {
            return query('/auth/changePassword/', "POST", data, 1, success, error)
        },
        changeEmployeePassword: function(data, success, error) {
            return query('/auth/changeEmployeePassword/', "POST", data, 1, success, error)
        },
        sendReset: function(data, success, error, showe) {
            return query('/auth/sendReset/', "POST", data, 1, success, error, showe)
        },
        resetPassword: function(data, success, error) {
            return query('/auth/reset/', "POST", data, 1, success, error)
        },
        addUser: function(data, success, error) {
            return query('/auth/add/', "POST", data, 1, success, error)
        },
        userCheck: function(data, success, error) {
            return query('/auth/userCheck/', "POST", data, 1, success, error)
        },
        otpGen: function(data, success, error) {
            return query('/auth/otpGen/', "POST", data, 1, success, error)
        },
        resendOTP: function(data, success, error) {
            return query('/auth/resendOTP/', "POST", data, 1, success, error)
        },
        otpVerify: function(data, success, error) {
            return query('/auth/otpVerify/', "POST", data, 1, success, error)
        },
        otpCheck: function(data, success, error) {
            return query('/auth/otpCheck/', "POST", data, 1, success, error)
        },
        otpLink: function(data, success, error) {
            return query('/auth/otpLink/', "POST", data, 1, success, error)
        },
        lead: function(data, success, error) {
            return query('/auth/lead/', "POST", data, 1, success, error)
        },
        checkOTPforlogin: function(data, success, error) {
            return query('/auth/checkOTPforlogin/', "POST", data, 1, success, error)
        },
        sendOTP: function(data, success, error) {
            return query('/auth/sendOtp/', "POST", data, 1, success, error)
        },
        loginwithOTP: function(data, success, error) {
            return query('/auth/loginwithotp/', "POST", data, 1, success, error)
        },
        OTPresend: function(data, success, error) {
            return query('/auth/otpresend/', "POST", data, 1, success, error)
        },
        updateProfileImage: function(data, success, error) {
            console.log("data", data);
            console.log("success", success);
            console.log("error", error);
            return query('/auth/updateProfileImage/', "POST", data, 1, success, error)
        }
    },
    iam: {
        policylist: function(data, tableId, column_data) {
            return dataQuery('/iam/list/', "GET", data, tableId, column_data)
        },

        showPolicy: function(id, data, success, error) {
            return query('/iam/show/' + id, "GET", data, 1, success, error)
        },
        searchlist: function(data, success, error) {
            return query('/iam/search/', "POST", data, 1, success, error)
        },
        searchaction: function(data, success, error) {
            return query('/iam/searchAction/', "POST", data, 1, success, error)
        },
        createPolicy: function(data, success, error) {
            return query('/iam/add/', "POST", data, 1, success, error)
        },
        updatePolicy: function(data, success, error) {
            return query('/iam/update/', "patch", data, 1, success, error)
        },
        policyDelete: function(id, data, success, error) {
            return query('/iam/delete/' + id, "GET", data, 1, success, error)
        },
        policyUserCount: function(id, data, success, error) {
            return query('/iam/count/' + id, "GET", data, 1, success, error)
        },
    },
    iamUser: {
        Userlist: function(data, tableId, column_data) {
            return dataQuery('/iam-user/list/', "GET", data, tableId, column_data)
        },
        UserPolicylist: function(id, tableId, column_data) {
            console.log("12")
            return dataQuery('/iam-user/show/' + id, "GET", id, tableId, column_data)
        },
        employeeDelete: function(id, data, success, error) {
            return query('/iam-user/delete/' + id, 'DELETE', data, 1, success, error)
        },
        UserpolicyDelete: function(policyId, data, success, error) {
            return query('/iam-user/delete/' + policyId + '/' + id, 'GET', data, 1, success, error)
        },
        addEmployee: function(data, success, error) {
            return query('/iam-user/addEmployee/', 'POST', data, 1, success, error)
        },
        employeePolicyList: function(id, tableId, column_data) {
            return dataQuery('/iam-user/employeePolicyList/' + id, 'GET', id, tableId, column_data)
        },
        employeePolicyUpdate: function(id, data, success, error) {
            return query('/iam-user/employeePolicyUpdate/' + id, 'PATCH', data, 1, success, error)
        },
        employeeResetPassword: function(data, success, error) {
            return query('/iam-user/resetPassword/', 'POST', data, 1, success, error)
        },
    },
    action: {
        actionlist: function(data, tableId, column_data) {
            return dataQuery('/action/actionlist/' + data, "GET", data, tableId, column_data)
        },
    },
    setting: {
        profileUpdate: function(data, success, error) {
            return query('/setting/profile/', "PATCH", data, 1, success, error)
        },
        changePassword: function(data, success, error) {
            return query('/setting/password/', "PATCH", data, 1, success, error)
        },
        generatekey: function(data, success, error) {
            return query('/setting/generate/', "POST", data, 1, success, error)
        },
        get: function(data, success, error) {
            return query('/setting/downloadpem/', "GET", data, 1, success, error)
        },
        setExchange: function(data, success, error) {
            return query('/setting/exchange/', "POST", data, 1, success, error)
        },
        getExchange: function(data, success, error) {
            return query('/setting/exchange/', "GET", data, 1, success, error)
        },
        metaAuth: function(data, success, error) {
            return query('/setting/metaAuth/', "POST", data, 1, success, error)
        },
        imapUpdate: function(data, success, error) {
            return query('/setting/updateImap/', "POST", data, 1, success, error)
        },
        imapDisable: function(data, success, error) {
            return query('/setting/disableImap/', "POST", data, 1, success, error)
        },
        reportButtonConfig: function(data, success, error) {
            return query('/setting/reportButtonConfig/', "POST", data, 1, success, error)
        },
        signInOutlook: function(data, success, error) {
            return query('/setting/outlook-login', "GET", data, 1, success, error)
        },
        generateVerifcationCode: function(data, success, error) {
            return query('/setting/generate-google-auth-code', "POST", data, 1, success, error)
        },
        verifyAndUpdateTwoFa: function(data, success, error) {
            return query('/setting/verify-two-fa', "POST", data, 1, success, error)
        },
    },
    inbox: {
        list: function(data, success, error) {
            return query('/inbox/', "GET", data, 1, success, error)
        },
        fetchMail: function(data, success, error, showError) {
            return query('/inbox/mail/', "GET", data, 1, success, error, showError)
        },
        analyticsDomainAuthRisk: function(data, success, error, showError) {
            return query('/inbox/analyticsDomainAuthRisk/', "GET", data, 1, success, error, showError)
        },
        fetchAttachment: function(data, success, error) {
            return query('/inbox/attachment/', "GET", data, 1, success, error)
        },
        attachmentRisk: function(data, success, error, showError) {
            return query('/inbox/attachmentRisk/', "GET", data, 1, success, error, showError)
        },
        fetchUrl: function(data, success, error) {
            return query('/inbox/link/', "GET", data, 1, success, error)
        },
        deleteMail: function(data, success, error) {
            return query('/inbox/deleteMail/', "post", data, 1, success, error)
        },
        deleteMailWhoElse: function(data, success, error) {
            return query('/inbox/deleteSingleMail', "post", data, 1, success, error)
        },
        blockSender: function(data, success, error) {
            return query('/inbox/blockSender', "post", data, 1, success, error)
        },
        blockDomain: function(data, success, error) {
            return query('/inbox/blockDomain', "post", data, 1, success, error)
        },
        scan: function(data, success, error) {
            return query('/inbox/scan', "post", data, 1, success, error)
        },
        mailRisk: function(data, success, error, showError) {
            return query('/inbox/mailRisk', "post", data, 1, success, error, showError)
        },
        urlRisk: function(data, success, error, showError) {
            return query('/inbox/urlRisk', "post", data, 1, success, error, showError)
        },
        gctxRisk: function(data, success, error, showError) {
            return query('/inbox/gctxRisk', "post", data, 1, success, error, showError)
        },
        changeStatus: function(data, success, error) {
            return query('/inbox/changeStatus/', "post", data, 1, success, error)
        },
        recoverMail: function(data, success, error) {
            return query('/inbox/recoverMail/', "post", data, 1, success, error)
        },
        recoverSingleMail: function(data, success, error) {
            return query('/inbox/recoverSingleMail/', "post", data, 1, success, error)
        },
        deleteMail_v2: function(data, success, error) {
            return query('/inbox/deleteMail_v2/', "post", data, 1, success, error)
        },
        recoverMail_v2: function(data, success, error) {
            return query('/inbox/recoverMail_v2/', "post", data, 1, success, error)
        },

    },
    home: {
        reporter: function(data, success, error) {
            return query('/home/reporter/', "GET", data, 1, success, error)
        },
        totalReport: function(data, success, error) {
            return query('/dashboard/totalReport/', "GET", data, 1, success, error)
        },
        spamOrHamp: function(data, success, error) {
            return query('/dashboard/spamOrHamp/', "GET", data, 1, success, error)
        },
        pendingCount: function(data, success, error) {
            return query('/dashboard/pendingCount/', "GET", data, 1, success, error)
        },
        approveCount: function(data, success, error) {
            return query('/dashboard/approveReport/', "GET", data, 1, success, error)
        },
        declineCount: function(data, success, error) {
            return query('/dashboard/declinedReport/', "GET", data, 1, success, error)
        },
        monthReport: function(data, success, error) {
            return query('/dashboard/monthReport/', "GET", data, 1, success, error)
        },
        topReport: function(data, success, error) {
            return query('/dashboard/topReportedMail/', "GET", data, 1, success, error)
        },
        recentReportedMails: function(data, success, error) {
            return query('/dashboard/recentReportedMails/', "GET", data, 1, success, error)
        },
        updateFcmToken: function(data, success, error) {
            return query('/dashboard/updateFcmToken/', "GET", data, 1, success, error)
        },
        auditList: function(data, success, error) {
            return query('/audit/get-audit-logs', "POST", data, 1, success, error)
        },
    },
    gctx: {
        get: function(data, success, error) {
            return query('/gctx/', "GET", data, 1, success, error)
        },
    },
    advanceSearch: {
        scan: function(data, success, error) {
            return query('/advanceSearch', "POST", data, 1, success, error)
        },
        advanceScanResponse: function(data, success, error) {
            return query('/advanceSearch/advanceScanResponse', "POST", data, 1, success, error)
        },
        blockDomain: function(data, success, error) {
            return query('/advanceSearch/blockDomain', "POST", data, 1, success, error)
        },
        blockSender: function(data, success, error) {
            return query('/advanceSearch/blockSender', "POST", data, 1, success, error)
        },
        deleteMail: function(data, success, error) {
            return query('/advanceSearch/deleteMail', "POST", data, 1, success, error)
        },
        updateAccessToken: function(data, success, error) {
            return query('/advanceSearch/updateToken', "POST", data, 1, success, error);
        },
        deleteAccessToken: function(data, success, error) {
            return query('/advanceSearch/deleteToken', "POST", data, 1, success, error);
        },
        deleteMail_v2: function(data, success, error) {
            return query('/inbox/deleteMail_v2/', "post", data, 1, success, error)
        },
        recoverMail_v2: function(data, success, error) {
            return query('/inbox/recoverMail_v2/', "post", data, 1, success, error)
        },
    },
    blacklisted: {
        list: function(data, success, error) {
            return query('/blacklist/', "GET", data, 1, success, error)
        },
        unBlockSender: function(data, success, error) {
            return query('/blacklist/unBlockSender/', "POST", data, 1, success, error)
        },
        unBlockDomain: function(data, success, error) {
            return query('/blacklist/unBlockDomain/', "POST", data, 1, success, error)
        },
    },
    aggregateReports: {
        mailboxAnalysis: function(data, success, error) {
            return query('/aggregateReports/mailboxAnalysis', "POST", data, 1, success, error)
        },
        dailyReport: function(data, success, error) {
            return query('/aggregateReports/dailyReports', "POST", data, 1, success, error)
        },
        headerAnalysis: function(data, success, error) {
            return query('/aggregateReports/headersAnalyticsCount', "POST", data, 1, success, error)
        },
        failedHeadersMails: function(data, success, error) {
            return query('/aggregateReports/failedHeadersMails', "POST", data, 1, success, error)
        },
        scannedAttachments: function(data, success, error) {
            return query('/aggregateReports/scannedAttachmentsAnalysis', "POST", data, 1, success, error)
        },
        scannedUrls: function(data, success, error) {
            return query('/aggregateReports/scannedUrlsAnalysis', "POST", data, 1, success, error)
        },
        gctxAnalysis: function(data, success, error) {
            return query('/aggregateReports/gctxScannedAnalysis', "POST", data, 1, success, error)
        }
    }
}