import express from 'express';
import { jwtStrategyThreacop, jwtLogoutStrategy, magicLinkStrategy, jwtStrategy, employeeMagicStrategy, employeeResetPasswordMagicStrategy } from '../../../../middleware/strategy';
import authController from './auth.controller';
import { loginCheck } from '../../../../middleware/auth';

export const authRouter = express.Router();
authRouter.route('/register').get(loginCheck(), authController.register);
authRouter.route('/login').get(loginCheck(), authController.login);
authRouter.route('/logout').get(jwtLogoutStrategy, authController.logout);
authRouter.route('/verify').get(authController.verifyMessage);
authRouter.route('/password/reset').get(authController.sendReset);
authRouter.route('/verify/:email/:token').get(authController.verify);
authRouter.route('/reset/:email/:token').get(authController.reset);
authRouter.route('/change-password/').get(jwtStrategy, authController.changepassword);
authRouter.route('/login/:email/:password').get((req, res, next) => { req.query = req.params;
    next(); }, magicLinkStrategy, authController.loginredirect);
authRouter.route('/employeelogin/:email/:password/:alias').get((req, res, next) => { req.query = req.params;
    next(); }, employeeMagicStrategy, authController.change);
authRouter.route('/change-password/:email/:password/:alias').get((req, res, next) => { req.query = req.params;
    next(); }, employeeResetPasswordMagicStrategy, authController.change);
authRouter.route('/threatcop').get((req, res, next) => {
    req.body['email'] = req.query.email,
        req.body['password'] = req.query.email
    next()
}, jwtStrategyThreacop, authController.myRedirect);