'use strict';
module.exports = {
	up: (queryInterface, Sequelize) => {
		return queryInterface.createTable('Users', {
			id: {
				allowNull: false,
				autoIncrement: true,
				primaryKey: true,
				type: Sequelize.INTEGER
			},
			firstName: {
				type: Sequelize.STRING
			},
			lastName: {
				type: Sequelize.STRING
			},
			email: {
				type: Sequelize.STRING
			},
			password: {
				type: Sequelize.STRING
			},
			phone: {
				type: Sequelize.STRING
			},
			status: {
				type: Sequelize.ENUM('active', 'inactive'),
				defaultValue: 'active'
			},
			valid: {
				type: Sequelize.INTEGER,
				defaultValue: 0
			},
			isNewuser: {
				type: Sequelize.INTEGER,
				defaultValue: 0
			},
			attempt: {
				type: Sequelize.INTEGER,
				defaultValue: 0
			},
			verf_key: {
				type: Sequelize.STRING
			},
			companyId: {
					type: Sequelize.INTEGER
				},
			resetPassword:{
					type: Sequelize.INTEGER
			},
			otp: {
				type: Sequelize.STRING
			},
			otpExpiry: {
				type: Sequelize.DATE
			},
			createdAt: {
				allowNull: false,
				type: Sequelize.DATE
			},
			updatedAt: {
				allowNull: false,
				type: Sequelize.DATE
			},
			deletedAt: {
				type: Sequelize.DATE
			},
			loggedOutAt: {
				type: Sequelize.DATE
			}
		});
	},
	down: (queryInterface, Sequelize) => {
		return queryInterface.dropTable('Users');
	}
};