'use strict';
module.exports = {
    up: (queryInterface, Sequelize) => {
        return queryInterface.createTable('aggregateReports', {
            id: {
                allowNull: false,
                autoIncrement: true,
                primaryKey: true,
                type: Sequelize.INTEGER
            },
            reportedMailId: {
                allowNull: false,
                type: Sequelize.INTEGER
            },
            companyId: {
                allowNull: false,
                type: Sequelize.STRING
            },
            totalUrls: {
                allowNull: false,
                type: Sequelize.INTEGER,
                defaultValue: 0
            },
            totalAttachments: {
                allowNull: false,
                type: Sequelize.INTEGER,
                defaultValue: 0
            },
            spfStatus: {
                allowNull: false,
                type: Sequelize.STRING,
                defaultValue: "NA"
            },
            dkimStatus: {
                allowNull: false,
                type: Sequelize.STRING,
                defaultValue: "NA"
            },
            dmarcStatus: {
                allowNull: false,
                type: Sequelize.STRING,
                defaultValue: "NA"
            },
            totalUrlScanned: {
                allowNull: false,
                type: Sequelize.INTEGER,
                defaultValue: 0
            },
            urlVirusFound: {
                allowNull: false,
                type: Sequelize.INTEGER,
                defaultValue: 0
            },
            totalAttachmentScanned: {
                allowNull: false,
                type: Sequelize.INTEGER,
                defaultValue: 0
            },
            attachmentsVirusFound: {
                allowNull: false,
                type: Sequelize.INTEGER,
                defaultValue: 0
            },
            totalUrlScannedGctx: {
                allowNull: false,
                type: Sequelize.INTEGER,
                defaultValue: 0
            },
            urlVirusFoundGctx: {
                allowNull: false,
                type: Sequelize.INTEGER,
                defaultValue: 0
            },
            totalAttachmentScannedGctx: {
                allowNull: false,
                type: Sequelize.INTEGER,
                defaultValue: 0
            },
            attachmentVirusFoundGctx: {
                allowNull: false,
                type: Sequelize.INTEGER,
                defaultValue: 0
            },
            senderDomain: {
                allowNull: false,
                type: Sequelize.STRING
            },
            domainVirusFound: {
                allowNull: false,
                type: Sequelize.BOOLEAN,
                defaultValue: false
            },
            ipScannedGctx: {
                allowNull: false,
                type: Sequelize.STRING
            },
            ipVirusFoundGctx: {
                allowNull: false,
                type: Sequelize.BOOLEAN,
                defaultValue: false
            },
            source: {
                type: Sequelize.STRING
            },
            createdAt: {
                allowNull: false,
                type: Sequelize.DATE
            },
            updatedAt: {
                allowNull: false,
                type: Sequelize.DATE
            },
            deletedAt: {
                type: Sequelize.DATE
            }
        });
    },
    down: (queryInterface, Sequelize) => {
        return queryInterface.dropTable('aggregateReports');
    }
};