'use strict';
module.exports = {
    up: (queryInterface, Sequelize) => {
        return queryInterface.createTable('tab_aggregateReports', {
            id: {
                allowNull: false,
                autoIncrement: true,
                primaryKey: true,
                type: Sequelize.INTEGER
            },
            companyId: {
                allowNull: false,
                type: Sequelize.STRING
            },
            forDate: {
                allowNull: false,
                type: Sequelize.DATEONLY,
                defaultValue: Sequelize.NOW
            },
            source: {
                type: Sequelize.STRING
            },
            totalMails: {
                allowNull: false,
                type: Sequelize.INTEGER,
                defaultValue: 0
            },
            spfPassCount: {
                allowNull: false,
                type: Sequelize.INTEGER,
                defaultValue: 0
            },
            dkimPassCount: {
                allowNull: false,
                type: Sequelize.INTEGER,
                defaultValue: 0
            },
            dmarcPassCount: {
                allowNull: false,
                type: Sequelize.INTEGER,
                defaultValue: 0
            },
            totalUrlScanned: {
                allowNull: false,
                type: Sequelize.INTEGER,
                defaultValue: 0
            },
            urlVirusFound: {
                allowNull: false,
                type: Sequelize.INTEGER,
                defaultValue: 0
            },
            totalAttachmentScanned: {
                allowNull: false,
                type: Sequelize.INTEGER,
                defaultValue: 0
            },
            attachmentsVirusFound: {
                allowNull: false,
                type: Sequelize.INTEGER,
                defaultValue: 0
            },
            totalUrlScannedGctx: {
                allowNull: false,
                type: Sequelize.INTEGER,
                defaultValue: 0
            },
            urlVirusFoundGctx: {
                allowNull: false,
                type: Sequelize.INTEGER,
                defaultValue: 0
            },
            totalAttachmentScannedGctx: {
                allowNull: false,
                type: Sequelize.INTEGER,
                defaultValue: 0
            },
            attachmentVirusFoundGctx: {
                allowNull: false,
                type: Sequelize.INTEGER,
                defaultValue: 0
            },
            totalDomainScanned: {
                allowNull: false,
                type: Sequelize.INTEGER,
                defaultValue: 0
            },
            domainVirusFound: {
                allowNull: false,
                type: Sequelize.INTEGER,
                defaultValue: 0
            },
            totalIpScannedGctx: {
                allowNull: false,
                type: Sequelize.INTEGER,
                defaultValue: 0
            },
            ipVirusFoundGctx: {
                allowNull: false,
                type: Sequelize.INTEGER,
                defaultValue: 0
            },
            totalWhoElseCount: {
                allowNull: false,
                type: Sequelize.INTEGER,
                defaultValue: 0
            },
            deletedCountWhoElse: {
                allowNull: false,
                type: Sequelize.INTEGER,
                defaultValue: 0
            },
            createdAt: {
                allowNull: false,
                type: Sequelize.DATE
            },
            updatedAt: {
                allowNull: false,
                type: Sequelize.DATE
            },
            deletedAt: {
                type: Sequelize.DATE
            }
        }, {
            indexes: [{
                unique: false,
                fields: ['companyId', 'forDate', 'source']
            }]
        });
    },
    down: (queryInterface, Sequelize) => {
        return queryInterface.dropTable('tab_aggregateReports');
    }
};