'use strict';
module.exports = {
  up: (queryInterface, Sequelize) => {
    return queryInterface.createTable('reportedMailReportMappings', {
      id: {
        allowNull: false,
        autoIncrement: true,
        primaryKey: true,
        type: Sequelize.INTEGER
      },
      reportedMailId: {
        allowNull: false,
        type: Sequelize.INTEGER
      },
      aggregateReportId: {
        allowNull: false,
        type: Sequelize.INTEGER
      },
      createdAt: {
        allowNull: false,
        type: Sequelize.DATE
      },
      updatedAt: {
        allowNull: false,
        type: Sequelize.DATE
      },
      deletedAt: {
        type: Sequelize.DATE
      }
    }, {
      indexes: [{
        unique: true,
        fields: ['reportedMailId', 'aggregateReportId']
      }]
    });
  },
  down: (queryInterface, Sequelize) => {
    return queryInterface.dropTable('reportedMailReportMappings');
  }
};