"use strict";

var addCreatedAt = value => {
  value["createdAt"] = new Date();
  value["updatedAt"] = new Date();
};
 
module.exports = {
  up: (queryInterface, Sequelize) => {
    var data = [
      {
        name: "reported-tab-full-access",
        type: "managed"
      }, 
      {
        name: "reported-tab-read-access",
        type: "managed"
      },
      {
        name: "reported-tab-power-access",
        type: "managed"
      },
      {
        name: "gctx-tab-full-access",
        type: "managed"
      },
      {
        name: "blacklist-tab-full-access",
        type: "managed"
      },
      {
        name: "blacklist-tab-read-access",
        type: "managed"
      },
      {
        name: "blacklist-tab-power-access",
        type: "managed"
      },
      {
        name: "settings-tab-full-access",
        type: "managed"
      },
      {
        name: "settings-tab-read-access",
        type: "managed"
      },
      {
        name: "settings-tab-power-access",
        type: "managed"
      },
      {
        name: "user-full-access",
        type: "managed"
      },
      {
        name: "user-read-access",
        type: "managed"
      },
      {
        name: "user-power-access",
        type: "managed"
      },
      {
        name: "user-policy-full-access",
        type: "managed"
      },
      {
        name: "user-policy-read-access",
        type: "managed"
      },
      {
        name: "user-policy-power-access",
        type: "managed"
      },
      {
        name: "administration-full-access",
        type: "managed"
      },
  
      
    ];
    data.reduce((p, value) => {
      return addCreatedAt(value);
    }, Promise.resolve());
    return queryInterface.bulkInsert("Policies", data, {});
  },
  down: (queryInterface, Sequelize) => {
    return Promise.all([
        queryInterface.sequelize.query("SELECT `id` FROM Policies", { type: queryInterface.sequelize.QueryTypes.SELECT})
    ])
    .then(r => {
        var policyIds = [];
        for(var i=0;i<r[0].length; i++){
            policyIds.push(r[0][i].id)
        }
        return policyIds;
    })
    .then(policyIds => {
        return queryInterface.bulkDelete('Policies', {id: policyIds}, {});
    })
  }
};
