"use strict";

var addCreatedAt = value => {
  value["createdAt"] = new Date();
  value["updatedAt"] = new Date();
}; 
module.exports = {
  up: (queryInterface, Sequelize) => {
    var data = [
      {
        name:"domain-block",
        type:"write"
      },
      {
        name:"sender-block",
        type:"write"
      },
      {
        name:"mail-delete",
        type:"delete"
      },
      {
        name:"mail-recover",
        type:"write"
      },
      {
        name:"reported-mail-read",
        type:"read"
      },
      {
        name:"reported-mail-ananytics-read",
        type:"read"
      },
      {
        name:"reported-mail-header-read",
        type:"read"
      },
      {
        name:"reported-mail-body-read",
        type:"read"
      },
      {
        name:"reported-mail-link-read",
        type:"read"
      },
      {
        name:"reported-mail-attachments-read",
        type:"read"
      },
      {
        name:"reported-mail-whoelse-read",
        type:"read"
      },
      {
        name:"reported-mail-whoelse-delete",
        type:"delete"
      },
      {
        name:"reported-mail-whoelse-recover",
        type:"write"
      },
      {
        name:"reported-mail-attachment-scan",
        type:"write"
      },
      {
        name:"reported-mail-attachment-result-read",
        type:"read"
      },
      {
        name:"reported-mail-link-result-read",
        type:"read"
      },
      {
        name:"change-status-approve-declined-write",
        type:"write"
      },
      {
        name:"gctx-tab-read",
        type:"read",
      },
      {
        name:"blacklist-tab-read",
        type:"read",
      },
      {
        name:"blacklist-tab-unblock-sender-write",
        type:"write"
      },
      {
        name:"blacklist-tab-unblock-domain-write",
        type:"write"
      },
      {
        name:"settings-tab-read",
        type:"read",
      },
      {
        name:"setting-tab-update-information-wrte",
        type:"write"
      },
      {
        name:"setting-tab-change-password-write",
        type:"write",
      },
      {
        name:"setting-tab-exchange-write",
        type:"write"
      },
      {
        name: "user-write",
        type:"delete",
      },
      {
        name:"user-read",
        type:"read"
      },
      {
        name: "user-delete",
        type:"delete",
      },
      {
        name:"user-policy-write",
        type:"write",
      },
      {
        name: "user-policy-read",
        type:"read",
      },
      {
        name:"user-policy-delete",
        type:"delete",
      },
    ];
    data.reduce((p, value) => {
      return addCreatedAt(value);
    }, Promise.resolve());
    return queryInterface.bulkInsert("Actions", data, {});
  },

  down: (queryInterface, Sequelize) => {
    return Promise.all([
			queryInterface.sequelize.query("SELECT `id` FROM Actions", { type: queryInterface.sequelize.QueryTypes.SELECT})
        ])
		.then(r => {
			var actionIds = [];
			for(var i=0;i<r[0].length; i++){
				actionIds.push(r[0][i].id)
			}
			return actionIds;
		})
		.then(actionIds => {
			return queryInterface.bulkDelete('Actions', {id: actionIds}, {});
		})
  }
};