'use strict';

var getActionIds = (name, queryInterface) => {
	for (var i = 0; i < name.length; i++) {
		name[i] = '\'' + name[i] + '\'';
	}
	return queryInterface.sequelize.query("SELECT `id` FROM Actions WHERE `name` IN (" + name + ")", { type: queryInterface.sequelize.QueryTypes.SELECT });
}

var getPolicyId = (name, queryInterface) => {
	name = "\"" + name + "\"";
	return queryInterface.sequelize.query("SELECT `id` FROM Policies WHERE `name`=" + name, { type: queryInterface.sequelize.QueryTypes.SELECT });
}

var insertIntoPolicyAction = (policyName, actionName, queryInterface) => {
	return getPolicyId(policyName, queryInterface)
		.then(policyId => {
			return getActionIds(actionName, queryInterface).then(r => [r, policyId])
		})
		.then(([actionId, policyId]) => {
			var data = [];
			for (var i = 0; i < actionId.length; i++) {
				data.push({
					actionId: actionId[i].id,
					policyId: policyId[0].id,
					createdAt: new Date(),
					updatedAt: new Date(),
				})
			}
			return data;
		})
		.then(data => {
			if (data.length) return queryInterface.bulkInsert("PolicyActions", data, {});
		})
		.catch(err => {
			console.log(JSON.stringify(err));
		})
}

var policyData = {
	"reported-tab-full-access": [
		"domain-block",
		"sender-block",
		"mail-delete",
		"mail-recover",
		"reported-mail-read",
		"reported-mail-ananytics-read",
		"reported-mail-header-read",
		"reported-mail-body-read",
		"reported-mail-link-read",
		"reported-mail-attachments-read",
		"reported-mail-whoelse-read",
		"reported-mail-whoelse-delete",
		"reported-mail-whoelse-recover",
		"reported-mail-attachment-scan",
		"reported-mail-attachment-result-read",
		"reported-mail-link-result-read",
		"change-status-approve-declined-write",
	],
	"reported-tab-read-access": [
		"reported-mail-read",
		"reported-mail-ananytics-read",
		"reported-mail-header-read",
		"reported-mail-body-read",
		"reported-mail-link-read",
		"reported-mail-attachments-read",
		"reported-mail-whoelse-read",
		"reported-mail-attachment-result-read",
		"reported-mail-link-result-read",
	],
	"reported-tab-power-access": [
		"domain-block",
		"sender-block",
		"mail-recover",
		"reported-mail-read",
		"reported-mail-ananytics-read",
		"reported-mail-header-read",
		"reported-mail-body-read",
		"reported-mail-link-read",
		"reported-mail-attachments-read",
		"reported-mail-whoelse-read",
		"reported-mail-whoelse-recover",
		"reported-mail-attachment-scan",
		"reported-mail-attachment-result-read",
		"reported-mail-link-result-read",
		"change-status-approve-declined-write",
	],

	"gctx-tab-full-access": [
		"gctx-tab-read",
	],

	"blacklist-tab-full-access": [
		"blacklist-tab-read",
		"blacklist-tab-unblock-sender-write",
		"blacklist-tab-unblock-domain-write",
	],

	"blacklist-tab-read-access": [
		"blacklist-tab-read",
	],

	"blacklist-tab-power-access": [
		"blacklist-tab-read",
		"blacklist-tab-unblock-sender-write",
		"blacklist-tab-unblock-domain-write",
	],

	"settings-tab-full-access": [
		"settings-tab-read",
		"setting-tab-update-information-wrte",
		"setting-tab-change-password-write",
		"setting-tab-exchange-write",
	],
	"settings-tab-read-access": [
		"settings-tab-read",
	],

	"settings-tab-power-access": [
		"settings-tab-read",
		"setting-tab-update-information-wrte",
		"setting-tab-change-password-write",
		"setting-tab-exchange-write",
	],
	//dasdasd

	"user-full-access": [
		"user-write",
		"user-read",
		"user-policy-write",
		"user-policy-delete",
		"user-delete",
	],

	"user-read-access": [
		"user-read",
	],

	"user-power-access": [
		"user-write",
		"user-read",
		"user-policy-write"
	],

	"user-policy-full-access": [
		"user-read",
		"user-write",
		"user-policy-read",
		"user-policy-write",
		"user-policy-delete",
	],

	"user-policy-read-access": [
		"user-policy-read",
		"user-read",
	],

	"user-policy-power-access": [
		"user-policy-read",
		"user-read",
		"user-write",
		"user-policy-write",
	],

	"administration-full-access": [
		"domain-block",
		"sender-block",
		"mail-delete",
		"mail-recover",
		"reported-mail-read",
		"reported-mail-ananytics-read",
		"reported-mail-header-read",
		"reported-mail-body-read",
		"reported-mail-link-read",
		"reported-mail-attachments-read",
		"reported-mail-whoelse-read",
		"reported-mail-whoelse-delete",
		"reported-mail-whoelse-recover",
		"reported-mail-attachment-scan",
		"reported-mail-attachment-result-read",
		"reported-mail-link-result-read",
		"change-status-approve-declined-write",
		"gctx-tab-read",
		"blacklist-tab-read",
		"blacklist-tab-unblock-sender-write",
		"blacklist-tab-unblock-domain-write",
		"settings-tab-read",
		"setting-tab-update-information-wrte",
		"setting-tab-change-password-write",
		"setting-tab-exchange-write",
		"user-write",
		"user-read",
		"user-delete",
		"user-policy-write",
		"user-policy-read",
		"user-policy-delete",
	],

}

module.exports = {
	up: (queryInterface, Sequelize) => {
		return Object.keys(policyData).reduce((p, data) => {
			return insertIntoPolicyAction(data, policyData[data], queryInterface)
		}, Promise.resolve())
	},

	down: (queryInterface, Sequelize) => {
		return Promise.all([
			queryInterface.sequelize.query("SELECT `id` FROM Policies", { type: queryInterface.sequelize.QueryTypes.SELECT })
		])
			.then(r => {
				var policyIds = [];
				for (var i = 0; i < r[0].length; i++) {
					policyIds.push(r[0][i].id)
				}
				return policyIds;
			})
			.then(policyIds => {
				return queryInterface.bulkDelete('PolicyActions', { policyId: policyIds }, {});
			})
	}
};

