import express from 'express';
import { productRouter } from './resources/product';
import { authRouter } from './resources/auth';
import { contentRouter } from './resources/content';
import { clientRouter } from './resources/client';
import { sessionRouter } from './resources/session';
import { iamRouter } from './resources/iam';
import { iamUserRouter } from './resources/iam-user';
import { actionRouter } from './resources/action';
import { inboxRouter } from './resources/inbox';
import { settingRouter } from './resources/setting';
import { homeRouter } from './resources/home';
import { dashboardRouter } from './resources/dashboard';
import { blacklistRouter } from './resources/blacklist';
import { gctxRouter } from './resources/gctx';
import { advanceSearchRouter } from './resources/advanceSearch';
import { aggregateReportRouter } from './resources/aggregateReport';
import { fcmRouter } from './resources/fcm';

export const restRouter = express.Router();
restRouter.use('/product', productRouter);
restRouter.use('/auth', authRouter);
restRouter.use('/client', clientRouter);
restRouter.use('/dashboard', dashboardRouter);
restRouter.use('/content', contentRouter);
restRouter.use('/session', sessionRouter);
restRouter.use('/iam', iamRouter);
restRouter.use('/iam-user', iamUserRouter);
restRouter.use('/action', actionRouter);
restRouter.use('/setting', settingRouter);
restRouter.use('/inbox', inboxRouter);
restRouter.use('/home', homeRouter);
restRouter.use('/blacklist', blacklistRouter);
restRouter.use('/gctx', gctxRouter);
restRouter.use('/advanceSearch', advanceSearchRouter);
restRouter.use('/aggregateReports', aggregateReportRouter);
restRouter.use('/fcm', fcmRouter);