import express from 'express';
import advanceSearchController from './advanceSearch.controller'
import { sanitize } from '../../../middleware/sanitizer';
import { jwtStrategy } from '../../../middleware/strategy';
import { validateBody, schemas } from '../../../middleware/validator';
import { userPermission } from '../../../middleware/userPermission';
import { userImplant } from '../../../middleware/auth';

export const advanceSearchRouter = express.Router();
advanceSearchRouter.route('/').post(sanitize(),jwtStrategy , validateBody(schemas.advanceScanSchemas), advanceSearchController.index_v2);
advanceSearchRouter.route('/advanceScanResponse').post(sanitize(), jwtStrategy , advanceSearchController.advanceScanResponse);
advanceSearchRouter.route('/blockSender').post(sanitize(), jwtStrategy , advanceSearchController.blockSender);
advanceSearchRouter.route('/blockDomain').post(sanitize(), jwtStrategy , advanceSearchController.blockDomain);
advanceSearchRouter.route('/deleteMail').post(sanitize(), jwtStrategy , advanceSearchController.deleteMail);
advanceSearchRouter.route('/updateToken').post(sanitize(), jwtStrategy , advanceSearchController.updateToken);
advanceSearchRouter.route('/deleteToken').post(sanitize(), jwtStrategy , advanceSearchController.deleteToken);