import express from 'express';
import aggregateReportController from './aggregateReport.controller'
import { sanitize } from '../../../middleware/sanitizer';
import { jwtStrategy } from '../../../middleware/strategy';

export const aggregateReportRouter = express.Router();
aggregateReportRouter.route('/saveReport').post(aggregateReportController.saveReport);
aggregateReportRouter.route('/mailboxAnalysis').post(jwtStrategy, aggregateReportController.mailboxAnalysis);
aggregateReportRouter.route('/dailyReports').post(jwtStrategy, aggregateReportController.dailyReports);
aggregateReportRouter.route('/headersAnalyticsCount').post(jwtStrategy, aggregateReportController.headersAnalyticsCount);
aggregateReportRouter.route('/failedHeadersMails').post(jwtStrategy, aggregateReportController.failedHeadersMails);
aggregateReportRouter.route('/scannedAttachmentsAnalysis').post(jwtStrategy, aggregateReportController.scannedAttachmentsAnalysis);
aggregateReportRouter.route('/scannedUrlsAnalysis').post(jwtStrategy, aggregateReportController.scannedUrlsAnalysis);
aggregateReportRouter.route('/gctxScannedAnalysis').post(jwtStrategy, aggregateReportController.gctxScannedItems);
aggregateReportRouter.route('/updateReport').post(aggregateReportController.updateWhoElseCount);