import express from 'express';
import blacklistController from './blacklist.controller';
import { jwtStrategy } from '../../../middleware/strategy'
import { sanitize } from '../../../middleware/sanitizer';
import { userPermission } from '../../../middleware/userPermission';

export const blacklistRouter = express.Router();

blacklistRouter.route('/').get(sanitize(), jwtStrategy ,userPermission('blacklist-tab-read'),blacklistController.index);
blacklistRouter.route('/unBlockSender').post(sanitize(), jwtStrategy ,userPermission('blacklist-tab-unblock-sender-write'),blacklistController.unBlockSender);
blacklistRouter.route('/unBlockDomain').post(sanitize(), jwtStrategy ,userPermission('blacklist-tab-unblock-domain-write'),blacklistController.unBlockDomain);
