import { db } from '../../../models';
function makeid() {
    var result = '', characters = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789', charactersLength = 62;
    for ( var i = 0; i < 35; i++ ) { result += characters.charAt(Math.floor(Math.random() * charactersLength)) }
    return result;
    }

export default {
    async index(req, res, next) {
        db.Client.findAll({ attributes: ['id','name', 'logo', 'key', 'url', 'status'] })
        .then(client => {
            if (client)
                return res.status(200).json({ data:client })
        })
        .catch(err => {
            next(err)
        })
    },
    async store(req, res, next) {
        var {  name , url, key, logo, logo_name } = req.body;
        var code = key.replace(/\s/g,'-').toLowerCase();
        var keyCount = 0;
        db.Client.count({ where : { key : key } }).then(r => {
             keyCount = r;
             return db.Client.findOne({ where : { code : code } })
        })       
        .then(client=>{
            if(keyCount > 0) 
                keyCount = keyCount + 1;
            if(client)
                code = code+'-'+keyCount;
            return db.Client.create({ name , code , key , url , logo , logo_name})
        })
        .then(client=>{
            if(client) return res.status(200).json({ success : 'Client Created Successfully !' });
            else throw new RequestError('Error creating client!');
        })
        .catch(err=>{
            next(err);
        })
    },
    async statusUpdate(req, res, next) {
        var { id } = req.params;
        db.Client.findOne({ where : { id : id } })
        .then(client=>{
            if(client){
                if(client.status == 'active')
                   var status = 'inactive';
                if(client.status == 'inactive')
                   var status = 'active';
                return db.Client.update({status : status}, {where: {id: id} })
            }
            throw new RequestError("Client Not exists.")
        })
        .then(client=>{
            res.status(200).json({ success : 1})
        })
        .catch(e=>{
            next(e);
        })
    },
    async fetch(req, res, next) {
        var { id } = req.params;
        db.Client.findOne({ where : { id : id } })
        .then(client=>{
            if(client) return res.status(200).json({ success : 1 }); 
            throw new RequestError("Client already exists.")
        })
        .catch(e=>{
            next(e);
        })
    },
    async update(req, res, next) {
        var body = req.body;
        var {  name , url, logo } = req.body;
        if(req.file){
            var logo = req.file.filename;
            var logo_name = req.file.originalname;
        }
        if(Object.keys(body).length > 0){
            db.Client.findOne({ where: { id:body.clientId } })
            .then(checkClient => {
                if(checkClient){
                    return db.Client.update({ name , url , logo ,logo_name},{where : {id : body.clientId}})
                }else throw new RequestError('Failed To Update');
            })
            .then(client => {
                if(client)
                    return res.status(200).json({'client': 'Client is successfully updated!'});
                else throw new RequestError('Error updating client!');
            })
            .catch(err => {
                next(err)
            })
        }else next(new RequestError('Invalid data received!'));
    },
    async action(req, res, next) {
        if(req.params.id > 0){
            db.Product.count()
            .then(product => {
                return db.Client.findOne({ include : [{model : db.ClientProduct, include : [{model : db.Product}]}],where: { id: req.params.id } , attributes: ['name', 'logo', 'key', 'url', 'logo_name','status'] }).then(client => [client, product])
           })  
            .then(([client, product]) => {       
                if(client){
                    return res.status(200).json( ({'success' : client , 'productCount' : product}) );
                }else throw new RequestError('Client doesn\'t exists!');
            })
            .catch(err => {
                next(err)
            });
        }else next(new RequestError('Invalid data received!'));
    },
    async productList(req, res, next){
       db.Product.findAll()
       .then(product => {
          if(product)
                return res.status(200).json({'products' : product}); 
            else throw new RequestError('No Product Found');
       })
       .catch(err => {
           next(err)
       });
    },
    async clientList(req, res, next){
        db.Product.findAll()
        .then(product=> {
            if(product)
                return db.Client.findAll({attributes : ['id', 'name']}, {where : {status : 'active'}}).then(client => [client , product])
            else throw new RequestError('No Product Found');
        })
        .then(([client,product]) => {
            if(client)
                return res.status(200).json({'clients' : client, 'product' : product});
            else throw new RequestError('No Client Found');
        })

    },
    async productDetail(req, res, next){
        var productKey = makeid();
        db.ClientProduct.findOne({where : {clientId : req.params.clientId , productId : req.params.productId}})
        .then(productCheck => {
            if(!productCheck)
                return db.ClientProduct.create({"clientId" : req.params.clientId , "productId" : req.params.productId , "productKey" : productKey})
            else              
                return db.ClientProduct.findOne({where : {clientId : req.params.clientId , productId : req.params.productId}})
        })
        .then(ClientProduct => {
            if(ClientProduct)
                return db.ClientProduct.findOne({
                    include : [{model: db.Client}, {model: db.Product} ],
                    where : {id : ClientProduct.id}
                });
            else
                throw new RequestError('Client Data Not Found');``
        })
       .then(client =>{
           if(client)
                return res.status(200).json({"data" : client});
            else  throw new RequestError('No Data Found');                   
       })
       .catch(err => {
           next(err);
       });
    },
    async updateClientProduct(req, res, next){
        db.ClientProduct.findOne({where : {url : req.body.url}})
        .then(urlExist => {
            if(!urlExist)
                return db.ClientProduct.update({url : req.body.url , setting : req.body.settings},{where : {id : req.body.clientProductId }})
            else
                throw new RequestError('URL already exist');
        })
        .then(clientProduct => {
            if(clientProduct)
                return res.status(200).json({'data' : 'Product Created'});
            else
                throw new RequestError('Failed To create !');
        })
        .catch(err => {
            next(err);
        });

    }
}; 
