import { db } from '../../../models';
import config from '../../../config';
// import S3_bucket from '../../../LMSlicence/S3_bucket';


export default {
    async index(req, res, next) {
        var condition = {}, query = req.query.filterData;
        if(query){
            if(query.clientId) condition['clientId'] = query.clientId;
            if(query.productId) condition['productId'] = query.productId;
            if(query.type) condition['type'] = query.type;
        }
        db.Content.findAll({where: condition,  attributes: ['id','name', 'thumbnail', 'content', 'type'] })
        .then(content => {
            if(content)
                return res.status(200).json({data : content});
            else throw new RequestError('Error fetching content!');
        })
        .catch(err => {
            next(err)
        })
    },
    async getFile(req, res, next){
        var data = S3_bucket.getFromS3('videos', '1580540042599.mp4');
        data.then(r => {
            data = r;
            res.status(200).json({success: true, file: data});
        })
    },
    async store(req, res, next) {
        console.log(req.files.thumbnail[0])
        console.log(req.files.thumbnail[0].filename);
        console.log(req.files.thumbnail[0].mimetype);
       // console.log();
        return false;
       // res.status(200).json({data: JSON.stringify(S3_bucket.getFromS3('videos/1580475613942.mp4'))});
        var {  name , clientId, productId, content, type, duration ,filename } = req.body;
        var thumbnail = null;
        var clientProductId = null;
        if(req.body.clientId != ' ' && req.body.productId != ' '){
            db.ClientProduct.findOne({where : {clientId : req.body.clientId, productId : req.body.productId}})
            .then(clientProduct => {
                clientProductId = clientProduct.id;
            });
        }
        var clientId = (req.body.clientId == ' ' ? null : req.body.clientId);
        var productId = (req.body.clientId == ' ' ? null : req.body.productId);
        db.Content.findOne({ where: { name: req.body.name} })
        .then(checkContent => {
            if(!checkContent){
                var file =  req.files.file[0].filename;
                var filename =  req.files.file[0].originalname;
                var thumbnail =  (req.files.thumbnail ? req.files.thumbnail[0].filename : null );                       
                return db.Content.create({name , clientId, productId, clientProductId, content , type, duration,file,  filename,thumbnail})
                .then(content => {                        
                    if(req.body.type == 'Video'){
                        if(req.files.file)
                            S3_bucket.uploadToS3('videos', req.files.file[0].path, req.files.file[0].filename);
                        if(req.files.thumbnail)
                            S3_bucket.uploadToS3('thumbnails', req.files.thumbnail[0].path, req.files.thumbnail[0].filename);
                    } 
                    if(req.body.type == 'Pdf'){
                        if(req.files.file) 
                            S3_bucket.uploadToS3('pdf', req.files.file[0].path, req.files.file[0].filename);
                    } 
                });
            }else throw new RequestError('Content name already exists!');
        })
        .then(content => {
            return res.status(200).json({'content': 'Content successfully added!'});
        })
        .catch(err => {
            next(err)
        })
    },
    async clientProductsList(req, res, next){
        if(req.query.clientId){
            db.ClientProduct.findAll({include: [{model : db.Product}], where : {clientId : req.query.clientId}})
            .then(products => {
                if(products)
                    return res.status(200).json({'products' : products});
                else  throw new RequestError('No Product Found');
            })
        }else{
            db.Product.findAll()
            .then(products => {
                if(products)
                    return res.status(200).json({'products' : products});
                else  throw new RequestError('No Product Found');

            })
        }
    },
    async fetch(req, res, next) {
        if(req.params.id > 0){
            db.Content.findOne({ where: { id: req.params.id} })
            .then(content => {
                if(content)
                    return res.status(200).json({'content': content});
                else throw new RequestError('Content doesn\'t exists!');
            })
            .catch(err => {
                next(err)
            });
        }else next(new RequestError('Invalid data received!'));
    },

    async update(req, res, next) {
        var body = req.body;
        var {  name , clientId, content, type, duration ,filename } = req.body;
        var clientProductId = null;
        if(req.file){
            var thumbnail = req.file.filename;
            var filename = req.file.originalname;
        }
        if(req.body.clientId != ' ' && req.body.productId != ' '){
            db.ClientProduct.findOne({where : {clientId : req.body.clientId, productId : req.body.productId}})
            .then(clientProduct => {
                clientProductId = (clientProduct ? clientProduct.id : null);
            });
        }
        var clientId = (req.body.clientId == ' ' ? null : req.body.clientId);
        var productId = (req.body.clientId == ' ' ? null : req.body.productId);
        db.Content.findOne({ where: { id:body.contentId } })            
        .then(checkId => {
            if(checkId){
                return db.Content.update({  name , clientId, productId, clientProductId, content, type, duration ,filename, thumbnail }, {where: {id: body.contentId} });
            }else throw new RequestError('Product with same name already exists!');
        })
        .then(content => {
            if(content)
                return res.status(200).json({'content': 'Content is successfully updated!'});
            else throw new RequestError('Error updating content!');
        })
        .catch(err => {
            next(err)
        })
    },

    async action(req, res, next) {
            db.Content.findOne({ where: { id: req.params.id} })
            .then(content => {
                if(content){
                    return res.status(200).json({'content': content});
                }else throw new RequestError('Content doesn\'t exists!');
            })
            .catch(err => {
                next(err)
            });
    },
}; 
