import express from 'express';
import dashboardController from './dashboard.controller';
import { jwtStrategy } from '../../../middleware/strategy';
import { userPermission } from '../../../middleware/userPermission';
import { userImplant } from '../../../middleware/auth';

export const dashboardRouter = express.Router();
dashboardRouter.route('/updateFcmToken').get(jwtStrategy, dashboardController.updateFcmToken);
dashboardRouter.route('/totalReport').get(jwtStrategy, dashboardController.totalReport);
dashboardRouter.route('/pendingCount').get(jwtStrategy, dashboardController.pendingCount);
dashboardRouter.route('/topReportedMail').get(jwtStrategy, dashboardController.topReportedMail);
dashboardRouter.route('/approveReport').get(jwtStrategy, dashboardController.approveReport);
dashboardRouter.route('/declinedReport').get(jwtStrategy, dashboardController.declinedReport);
dashboardRouter.route('/spamOrHamp').get(jwtStrategy, dashboardController.spamOrHamp);
dashboardRouter.route('/monthReport').get(jwtStrategy, dashboardController.monthReport);
dashboardRouter.route('/recentReportedMails').get(jwtStrategy, userImplant, dashboardController.recentReportedMails);
dashboardRouter.route('/getsignature').post(jwtStrategy, dashboardController.getImageSignature);