import { db } from '../../../models';
import config from '../../../config';
import FCM1 from 'fcm-node';

var fcm1 = new FCM1(config.fcm.fcmServerKey);

function sendFcm(payload, fcmKey) {
    var message = {
        to: fcmKey,
        data: {
            payload
        },
        priority: 'high',
        time_to_live: 2419200
    };

    fcm1.send(message, function(err, response) {
        console.log("Err, response", err, response);
    });
}

export default {
    async newMailReportedFcm(req, res, next) {
        console.log("Inside newMailReportedFcm", req.query);
        res.send("Success");
        db.Company.findOne({ attributes: ['id'], where: { alias: req.query.companyCode } })
            .then(r => {
                return db.User.findOne({ attributes: ['fcmKey'], where: { companyId: r.id } })
            }).then(r => {
                console.log("Fcm key is", JSON.parse(JSON.stringify(r)));
                sendFcm({ "notificationTitle": "New Phishing Mail Reported", "message": req.query.from + " is reported by " + req.query.to }, r.fcmKey);
            })
    },

    async outlookLoginSuccess(req, res, next) {
        console.log("Request", req.query)
        db.Company.findOne({ attributes: ['id'], where: { alias: req.query.companyCode } })
            .then(r => {
                return db.User.findOne({ attributes: ['fcmKey'], where: { companyId: r.id } })
            }).then(r => {
                console.log("Fcm key is", JSON.parse(JSON.stringify(r)));
                sendFcm({ "notificationTitle": "Login success", "message": "Successfully logged in to outlook" }, r.fcmKey);
            })
        res.send("Success");
    }
}