import { db } from '../../../models';
import {Tab}  from '../../../modules/Tab';
import { findEmails } from '../../../functions';

export default {
    async index(req, res, next) {
        var tab = new Tab();
        db.Company.findOne({where : { id :  req.user.companyId }})
        .then(company=>{
            if(company)return tab.listInbox({ companyCode : company.alias }).then(r=>r.mails)
            else throw new RequestError('Server error!');
        })
        .then(inbox => {
            if (inbox){
                var totalReport = inbox.length;
                let uniqueReport =new Set();
                let approvedReport =new Set();
                let totalReporter =new Set();
                let reporters =  {};
                let approvedReporters = { };
                inbox.reduce((p, a) => {
                    if (a.approvedBy) { approvedReport.add(a.approvedBy) }
                    if (a.Header.reciever && JSON.parse(a.Header.reciever) && JSON.parse(a.Header.reciever)['0'] && findEmails(JSON.parse(a.Header.reciever)['0']).length) {
                        var email = findEmails(JSON.parse(a.Header.reciever)['0'])[0];
                        totalReporter.add(email);
                        if (!reporters[email]) reporters[email] = 1;
                        else {
                        reporters[email] += reporters[email];
                        }
                        if (a.approvedBy) {
                            if(!approvedReporters[email]) approvedReporters[email] = 1;
                            else approvedReporters[email] += approvedReporters[email];
                        }
                    }
                }, Promise.resolve())
                var sortable = [];
                for (var reporter in reporters) {
                    sortable.push([reporter, reporters[reporter] , approvedReporters[reporter]  ]);
                }
                sortable.sort(function (a, b) {
                    return a[1] - b[1];
                });
                 return res.status(200).json({'uniqueReport': totalReport ,'totalReport' : totalReport ,'approvedReport' : approvedReport.size , 'totalReporter' : totalReporter.size ,"reporter" : sortable  })}
            else throw new RequestError('Server error!');
        })
        .catch(err => {
            console.log("index -> err", err)
            next(err)
        })
    },
}; 
