import { db } from '../../../models';

export default {
    async index(req, res, next) {
        db.Policy.findAll({ where: { type: "managed" } })
            .then(re => {
                if (re) return db.Policy.findAll({ where: { type: "custom", companyId: req.user.companyId, deletedAt: null } }, { paranoid: true }).then(r => [r, re])
                throw new RequestError("Something is Wrong !", 500);
            })
            .then(async ([managed, custom]) => {
                if (managed || custom) {
                    for (var i = 0; i < custom.length; i++) {
                        await managed.push(custom[i]);
                    }
                    return res.status(200).json({ 'data': managed });
                }
                throw new RequestError("Something is Wrong !", 500);
            }).catch(err => {
                next(err);
            });
    },
    async addPolicy(req, res, next) {
        var policy = req.body.policyName;
        var description = req.body.description;
        var action = req.body.action;
        return db.Policy.create({ name: policy, type: "custom", description: description, companyId: req.user.companyId })
            .then(r => {
                if (r) {
                    var data = [];
                    for (var i = 0; i < action.length; i++) {
                        data.push({
                            actionId: action[i],
                            policyId: r.id
                        })
                    }
                    return db.PolicyAction.bulkCreate(data);
                }
                throw new RequestError("Server Error!", 500);

            })
            .then(p => {
                if (p) {
                    return res.status(200).json({ 'status': "true" });
                }
                throw new RequestError("Server Error !", 500);

            })
            .catch(err => {
                next(err);
            });

    },
    async showPolicy(req, res, next) {
        db.Policy.findOne({
            where: { id: req.params.policyId, type: "managed" }
        })
            .then(policies => {
                return db.Policy.findOne({ where: { id: req.params.policyId, companyId: req.user.companyId } }).then(r => [r, policies])
            })
            .then(([managed, custom]) => {
                if (managed) {
                    return res.status(200).json({ policy: managed });
                }
                else if (custom) {
                    return res.status(200).json({ policy: custom });
                }
                throw new RequestError("Server error !", 500);
            })
            .catch(err => {
                next(err);
            });
    },
    async updatePolicy(req, res, next) {
        var policy = req.body.policyName;
        var { action, description } = req.body;
        var policyId = req.body.policyId;
        return db.Policy.update({ name: policy, description: description }, { where: { id: policyId, type: "custom", companyId: req.user.companyId } })
            .then(r => {
                if (r) {
                    return db.Action.findAll({ where: { id: action } })
                }
                throw new RequestError("Unauthorized !", 401);
            })
            .then(dis => {
                if (dis) {
                    return db.PolicyAction.destroy({ where: { policyId: policyId } }).then(r => [r, dis])
                }
                throw new RequestError("Server error !");
            })
            .then(([r, list]) => {
                0
                var policyActionMap = [];
                for (var i = 0; i < list.length; i++) {
                    policyActionMap.push({
                        actionId: list[i].id,
                        policyId: policyId
                    })
                }
                return db.PolicyAction.bulkCreate(policyActionMap);
            })
            .then(p => {
                if (p) {
                    return res.status(200).json({ 'status': "true" });
                } else {
                    throw new RequestError("Something is Wrong !", 500);
                }
            })
            .catch(err => {
                console.log(err);
                next(err)
            });
    },
    async policyDelete(req, res, next) {
        var date = new Date();
        return db.Policy.findOne({ where: { id: req.params.policyId } })
            .then(re => {
                if (re.type == 'custom') {
                    return db.Policy.destroy({ where: { id: req.params.policyId, type: "custom" } })
                }
                else {
                    throw new RequestError("You Have been Denied Delete Permisssion Manage Type", 500);
                }
            })
            .then(policy => {
                return db.UserPolicy.findAll({ where: { policyId: req.params.policyId } })

            })
            .then(list => {
                return list.reduce((p, data) => {
                    return db.UserPolicy.update({ deletedAt: date }, { where: { id: data.id } })
                }, Promise.resolve())
            })

            .then(del => {
                return res.status(200).json({ 'status': "Sucessfully Delete" });
            })
            .catch(err => {
                console.log(err);
                next(err)
            });
    },
    async policyUserCount(req, res, next) {
        console.log("Inside policyUserCount", req.params.policyId)
        db.UserPolicy.count({
            attributes: [db.Sequelize.literal('COUNT(DISTINCT(UserId))'), 'UserId'],
            where: { policyId: req.params.policyId, },
            group: ['UserID']
        })
            .then(re => {
                return res.status(200).json({ 'count': re });
            })
            .catch(err => {
                next(err)
            });
    }
};