import express from 'express';
import iamController from './iam.controller';
import { jwtStrategy } from '../../../middleware/strategy';
import {validateBody, schemas} from '../../../middleware/validator'
import { userPermission } from '../../../middleware/userPermission';

export const iamRouter = express.Router();
iamRouter.route('/list').get(jwtStrategy,userPermission('policy-read'),iamController.index);
iamRouter.route('/add').post(jwtStrategy,validateBody(schemas.createPolicy),userPermission('policy-write'),iamController.addPolicy);
iamRouter.route('/update').patch(jwtStrategy,validateBody(schemas.updatePolicy),userPermission('policy-write'),iamController.updatePolicy);
iamRouter.route('/show/:policyId').get(jwtStrategy,userPermission('policy-read'),iamController.showPolicy);
iamRouter.route('/delete/:policyId').get(jwtStrategy,userPermission('policy-delete'),iamController.policyDelete);
iamRouter.route('/count/:policyId').get(jwtStrategy,userPermission('policy-read'),iamController.policyUserCount);

