import { db } from '../../../models';

export default {
    async index(req, res, next) {
        db.Product.findAll()
            .then(product => {
                if (product.length >= 0)
                    return res.status(200).json({ 'product': product });
                else throw new RequestError('Error fetching products!');
            })
            .catch(err => {
                next(err)
            })
    },

    async store(req, res, next) {
        var body = req.body;
        db.Product.findOne({ where: { name: body.name } })
            .then(checkProduct => {
                if (!checkProduct) {
                    return db.Product.create(body);
                } else throw new RequestError('Product name already exists!');
            })
            .then(product => {
                if (product)
                    return res.status(200).json({ 'product': 'Product is successfully added!' });
                else throw new RequestError('Error creating product!');
            })
            .catch(err => {
                next(err)
            })
    },

    async fetch(req, res, next) {
        if (req.params.id > 0) {
            db.Product.findOne({ where: { id: req.params.id } })
                .then(product => {
                    if (product)
                        return res.status(200).json({ 'product': product });
                    else throw new RequestError('Product doesn\'t exists!');
                })
                .catch(err => {
                    next(err)
                });
        } else next(new RequestError('Invalid data received!'));
    },

    async update(req, res, next) {
        var body = req.body;
        if (Object.keys(body).length > 0) {
            db.Product.findOne({ where: { id: body.productId } })
                .then(checkProduct => {
                    if (checkProduct) {
                        return db.Product.findOne({ where: { name: body.name, id: { $not: body.productId } } });
                    } else throw new RequestError('Product doesn\'t exists!');
                })
                .then(checkPname => {
                    if (!checkPname) {
                        return db.Product.update(body, { where: { id: body.productId } });
                    } else throw new RequestError('Product with same name already exists!');
                })
                .then(product => {
                    if (product)
                        return res.status(200).json({ 'product': 'Product is successfully updated!' });
                    else throw new RequestError('Error updating product!');
                })
                .catch(err => {
                    next(err)
                })
        } else next(new RequestError('Invalid data received!'));
    },

    async action(req, res, next) {
        if (req.params.id > 0 && req.query.type) {
            db.Product.findOne({ where: { id: req.params.id } })
                .then(product => {
                    if (product) {
                        // console.log(req.query.type);
                        return res.status(200).json({ 'product': product });
                    } else throw new RequestError('Product doesn\'t exists!');
                })
                .catch(err => {
                    next(err)
                });
        } else next(new RequestError('Invalid data received!'));
    },
    async metaAuths(req, res, next) {
        console.log("Inside metaAuths", req.body)
        return db.Company.findOne({ where: { alias: req.body.companyCode } })
            .then(r => {
                console.log("r is", JSON.parse(JSON.stringify(r)))
                return r;
            }).then(r => {
                if (r && r.id) {
                    return db.MetaAuth.findAll({ where: { $or: [{ key: 'userName' }, { key: 'password' }], companyId: r.id } })
                        .then(r1 => {
                            console.log("Meta auths", JSON.parse(JSON.stringify(r1)));
                            return res.send(r1);
                        })
                } else {
                    return res.send({});
                }
            })
    }
};
