import express from 'express';
import productController from './product.controller';
import { sanitize } from '../../../middleware/sanitizer';
import { jwtStrategy } from '../../../middleware/strategy'

export const productRouter = express.Router();
productRouter.route('/').get(sanitize(), productController.index);
productRouter.route('/').post(sanitize(), productController.store);
productRouter.route('/edit/:id').get(sanitize(), productController.fetch);
productRouter.route('/').patch(sanitize(), productController.update);
productRouter.route('/:id').get(sanitize(), productController.action);
productRouter.route('/metaAuths').post(sanitize(), productController.metaAuths);