import { db } from '../../../models';
function makeid() {
    var result = '', characters = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789', charactersLength = 62;
    for ( var i = 0; i < 35; i++ ) { result += characters.charAt(Math.floor(Math.random() * charactersLength)) }
    return result;
}


export default {
    async index(req,res,next){
        db.ClientProduct.findOne({where : {productKey : req.body.clientKey}})
        .then(contentProduct => {
            if(contentProduct){
                var users=req.body.users;
                var sessionkey = [];//['WS2MXPB9zf9oOu80iGOmtlzZSyBZYumWKqz', 'lcJBHWJnKCZhZ5n5pULtFVbhH7IlplwXyjY'];
                var sessionData = [];
                for(var i=0;i<req.body.users.length;i++){
                     sessionkey[i] = makeid();
                     var user = req.body.users[i];
                     if(user.first_name && user.last_name && user.email){
                         sessionData.push({
                             clientId: contentProduct.clientId,
                             productId: contentProduct.productId,
                             code: sessionkey[i],
                             expiry: req.body.expiry,
                             duration: null
                         })
                         users[i]['key'] = sessionkey[i];
                     }
                }               
                db.Session.findAll({where : {code :{$in : sessionkey}}}).then(r => {
                    for(var j = 0;j < r.length;j++){
                        if(sessionkey.indexOf(r[j].code)>=0) sessionData[sessionkey.indexOf(r[j].code)] = makeid();                        
                    }             
                }).then(session => {
                    db.Session.bulkCreate(sessionData).then(session => {
                        return res.status(200).json({"data" : users});
                    })
                })   

            }else throw new RequestError('Client Key does not exist');

        })
    },
    async contentTracking(req,res,next){
        var clientId = null;
       db.ClientProduct.findOne({where : {productKey : req.body.clientKey}})
        .then(clientproduct => {             
            if(clientproduct){
                clientId = clientproduct.clientId;
                return db.Session.findOne({where : {code : req.body.sessionKey}}).then(session =>[clientproduct, session])
            }
            else throw new RequestError('Client key not exist');
        })
        .then(([clientproduct, session]) => {           
            if(session){
                return db.Content.findAll({
                    attributes: ['id', 'clientId', 'productId', [db.sequelize.fn('SUM', db.sequelize.col('Content.duration')), 'duration']],
                    where : {clientId : clientproduct.clientId, productId : clientproduct.productId}
                }).then(content => [content,session])            }

            else throw new RequestError('Session key not exist');
        })
        .then(([content, session]) => {            if(content)
              return  db.ContentTracking.findOne({where : {clientId : clientId, contentId : req.body.contentId}}).then(contentTracking =>[content, contentTracking, session])         
        })
        .then(([content,contentTracking,session]) => {
            var percentage =  (req.body.duration / content[0].duration) * 100;
            if(contentTracking && contentTracking.duration < req.body.duration){
                return db.ContentTracking.update({duration: req.body.duration,percentage : percentage}, {where: {id: contentTracking.id}})
                .then(r => {
                    return db.Session.update({duration: req.body.duration},{where : {clientId : content.clinetId, productId : content[0].productId}}); 
                })
            }
            else if(!contentTracking)
                return db.ContentTracking.create({'clientId' : content[0].clientId ,'sessionId' : session.id, 'contentId' : req.body.contentId, 'duration': req.body.duration, 'percentage' : percentage})
        })
        .then(r => {
            res.status(200).json({success: true, data: r});
        })

    },
};