import Blowfish from 'egoroof-blowfish';
var bf = new Blowfish(toString(process.env.APP_SECRET), Blowfish.MODE.ECB, Blowfish.PADDING.NULL);
const fromHexString = hexString => new Uint8Array(hexString.match(/.{1,2}/g).map(byte => parseInt(byte, 16)));

export var randomString = (len, charSet) => {
    charSet = charSet || 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789';
    var randomString = '';
    for (var i = 0; i < len; i++) {
        var randomPoz = Math.floor(Math.random() * charSet.length);
        randomString += charSet.substring(randomPoz, randomPoz + 1);
    }
    return randomString;
}
export var validateMetaKeys = (user) => {
    var x = {};
    try {
        if (user && user.Company && user.Company.MetaAuths && user.Company.MetaAuths.length) {
            user.Company.MetaAuths.reduce((p, a) => {
                if (a.key == "password") {
                    var password = bf.decode(fromHexString(a.value));
                    x[a.key] = password.toString();
                }
                else x[a.key] = a.value.toString();
            }, Promise.resolve())
            return x;
        }
    }
    catch {
        return null
    }
}
export var validateEmail = function (email) {
    var re = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
    return re.test(String(email).toLowerCase());
}

export function secondsToTime(secs) {
    var hours = Math.floor(secs / (60 * 60));

    var divisor_for_minutes = secs % (60 * 60);
    var minutes = Math.floor(divisor_for_minutes / 60);

    var divisor_for_seconds = divisor_for_minutes % 60;
    var seconds = Math.ceil(divisor_for_seconds);

    return hours.pad() + ":" + minutes.pad() + ":" + seconds.pad();
}

export function getDomainName(hostname) {
    var domain = hostname;
    if (hostname != null) {
        var parts = hostname.split('.').reverse();

        if (parts != null && parts.length > 1) {
            domain = parts[1] + '.' + parts[0];

            if (hostname.toLowerCase().indexOf('.co.uk') != -1 && parts.length > 2) {
                domain = parts[2] + '.' + domain;
            }
        }
    }
    return domain;
}

export function generateQueryString(data) {
    let keys = Object.keys(data);
    let values = [];
    for (var i = 0; i < keys.length; i++) {
        values.push(keys[i] + '=' + data[keys[i]]);
    }
    return values.join('&');
}

global.json = (obj) => {
    return JSON.parse(JSON.stringify(obj))
}

global.isJson = (str) => {
    try {
        JSON.parse(str);
    } catch (e) {
        return false;
    }
    return true;
}

export function findEmails(string) {
    var wordArray = string.split(" ");
    var result = [];
    wordArray.forEach(function (word) {
        if (word.match(/[@]/) !== null) {
            if (word[word.length - 1].match(/[,:;.!?]/)) {
                word = word.slice(0, -1);
            }

            if (validateEmail(word)) {
                result.push(word);
            }
        }
    });
    return result;
}