import nodemailer from 'nodemailer';
import config from './config';
import { db } from './models';

export default {

    sendNewUserLink: (email, password) => {
        return new Promise((resolve, reject) => {
            try {
                // db.User.findOne({where: {email: email}})
                // .then((user) => {console.log(JSON.stringify(user))
                //     if(user){
                // if(user.valid == 0){
                var smtpTransport = nodemailer.createTransport({
                    host: config.mail.host,
                    port: config.mail.port,
                    auth: {
                        user: config.mail.username,
                        pass: config.mail.password
                    },
                    tls: { rejectUnauthorized: false },
                });
                smtpTransport.sendMail({
                    from: config.mail.from,
                    to: email,
                    subject: 'KDMARC OTP',
                    html: "Hi <br>" + "Your One Time Password(OTP) for completing your registeration on KDMARC is  " + password + " expires  in 10 minutes .Please do not share OTP with anyone .<br> Best Regards, <br> Team KDMARC",
                }, function (error, info) {
                    if (error) {
                        return reject({
                            name: "PRAException",
                            msg: 'Email Sending Failed'
                        })
                    }
                    return resolve(true)
                });

                // }
                //     }else throw {
                //         name: "PRAException",
                //         msg: 'Email Body not available'
                //     }
                // })
            } catch (err) {
                console.log(err)
                reject(err);
            }
        });
    },
    sendDomain: (data, detail, email) => {
        data.details = JSON.stringify(data.details);
        return new Promise((resolve, reject) => {
            try {
                var value = '';
                for (var i = 0; i < 5; i++) {
                    value += '<tr><td></td><td></td></tr>';
                }
                Object.keys(data.details).forEach(key => {
                    Object.keys(data.details[key]).forEach(key1 => {
                        if (key != 'info')
                            value += '<tr><td>' + key1 + '</td><td>' + data.details[key][key1] + '</td></tr>'
                    })
                })
                Object.keys(detail).forEach(key => {
                    value += '<tr><td>' + key + '</td><td>' + JSON.stringify(detail[key]) + '</td></tr>';
                })
                var html = '<!DOCTYPE html> <html> <body> <label>Firstname:</label> <span>' + (data.firstname ? data.firstname : '') + '</span> <br> <label>Lastname:</label> <span>' + (data.lastname ? data.lastname : '') + '</span> <br> <label>Email:</label> <span>' + data.email + '</span> <br> <label>Source:</label> <span>' + data.source + '</span> <br> <label>Details:</label> <br> <table> ' + value + '</table> </body> </html>'

                var smtpTransport = nodemailer.createTransport({
                    host: config.mail.host,
                    port: config.mail.port,
                    auth: {
                        user: config.mail.username,
                        pass: config.mail.password
                    },
                    tls: { rejectUnauthorized: false },
                });
                //console.log(smtpTransport)
                smtpTransport.sendMail({
                    from: config.mail.from,
                    to: email,
                    subject: "New Lead reported",
                    html: html
                }, function (error, info) {
                    if (error) {
                        return reject({
                            name: "PRAException",
                            msg: 'Email Sending Failed'
                        })
                    }
                    return resolve(true)
                })
            } catch (err) {
                resolve(true);
            }
        });
    },
    sendRegisterationLink: (email, companyKey) => {
        return new Promise((resolve, reject) => {
            try {
                db.User.findOne({ where: { email: email } })
                    .then((user) => {
                        console.log("User found", JSON.parse(JSON.stringify(user)));
                        if (user) {
                            if (user.valid == 0) {
                                var key = Math.random().toString(36).slice(2);
                                db.User.update({ verf_key: key }, { where: { id: user.id } })
                                    .then(r => {
                                        var smtpTransport = nodemailer.createTransport({
                                            host: config.mail.host,
                                            port: config.mail.port,
                                            auth: {
                                                user: config.mail.username,
                                                pass: config.mail.password
                                            },
                                            tls: { rejectUnauthorized: false },
                                        });
                                        smtpTransport.sendMail({
                                            from: config.mail.from,
                                            to: email,
                                            subject: 'Verify Your Account',
                                            html: '<!doctype html> <html> <head> <style> /* ------------------------------------- GLOBAL RESETS ------------------------------------- */ img { border: none; -ms-interpolation-mode: bicubic; max-width: 100%; } body { background-color: #f6f6f6; font-family: sans-serif; -webkit-font-smoothing: antialiased; font-size: 14px; line-height: 1.4; margin: 0; padding: 0; -ms-text-size-adjust: 100%; -webkit-text-size-adjust: 100%; } table { border-collapse: separate; mso-table-lspace: 0pt; mso-table-rspace: 0pt; width: 100%; } table td { font-family: sans-serif; font-size: 14px; vertical-align: top; } /* ------------------------------------- BODY & CONTAINER ------------------------------------- */ .body { background-color: #f6f6f6; width: 100%; } /* Set a max-width, and make it display as block so it will automatically stretch to that width, but will also shrink down on a phone or something */ .container { display: block; Margin: 0 auto !important; /* makes it centered */ max-width: 580px; padding: 10px; width: 580px; } /* This should also be a block element, so that it will fill 100% of the .container */ .content { box-sizing: border-box; display: block; Margin: 0 auto; max-width: 580px; padding: 10px; } /* ------------------------------------- HEADER, FOOTER, MAIN ------------------------------------- */ .main { background: #fff; border-radius: 3px; width: 100%; } .wrapper { box-sizing: border-box; padding: 20px; text-align: center; } .footer { clear: both; padding-top: 10px; text-align: center; width: 100%; } .footer td, .footer p, .footer span, .footer a { color: #999999; font-size: 12px; text-align: center; } /* ------------------------------------- TYPOGRAPHY ------------------------------------- */ h1, h2, h3, h4 { color: #000000; font-family: sans-serif; font-weight: 400; line-height: 1.4; margin: 0; margin-bottom: 10px; } h1 { font-size: 30px; font-weight: 300; text-align: center; } p, ul, ol { font-family: sans-serif; font-size: 14px; font-weight: normal; margin: 0; margin-bottom: 20px; } p li, ul li, ol li { list-style-position: inside; margin-left: 5px; } a { color: #3498db; text-decoration: underline; } /* ------------------------------------- BUTTONS ------------------------------------- */ .btn { box-sizing: border-box; width: 100%; } .btn > tbody > tr > td { padding-bottom: 15px; } .btn table { width: auto; } .btn table td { background-color: #ffffff; border-radius: 5px; text-align: center; } .btn a { background-color: #ffffff; border: solid 1px #3498db; border-radius: 5px; box-sizing: border-box; color: #3498db; cursor: pointer; display: inline-block; font-size: 14px; font-weight: bold; margin: 0; padding: 12px 25px; text-decoration: none; text-transform: capitalize; } .btn-primary table td { background-color: #3498db; } .btn-primary a { background-color: #4EAA36; border-color: #4EAA36; color: #ffffff; } /* ------------------------------------- OTHER STYLES THAT MIGHT BE USEFUL ------------------------------------- */ .last { margin-bottom: 0; } .first { margin-top: 0; } .align-center { text-align: center; } .align-right { text-align: right; } .align-left { text-align: left; } .clear { clear: both; } .mt0 { margin-top: 0; } .mb0 { margin-bottom: 0; } .preheader { color: transparent; display: none; height: 0; max-height: 0; max-width: 0; opacity: 0; overflow: hidden; mso-hide: all; visibility: hidden; width: 0; } .powered-by a { text-decoration: none; } hr { border: 0; border-bottom: 1px solid #f6f6f6; Margin: 20px 0; } /* ------------------------------------- RESPONSIVE AND MOBILE FRIENDLY STYLES ------------------------------------- */ @media only screen and (max-width: 620px) { table[class=body] h1 { font-size: 28px !important; margin-bottom: 10px !important; } table[class=body] p, table[class=body] ul, table[class=body] ol, table[class=body] td, table[class=body] span, table[class=body] a { font-size: 16px !important; } table[class=body] .wrapper, table[class=body] .article { padding: 10px !important; } table[class=body] .content { padding: 0 !important; } table[class=body] .container { padding: 0 !important; width: 100% !important; } table[class=body] .main { border-left-width: 0 !important; border-radius: 0 !important; border-right-width: 0 !important; } table[class=body] .btn table { width: 100% !important; } table[class=body] .btn a { width: 100% !important; } table[class=body] .img-responsive { height: auto !important; max-width: 100% !important; width: auto !important; }} @media all { .ExternalClass { width: 100%; } .ExternalClass, .ExternalClass p, .ExternalClass span, .ExternalClass font, .ExternalClass td, .ExternalClass div { line-height: 100%; } .apple-link a { color: inherit !important; font-family: inherit !important; font-size: inherit !important; font-weight: inherit !important; line-height: inherit !important; text-decoration: none !important; } .btn-primary table td:hover { background-color: #34495e !important; } } </style> </head> <body class=""> <table border="0" cellpadding="0" cellspacing="0" class="body"> <tr> <td>&nbsp;</td> <td class="container"> <div class="content"> <span class="preheader"></span> <table class="main"> <!-- START MAIN CONTENT AREA --> <tr> <td class="wrapper"> <table border="0" cellpadding="0" cellspacing="0"> <tr> <td> <img src="https://www.threatalertbutton.com/assets/images/product/tab-dark.png" width="100"> <h1>Verify your email address</h1> <p>Please click the button below to confirm your email address  and  <br> activate your account.</p> <table border="0" cellpadding="0" cellspacing="0" class="btn btn-primary"> <tbody> <tr> <td align="center"> <table border="0" cellpadding="0" cellspacing="0"> <tbody> <tr> <td> <!-- Enter the url in the href--> <a  href="' + config.app.url + '/verify/' + email + '/' + key + '" target="_blank"> Confirm Email</a> <!-- Enter the url in the href --> </td> </tr> </tbody> </table> </td> </tr> </tbody> </table> <p style="color: #999999; margin-top: 15px;">If you received this email by mistake, simply delete it and dont click the button.</p> </td> </tr> </table> </td> </tr> <!-- END MAIN CONTENT AREA --> </table> <!-- START FOOTER --> <div class="footer"> <table border="0" cellpadding="0" cellspacing="0"> <tr> <td height="10"></td> </tr> <tr> <td class="content-block powered-by"> <div class="copy">© 2020 Kratikal Tech Pvt Ltd. All Rights Reserved </div> </td> </tr> </table> </div> <!-- END FOOTER --> <!-- END CENTERED WHITE CONTAINER --> </div> </td> <td>&nbsp;</td> </tr> </table> </body> </html>',
                                            //html: '<!DOCTYPE html> <html> <head> <title>Verify account</title> </head> <body cz-shortcut-listen="true" style="margin: 0; padding: 0 !important; margin-top: 20px; mso-line-height-rule: exactly; color: black;" width="100%"> <center style="width: 100%;"> <div style="display: none; font-size: 1px;max-height: 0px; max-width: 0px; opacity: 0; overflow: hidden; mso-hide: all; font-family: sans-serif;">&nbsp;</div> <div class="email-container" style="max-width: 600px; margin: 0 auto;"> <img width="100px" src="'+config.app.url+'/static/assets/images/logo/logo-dark.png"> <div class="overlay">&nbsp;</div> <table align="center" border="0" cellpadding="0" cellspacing="0" role="presentation" style="margin: auto;border: 2px solid #eeeded; border-radius: 10px; padding:0px;" width="100%"> <tbody> <tr> <td class="hero bg_white"  valign="middle"> <table border="0" cellpadding="0" cellspacing="0" width="100%" > <tbody> <!-- center image --> <tr> <td style="text-align: center;"> <img  width="120" height="60" style="margin-bottom: 0px; border-radius: 5px;" src="'+config.app.url+'/static/assets/images/banner-account-verify.png"> </td> </tr> </tbody> </table> <table border="0" cellpadding="10" cellspacing="0" width="100%" > <tbody> <!-- paragraph --> <tr> <td style="text-align: center;"> <p style="font-size:16px;line-height:0px;font-family:Arial;margin-bottom: 28px;color: #4a4848;">Welcome to ThreatAlertButton!</p> <p style="font-size:20px;line-height:21px;font-family:Arial;margin-bottom:0px;">Thanks for registering with us.</p> </td> </tr> <!-- button --> <tr> <td style="text-align: center;"> <p style="border-top: 2px solid #00000021;"></p> <p style="font-size:16px; line-height: 54px;font-family:Arial;margin-bottom: 20px;color: #4a4848;">Please verify your account to get started</p> <a style="background: #f0803b; color:white; padding: 10px 20px;font-family:Arial; text-decoration: none; border-radius: 22px; letter-spacing: 0.3px;font-size: 16px;    font-weight: 600;" href="'+config.app.url+'/verify/'+email+'/'+key+'" target="_blank">Verify Account</a> </td> </tr> <tr> <td style="text-align: center;"> <p style="font-size:16px;line-height:21px;font-family:Arial;margin-bottom: 25px;">Need help?</p> <p style="font-size:16px;line-height:10px;font-family:Arial;margin-bottom: 15px;color: #4a4848;">Visit the Help Center or Contact us.</p> <p style="font-size:16px;line-height:21px;font-family:Arial;margin-bottom: 10px;"><a href="https://app.threatalertbutton.com/">app.threatalertbutton.com</a></p> </td> </tr> <tr > <td style=" text-align: center;"> <p style="font-size:16px; margin-bottom: 25px; font-family:Arial;">This is a system-generated email, please don\'t reply to this message.</p> </td> </tr> <tr > <td style="border-top: 2px solid #00000021; text-align: center;"> <p style="font-size:16px; margin-bottom: 35px; font-family:Arial;line-height: 26px;">If you’re having trouble clicking the "Verify Account" button, copy and paste the URL below into your web browser:<a href="'+config.app.url+'/verify/'+email+'/'+key+'" style="text-decoration: none;"> '+config.app.url+'/verify/'+email+'/'+key+' </a></p> </td> </tr> </tbody> </table> </td> </tr> </tbody> </table> </div> </center> </body> </html>' ,
                                        }, function (error, info) {
                                            if (error) {
                                                console.log("Error occured while sending verification link", error)
                                                return reject({
                                                    msg: 'Email Sending Failed'
                                                })
                                            }
                                            console.log("Mail sent");
                                            return resolve(true)
                                        });
                                    })
                                    .catch(err => {
                                        return reject({
                                            msg: 'Email Sending Failed'
                                        })
                                    })
                            }
                        } else throw {
                            msg: 'Email Body not available'
                        }
                    })
            } catch (err) {
                console.log(err)
                reject(err);
            }
        });
    },
    sendResetPassword: (email) => {
        return new Promise((resolve, reject) => {
            try {
                db.User.findOne({ where: { email: email } })
                    .then(user => {
                        if (user) {
                            var key = Math.random().toString(36).slice(2);
                            db.User.update({ verf_key: key }, { where: { id: user.id } })
                                .then(r => {
                                    var smtpTransport = nodemailer.createTransport({
                                        host: config.mail.host,
                                        port: config.mail.port,
                                        auth: {
                                            user: config.mail.username,
                                            pass: config.mail.password
                                        },
                                        tls: { rejectUnauthorized: false },
                                    });
                                    smtpTransport.sendMail({
                                        from: config.mail.from,
                                        to: email,
                                        subject: 'ThretAlertButton Password Reset',
                                        html: '<!doctype html> <html> <head> <style> img { border: none; -ms-interpolation-mode: bicubic; max-width: 100%; } body { background-color: #f6f6f6; font-family: sans-serif; -webkit-font-smoothing: antialiased; font-size: 14px; line-height: 1.4; margin: 0; padding: 0; -ms-text-size-adjust: 100%; -webkit-text-size-adjust: 100%; } table { border-collapse: separate; mso-table-lspace: 0pt; mso-table-rspace: 0pt; width: 100%; } table td { font-family: sans-serif; font-size: 14px; vertical-align: top; } .body { background-color: #f6f6f6; width: 100%; } .container { display: block; Margin: 0 auto !important; max-width: 580px; padding: 10px; width: 580px; } .content { box-sizing: border-box; display: block; Margin: 0 auto; max-width: 580px; padding: 10px; } .main { background: #fff; border-radius: 3px; width: 100%; } .wrapper { box-sizing: border-box; padding: 20px; text-align: center; } .footer { clear: both; padding-top: 10px; text-align: center; width: 100%; } .footer td, .footer p, .footer span, .footer a { color: #999999; font-size: 12px; text-align: center; } h1, h2, h3, h4 { color: #000000; font-family: sans-serif; font-weight: 400; line-height: 1.4; margin: 0; margin-bottom: 10px; } h1 { font-size: 30px; font-weight: 300; text-align: center; } p, ul, ol { font-family: sans-serif; font-size: 14px; font-weight: normal; margin: 0; margin-bottom: 20px; } p li, ul li, ol li { list-style-position: inside; margin-left: 5px; } a { color: #3498db; text-decoration: underline; } .btn { box-sizing: border-box; width: 100%; } .btn > tbody > tr > td { padding-bottom: 15px; } .btn table { width: auto; } .btn table td { background-color: #ffffff; border-radius: 5px; text-align: center; } .btn a { background-color: #ffffff; border: solid 1px #3498db; border-radius: 5px; box-sizing: border-box; color: #3498db; cursor: pointer; display: inline-block; font-size: 14px; font-weight: bold; margin: 0; padding: 12px 25px; text-decoration: none; text-transform: capitalize; } .btn-primary table td { background-color: #3498db; } .btn-primary a { background-color: #4EAA36; border-color: #4EAA36; color: #ffffff; } .last { margin-bottom: 0; } .first { margin-top: 0; } .align-center { text-align: center; } .align-right { text-align: right; } .align-left { text-align: left; } .clear { clear: both; } .mt0 { margin-top: 0; } .mb0 { margin-bottom: 0; } .preheader { color: transparent; display: none; height: 0; max-height: 0; max-width: 0; opacity: 0; overflow: hidden; mso-hide: all; visibility: hidden; width: 0; } .powered-by a { text-decoration: none; } hr { border: 0; border-bottom: 1px solid #f6f6f6; Margin: 20px 0; } @media only screen and (max-width: 620px) { table[class=body] h1 { font-size: 28px !important; margin-bottom: 10px !important; } table[class=body] p, table[class=body] ul, table[class=body] ol, table[class=body] td, table[class=body] span, table[class=body] a { font-size: 16px !important; } table[class=body] .wrapper, table[class=body] .article { padding: 10px !important; } table[class=body] .content { padding: 0 !important; } table[class=body] .container { padding: 0 !important; width: 100% !important; } table[class=body] .main { border-left-width: 0 !important; border-radius: 0 !important; border-right-width: 0 !important; } table[class=body] .btn table { width: 100% !important; } table[class=body] .btn a { width: 100% !important; } table[class=body] .img-responsive { height: auto !important; max-width: 100% !important; width: auto !important; }} @media all { .ExternalClass { width: 100%; } .ExternalClass, .ExternalClass p, .ExternalClass span, .ExternalClass font, .ExternalClass td, .ExternalClass div { line-height: 100%; } .apple-link a { color: inherit !important; font-family: inherit !important; font-size: inherit !important; font-weight: inherit !important; line-height: inherit !important; text-decoration: none !important; } .btn-primary table td:hover { background-color: #34495e !important; } } </style> </head> <body class=""> <table border="0" cellpadding="0" cellspacing="0" class="body"> <tr> <td>&nbsp;</td> <td class="container"> <div class="content"> <span class="preheader"></span> <table class="main"> <tr> <td class="wrapper"> <table border="0" cellpadding="0" cellspacing="0"> <tr> <td> <img src="https://www.threatalertbutton.com/assets/images/product/tab-dark.png" width="100"> <h1>Reset Password</h1> <p>Please click the button below to reset your password  and  <br> recover your account.</p> <table border="0" cellpadding="0" cellspacing="0" class="btn btn-primary"> <tbody> <tr> <td align="center"> <table border="0" cellpadding="0" cellspacing="0"> <tbody> <tr> <td> <a href="' + config.app.url + '/reset/' + email + '/' + key + '" target="_blank"> Reset Password</a> </td> </tr> </tbody> </table> </td> </tr> </tbody> </table> <p style="color: #999999; margin-top: 15px;">If you received this email by mistake, simply delete it and dont click the button.</p> </td> </tr> </table> </td> </tr> </table> <div class="footer"> <table border="0" cellpadding="0" cellspacing="0"> <tr> <td height="10"></td> </tr> <tr> <td class="content-block powered-by"> <div class="copy">© 2020 Kratikal Tech Pvt Ltd. All Rights Reserved </div> </td> </tr> </table> </div> </div> </td> <td>&nbsp;</td> </tr> </table> </body> </html>',
                                        //text: "Click on this link to reset your password - "+config.app.url+"/reset/"+email+"/"+key,
                                    }, function (error, info) {
                                        if (error) {
                                            return reject({
                                                name: "PRAException",
                                                msg: 'Email Sending Failed',
                                                error: error
                                            })
                                        }
                                        return resolve(true)
                                    });
                                })
                        } else {
                            reject(true);
                        }
                    })
            } catch (err) {
                reject(err);
            }
        });
    },

    sendOtpLink: (email, newPassword) => {
        return new Promise((resolve, reject) => {
            try {
                db.User.findOne({ where: { email: email } })
                    .then((user) => {
                        if (user) {
                            if (user.isNewUser == 1) {
                                var smtpTransport = nodemailer.createTransport({
                                    host: config.mail.host,
                                    port: config.mail.port,
                                    auth: {
                                        user: config.mail.username,
                                        pass: config.mail.password
                                    },
                                    tls: { rejectUnauthorized: false },
                                });
                                smtpTransport.sendMail({
                                    from: config.mail.from,
                                    to: email,
                                    subject: 'KDMARC Reset Password',
                                    text: "Click on this link to reset your password - " + config.app.url + "/login/" + email + "/" + newPassword,
                                }, function (error, info) {
                                    if (error) {
                                        return reject({
                                            name: "PRAException",
                                            msg: 'Email Sending Failed'
                                        })
                                    }
                                    return resolve(true)
                                });

                            }
                        } else throw {
                            name: "PRAException",
                            msg: 'Email Body not available'
                        }
                    })
            } catch (err) {
                reject(err);
            }
        });
    },

    sendEmployeePassword: (email, password, alias) => {
        return new Promise((resolve, reject) => {
            try {
                db.Employee.findOne({ where: { email: email } })
                    .then((user) => {
                        if (user) {
                            var smtpTransport = nodemailer.createTransport({
                                host: config.mail.host,
                                port: config.mail.port,
                                auth: {
                                    user: config.mail.username,
                                    pass: config.mail.password
                                },
                                tls: { rejectUnauthorized: false },
                            });
                            smtpTransport.sendMail({
                                from: config.mail.from,
                                to: email,
                                subject: 'KDMARC Password',
                                html: "Dear Patron,<br><br> Thank you for registering with KDMARC.Your login details are given below, please keep it secret.<br> Alias : " + alias + "<br> Email : " + user.email + "  <br>Below is the login link for activation of your KDMARC services.<br> <br> <b>" + config.app.url + "/employeelogin/" + email + "/" + password + "/" + alias + "</b> <br><br> This link will expire in 48 hours. <br> This is a system generated mail. Please do not reply to this email ID. <br><br> Warm Regards,<br> Customer Care<br> KDMARC",
                                // html: "Hi <br>" + "Your One Time Password(OTP) for completing your registeration on KDMARC is  " + password + " .Please do not share OTP with anyone .<br> Best Regards, <br> Team KDMARC",
                            }, function (error, info) {
                                if (error) {
                                    return reject({
                                        name: "PRAException",
                                        msg: 'Email Sending Failed'
                                    })
                                }
                                return resolve(true)
                            });
                        } else throw {
                            name: "PRAException",
                            msg: 'Email Body not available'
                        }
                    })
            } catch (err) {
                reject(err);
            }
        });
    },

    employeeResetPassword: (email, password, alias) => {
        return new Promise((resolve, reject) => {
            try {
                db.Employee.findOne({ where: { email: email } })
                    .then((user) => {
                        if (user) {
                            var smtpTransport = nodemailer.createTransport({
                                host: config.mail.host,
                                port: config.mail.port,
                                auth: {
                                    user: config.mail.username,
                                    pass: config.mail.password
                                },
                                tls: { rejectUnauthorized: false },
                            });
                            smtpTransport.sendMail({
                                from: config.mail.from,
                                to: email,
                                subject: 'KDMARC Reset Password',
                                text: "Click on this link to reset your password - " + config.app.url + "/employeelogin/" + email + "/" + password + "/" + alias,
                                // html: "Hi <br>" + "Your One Time Password(OTP) for completing your registeration on KDMARC is  " + password + " .Please do not share OTP with anyone .<br> Best Regards, <br> Team KDMARC",
                            }, function (error, info) {
                                if (error) {
                                    return reject({
                                        name: "PRAException",
                                        msg: 'Email Sending Failed'
                                    })
                                }
                                return resolve(true)
                            });
                        } else throw {
                            name: "PRAException",
                            msg: 'Email Body not available'
                        }
                    })
            } catch (err) {
                reject(err);
            }
        });
    },

    sendEmployeePassword: (email, password, alias) => {
        return new Promise((resolve, reject) => {
            try {
                db.Employee.findOne({ where: { email: email } })
                    .then((user) => {
                        if (user) {
                            var smtpTransport = nodemailer.createTransport({
                                host: config.mail.host,
                                port: config.mail.port,
                                auth: {
                                    user: config.mail.username,
                                    pass: config.mail.password
                                },
                                tls: { rejectUnauthorized: false },
                            });
                            smtpTransport.sendMail({
                                from: config.mail.from,
                                to: email,
                                subject: 'ThreatAlertButton Password',
                                html: "Dear Patron,<br><br> You have been registered with ThreatAlertButton.Your login details are given below, please keep it secret.<br> Alias : " + alias + "<br> Email : " + user.email + "  <br>Below is the login link for activation of your ThreatAlertButton account.<br> <br> <b>" + config.app.url + "/employeelogin/" + email + "/" + password + "/" + alias + "</b> <br><br> This link will expire after one time use, if you face any problem contact you admininstrator.<br> This is a system generated mail. Please do not reply to this email ID. <br><br> Warm Regards,<br> Customer Care<br> ThreatAlertButton",
                            }, function (error, info) {
                                if (error) {
                                    return reject({
                                        name: "PRAException",
                                        msg: 'Email Sending Failed'
                                    })
                                }
                                return resolve(true)
                            });
                        } else throw {
                            name: "PRAException",
                            msg: 'Email Body not available'
                        }
                    })
            } catch (err) {
                reject(err);
            }
        });
    },

    alertSOCTeam: (email) => {
        return new Promise((resolve, reject) => {
            try {
                var smtpTransport = nodemailer.createTransport({
                    host: config.mail.host,
                    port: config.mail.port,
                    auth: {
                        user: config.mail.username,
                        pass: config.mail.password
                    },
                    tls: { rejectUnauthorized: false },
                });
                smtpTransport.sendMail({
                    from: config.mail.from,
                    to: email,
                    subject: 'Report',
                    html: "Hi <br>" + "Your email has been reported to the security team with subject . We will revert as soon as any action is performed on your report.",
                }, function (error, info) {
                    if (error) {
                        return reject({
                            name: "Exception",
                            msg: 'Email Sending Failed'
                        })
                    }
                    return resolve(true)
                });


            } catch (err) {
                console.log(err)
                reject(err);
            }
        });
    },

    employeeResetPassword: (email, password, alias) => {
        return new Promise((resolve, reject) => {
            try {
                db.Employee.findOne({ where: { email: email } })
                    .then((user) => {
                        if (user) {
                            var smtpTransport = nodemailer.createTransport({
                                host: config.mail.host,
                                port: config.mail.port,
                                auth: {
                                    user: config.mail.username,
                                    pass: config.mail.password
                                },
                                tls: { rejectUnauthorized: false },
                            });
                            smtpTransport.sendMail({
                                from: config.mail.from,
                                to: email,
                                subject: 'ThreatAlertButton Reset Password',
                                text: "Click on this link to reset your password - " + config.app.url + "/change-password/" + email + "/" + password + "/" + alias,
                            }, function (error, info) {
                                if (error) {
                                    return reject({
                                        name: "PRAException",
                                        msg: 'Email Sending Failed'
                                    })
                                }
                                return resolve(true)
                            });
                        } else throw {
                            name: "PRAException",
                            msg: 'Email Body not available'
                        }
                    })
            } catch (err) {
                reject(err);
            }
        });
    },



    sendDomain: (data, detail) => {
        data.details = JSON.parse(data.details);
        return new Promise((resolve, reject) => {
            try {
                var value = '';
                for (var i = 0; i < 5; i++) {
                    value += '<tr><td></td><td></td></tr>';
                }
                Object.keys(data.details).forEach(key => {
                    Object.keys(data.details[key]).forEach(key1 => {
                        if (key != 'info')
                            value += '<tr><td>' + key1 + '</td><td>' + data.details[key][key1] + '</td></tr>'
                    })
                })
                Object.keys(detail).forEach(key => {
                    value += '<tr><td>' + key + '</td><td>' + JSON.stringify(detail[key]) + '</td></tr>';
                })
                var html = '<!DOCTYPE html> <html> <body> <label>Firstname:</label> <span>' + (data.firstname ? data.firstname : '') + '</span> <br> <label>Lastname:</label> <span>' + (data.lastname ? data.lastname : '') + '</span> <br> <label>Email:</label> <span>' + data.email + '</span> <br><label>phone:</label> <span>' + (data.phone) + '</span> <br><label>Source:</label> <span>' + data.source + '</span> <br> <label>Details:</label> <br> <table> ' + value + '</table> </body> </html>'
                var smtpTransport = nodemailer.createTransport({
                    host: config.mail.host,
                    port: config.mail.port,
                    auth: {
                        user: config.mail.username,
                        pass: config.mail.password
                    },
                    tls: { rejectUnauthorized: false },
                });
                smtpTransport.sendMail({
                    from: config.mail.from,
                    to: config.mail.to.split(','),
                    subject: "New Lead reported",
                    html: html
                }, function (error, info) {

                    if (error) {
                        return reject(new RequestError('Email Sending Failed', 500, error));
                    }
                    return resolve(true)
                })
            } catch (err) {
                resolve(true);
            }
        });
    },

    sendOTP: (email, OTP) => {
        return new Promise((resolve, reject) => {
            try {
                var smtpTransport = nodemailer.createTransport({
                    host: config.mail.host,
                    port: config.mail.port,
                    auth: {
                        user: config.mail.username,
                        pass: config.mail.password
                    },
                    tls: { rejectUnauthorized: false },
                });
                smtpTransport.sendMail({
                    from: config.mail.from,
                    to: email,
                    subject: 'ThreatAlertButton OTP',
                    html: "Hi <br>" + "Your One Time Password(OTP) for login is  " + OTP + " expires  in 10 minutes .Please do not share OTP with anyone .<br> Best Regards, <br> Team Kratikal",
                }, function (error, info) {
                    if (error) {
                        return reject({
                            name: "TABException",
                            msg: 'Email Sending Failed'
                        })
                    }
                    return resolve(true)
                });
            } catch (err) {
                console.log(err)
                reject(err);
            }
        });
    },
}