import passport from 'passport';
import JWT from 'jsonwebtoken';
import config from '../config';
import { db } from '../models';

var JWTSign = function(user, date) {
    return JWT.sign({
        iss: config.app.name,
        sub: user.id,
        iat: date.getTime(),
        exp: new Date().setMinutes(date.getMinutes() + 30)
    }, config.app.secret);
}
export var loginCheck = () => {
    console.log("Inside logincheck")
    return (req, res, next) => {
        var token = null;
        if (req && req.cookies) {
            token = req.cookies['XSRF-token-tab'];
        }
        if (token != null) {
            return res.redirect('/');
        }
        next();
    }
}
export var validatelogin = (req, res, next) => {
    passport.authenticate('jwt', { session: false }, async(err, user, info) => {
        let contype = req.headers['content-type'];
        var json = !(!contype || contype.indexOf('application/json') !== 0);
        if (err && err == 'expired') { next(); return; }
        if (err && err == 'invalid') { next(); return; }
        if (err && err == 'user') { next(); return; }
        if (err && Object.keys(err).length) { next(); return; }
        if (err) { next(); return; }
        if (!user) { next(); return; }
        var meta = await db.UserPackage.findOne({
            where: { companyId: user.companyId }
        });
        if (meta) {
            var date = new Date();
            var token = JWTSign(user, date);
            res.cookie('XSRF-token', token, {
                expire: new Date().setMinutes(date.getMinutes() + 30),
                httpOnly: true,
                secure: config.app.secure
            });
            req.user = user;
        }
        next();
        //Update Token
    })(req, res, next);
};
export var checkExpiry = (req, res, next) => {
    db.UserPackage.findAll({ where: { companyId: req.user.companyId } })
        .then((meta) => {
            if (meta[0]) {
                var date = new Date();
                var tempDate = Date.parse(date);
                var metaDate = new Date(parseInt(meta[5].value));
                metaDate.setDate(metaDate.getDate() + parseInt(meta[4].value));
                metaDate = Date.parse(metaDate)
                metaDate = Math.floor(metaDate / (3600 * 24 * 1000));
                tempDate = Math.floor(tempDate / (3600 * 24 * 1000));
                diff = (metaDate - tempDate)
            }
            if (diff <= 0) {
                throw new RequestError('Package  expired', 403);
            }
            req.user.expiry = diff;
            next();
        })
};
export var userImplant = (req, res, next) => {
    res.locals.user = json(req.user);
    // console.log("user is", req.user);
    for (var i = 0; i < req.user.Company.MetaAuths.length; i++) {
        if (req.user.Company.MetaAuths[i].key == 'imap')
            if (json(req.user.Company.MetaAuths[i].value) == 1) { res.locals.imap_imap = "checked" } else { res.locals.imap_imap = "unchecked" };
        if (req.user.Company.MetaAuths[i].key == 'imap_userID') res.locals.imap_userID = json(req.user.Company.MetaAuths[i].value);
        if (req.user.Company.MetaAuths[i].key == 'imap_password') res.locals.imap_password = req.user.Company.MetaAuths[i].value;
        if (req.user.Company.MetaAuths[i].key == 'imap_host') res.locals.imap_host = req.user.Company.MetaAuths[i].value
        if (req.user.Company.MetaAuths[i].key == 'imap_port') res.locals.imap_port = req.user.Company.MetaAuths[i].value
    }
    next();
}