import { db } from '../models';

export var checkAccess = function(moduleName, access){
    return (req, res, next) => {
        db.UserModule.findOne({ 
            where : { accessType: { like: "%"+access+"%" }, userId: req.user.id },
            include: [{ 
               model:db.Module,
               where: { name: moduleName },
               required: true,
            }]
        })
        .then(r => {
            if(r) {
                return next();}
            else{
                return db.UserModule.findOne({ 
                    where : { accessType: { like: "%"+access+"%" }, userId: req.user.id },
                    include: [{ 
                       model:db.Module,
                       where: { name: ["Domain", "Source", "Overview", "Report"] },
                       required: true,
                    }]
                }).then(r => {
                    if(r.Module.name=='Domain') 
                    {   
                        return res.redirect('domains');
                    }
                    else if(r.Module.name=='Source'){
                        return res.redirect('sources');
                    }
                    else if(r.Module.name=='Overview'){
                        return res.redirect('/');
                    }
                    else if(r.Module.name=='Report'){
                        return res.redirect('reports');
                    }
                    else throw new RequestError('Access Denied', 401);
                })
                .catch( err => {
                    next(err);
                 })    
            } 
        })
        
        .catch( err => {
           next(err);
        })
    }
}; 