import API from './API';
import config from '../config';

export class Tab extends API {
    constructor() {
        super(config.tab.baseUrl)
    }
    listInbox(data) {
        return super.get({ 'path': '/api/email/' }, data)
    }
    totalReport(data) {
        return super.get({ 'path': '/api/email/totalReport' }, data)
    }
    pendingReport(data) {
        return super.get({ 'path': '/api/email/pendingReport' }, data)
    }
    topReportedMail(data) {
        return super.get({ 'path': '/api/email/topReportedMail' }, data)
    }
    approveReport(data) {
        return super.get({ 'path': '/api/email/approveReport' }, data)
    }
    declinedReport(data) {
        return super.get({ 'path': '/api/email/declinedReport' }, data)
    }
    monthReport(data) {
        return super.get({ 'path': '/api/email/monthReport' }, data)
    }
    spamOrHamp(data) {
        return super.get({ 'path': '/api/email/spamOrHamp' }, data)
    }
    fetchMail(data) {
        return super.get({ 'path': '/api/email/reportedmails/' }, data)
    }
    fetchMailReport(data) {
        return super.get({ 'path': '/api/email/reportedmailsCount/' }, data)
    }
    fetchDmarcDomainAuthRisk(data) {
        return super.get({ 'path': '/api/email/analyticsDomainAuthRisk/' }, data)
    }
    fetchAttachmentScanResult(data) {
        return super.get({ 'path': '/api/scan/' }, data)
    }
    fetchLinkScanResult(data) {
        return super.get({ 'path': '/api/scan/linkScan/' }, data)
    }
    fetchLinkScanResult_aggregate(data) {
        return super.post({ 'path': '/api/scan/linkScanAggregate/' }, data)
    }
    attachmentRisk(data) {
        return super.get({ 'path': '/api/scan/attachmentRisk/' }, data)
    }
    urlRisk(data) {
        return super.get({ 'path': '/api/scan/urlRisk/' }, data)
    }
    gctxRisk(data) {
        return super.get({ 'path': '/api/scan/gctxRisk/' }, data)
    }
    deleteMail(data) {
        return super.post({ 'path': '/api/scan/deleteMail/' }, data)
    }
    fetchWhoElse(data) {
        return super.post({ 'path': '/api/scan/whoElse/' }, data)
    }
    scanAttachment(data) {
        return super.post({ 'path': '/api/scan/file/' }, data)
    }
    deleteSingleMail(data) {
        return super.post({ 'path': '/api/scan/deleteSingleMail/' }, data)
    }
    blockSender(data) {
        return super.post({ 'path': '/api/scan/blockSender/' }, data)
    }
    blockDomain(data) {
        return super.post({ 'path': '/api/scan/blockDomain/' }, data)
    }
    mailRisk(data) {
        return super.post({ 'path': '/api/scan/mailRisk/' }, data)
    }
    changeStatus(data) {
        return super.post({ 'path': '/api/scan/approvalStatus/' }, data)
    }
    blacklist(data) {
        return super.get({ 'path': '/api/scan/blacklisted/' }, data)
    }
    unBlockDomain(data) {
        return super.post({ 'path': '/api/scan/unblockDomain/' }, data)
    }
    unBlockSender(data) {
        return super.post({ 'path': '/api/scan/unblockSender/' }, data)
    }
    recoverMail(data) {
        return super.post({ 'path': '/api/scan/recoverMail' }, data)
    }
    recoverSingleMail(data) {
        return super.post({ 'path': '/api/scan/recoverSingleMail' }, data)
    }
    recentReportedMails(data) {
        return super.get({ 'path': '/api/scan/recentReportedMails/' }, data)
    }
    advanceScan(data) {
        return super.post({ 'path': '/api/scan/advanceScan' }, data)
    }
    reportersCount(data) {
        return super.get({ 'path': '/api/scan/reportersCount/' }, data)
    }
    headerFileName(data) {
        return super.post({ 'path': '/api/email/headerFileName' }, data)
    }
    fetchDnsblScanReport(data) {
        return super.post({ 'path': '/api/email/dnsblReport' }, data)
    }
    depceptiveDomainCheck(data) {
        return super.post({ 'path': '/api/email/depceptiveDomainCheck' }, data)
    }
}