var searchHistory = window.localStorage.getItem("search-history") ? Array.from(JSON.parse(JSON.parse(JSON.stringify(window.localStorage.getItem("search-history"))))) : [];
var validateData = function () {
    var data = {}
    data.senderID = $('#senderID').val() ? $('#senderID').val() : $('#senderID1').val();
    data.senderIP = $('#senderIP').val() ? $('#senderIP').val() : $('#senderIP1').val();
    data.mailSubject = $('#mailSubject').val() ? $('#mailSubject').val() : $('#mailSubject1').val();
    if (!data.senderID || (data.senderID && data.senderID.length == 0)) {
        addError('senderID', 'Please Enter a Sender Email ID to proceed!');
    }
    //-------------------start- date- handel ------------------------
    data.startDate = $('#startDate').val() ? $('#startDate').val() : $('#startDate1').val();
    var myDate = data.startDate.split("/");
    var newDate = myDate[0] + "/" + myDate[1] + "/" + myDate[2];
    var startDatetimestamp = new Date(newDate).getTime();
    var date = new Date();
    date.setDate(date.getDate() - 10);
    var dateString = date.toISOString().split('T')[0];
    prevmyDate = dateString.split("-");
    var prevDate = prevmyDate[1] + "/" + prevmyDate[2] + "/" + prevmyDate[0];
    var Prevtimestamp = new Date(prevDate).getTime();
    // console.log("data is", startDatetimestamp, new Date().getTime());
    // console.log("data is", startDatetimestamp, Prevtimestamp);
    if (startDatetimestamp > new Date().getTime()) {
        addError('startDate', 'Start Date cannot be bigger than Today!')
    }
    else if (startDatetimestamp < Prevtimestamp) {
        addError('startDate', 'The StartDate cannot be older than 10 days from today.')
    }
    //-------------------end-date-handel ------------------------
    data.endDate = $('#endDate').val() ? $('#endDate').val() : $('#endDate1').val();
    var endDate = data.endDate.split("/")
    var endDateNotFormatted = endDate[0] + "/" + endDate[1] + "/" + endDate[2];
    var endDateTimestamp = new Date(endDateNotFormatted).getTime();
    // console.log("endDateTimestamp and Prevtimestamp", endDateTimestamp, Prevtimestamp);
    // console.log("endDateTimestamp and startDatetimestamp", endDateTimestamp, startDatetimestamp);
    if (endDateTimestamp < Prevtimestamp) {
        addError('endDate', 'End Date cannot be more than 30 days! for today')
    }
    else if (endDateTimestamp < startDatetimestamp) {
        addError('endDate', 'End Date cannot be less than Start date!')
    }
    hasError() && showErrors();
    return data;
}

var advanceSearch = function (data) {
    var data = validateData();
    !hasError() && api.advanceSearch.scan(data, function (response) {
        advanceScanRespose(response);
        showSuccess("Your Request is Now processing. Please Wait !");
    }, function (err) {
        hidePageLoader();
        if (err.errors) showError(err.errors);
    })
}

var advanceSearch_v2 = function (data) {
    var data = validateData();
    console.log("Inside advanceSearch_v2", data);
    checkAccessToken(data);
}

var advanceSearch_v3 = function () {
    var data = validateData();
    showPageLoader();
    if (hasError())
        hidePageLoader();
    !hasError() && api.advanceSearch.scan(data, function (response) {
        hidePageLoader();
        $('#advanceSearch').html("")
        if (Array.isArray(response.mails)) {
            showMails(response.mails, data);
        }
        else {
            // advanceScanRespose(response);
            showSuccess("No Mails Found!");
        }
    }, function (err) {
        console.log("Error is", err);
        if (err.errors) showError(err.errors);
        hidePageLoader();
    })
    window.localStorage.setItem("search-history", JSON.stringify([...(window.localStorage.getItem("search-history") ? JSON.parse(window.localStorage.getItem("search-history")) : []), data.senderID]))
    searchHistory.push(data.senderID)
    autocomplete(document.getElementById("senderID"), searchHistory);
    // window.localStorage.setItem("search-history", JSON.stringify([...(window.localStorage.getItem("search-history") == undefined ? [] : JSON.parse(window.localStorage.getItem("search-history"))), data.senderID]));
}

function showMails(data, query) {
    hidePageLoader();
    console.log("query", query);
    // $("#senderID1").val("Sender: " + query.senderID + ", SenderIp: " + query.senderIP + ", MailSubject: " + query.mailSubject)
    if (data.length > 0) {
        // $("#search-top-fix").fadeIn(200);
        $('#senderID').val("");
        $('#startDate').val("");
        $('#endDate').val("");
        // $("#senderID1").val(data[0].senderAddress)
        // $('#startDate1').val(query.startDate);
        // $('#endDate1').val(query.endDate);
        // $("#senderID1").val(data[0].senderAddress + "" + query.startDate + "" + query.endDate)
        $("#search-top-fix").css({ "display": "block" });
        $("#resultsCount").html("<b>"+data.length+"</b> Result(s) Found")
        for (var i = 0; i < data.length; i++) {
            $('#advanceSearch').append('<tr class="table-row"><td>' + data[i].senderAddress + '</td><td>' + data[i].recipientAddress + '</td><td>' + data[i].subject + '</td><td>' + data[i].recieved + '</td><td>' + data[i].status + '</td><td>' + data[i].fromIp + '</td><td>' + data[i].size + '</td></tr>')
            $('#search-wrap').hide();
            $('#table-wrap').show();
        }
    } else {
        showSuccess("No Result Found");
    }
}


var blockDomain = function (data) {
    var senderId = { "senderId": data }
    !hasError() && api.advanceSearch.blockDomain(senderId, function (response) {
        showSuccess("Your Request is Now processing. Please Wait !");
    }, function (err) {
        hidePageLoader();
        if (err.errors) showError(err.errors);
    })
}

var blockSender = function (data) {
    var senderId = { "senderId": data }
    !hasError() && api.advanceSearch.blockSender(senderId, function (response) {
        showSuccess("Your Request is Now processing. Please Wait !");
    }, function (err) {
        hidePageLoader();
        if (err.errors) showError(err.errors);
    })
}

var deleteMail = function (sender, receiver, id, date, Subject) {
    var data = { sender: sender, receiver: receiver, date: date, subject: Subject, id: id }
    !hasError() && api.advanceSearch.deleteMail(data, function (response) {
        console.log(response)
        showSuccess("Your Request is Now processing. Please Wait !");
    }, function (err) {
        hidePageLoader();
        if (err.errors) showError(err.errors);
    })
}

var advanceScanRespose = function (response) {
    showPageLoader();
    var interval = setInterval(() => {
        api.advanceSearch.advanceScanResponse(response, function (data) {
            if (data.success == 'Please Wait!') console.log("Please Wait")
            else {
                console.log(data.success)
                $('#search-wrap').hide();
                $('#table-wrap').show();
                hidePageLoader();
                for (var i = 0; i < data.success.length; i++) {
                    var deleteMailobj = { recieved: data.success[i].Recieved, sender: data.success[i].SenderAddress, receiver: data.success[i].RecipientAddress }
                    deleteMailobj = JSON.stringify(deleteMailobj)
                    console.log(data.success[i].Received)
                    $('#advanceSearch').append('<tr><td>' + data.success[i].SenderAddress + '</td><td>' + data.success[i].RecipientAddress + '</td><td>' + data.success[i].FromIP + '</td><td>' + data.success[i].Subject + '</td><td>' + data.success[i].Size + '</td><td>' + data.success[i].gctx + '</td><td>' + data.success[i].Status + '</td><td><div class="dropdown"><a href="#" class="text-white dropdown-toggle btn btn-success" data-toggle="dropdown"><i class=" fas fa-info"></i></a><div class="dropdown-menu dropdown-menu-right"><!-- item--><a href="javascript:void(0);" onclick="deleteMail(\'' + data.success[i].SenderAddress + '\' ,\'' + data.success[i].RecipientAddress + '\' ,\'' + data.success[i].Received + '\' , `' + data.success[i].Subject + '` )" class="dropdown-item"><span>Delete</span></a><!-- item--><a href="javascript:void(0);" onclick="blockDomain(\'' + data.success[i].SenderAddress + '\');"class="dropdown-item"><span>Block Domain</span></a><a href="javascript:void(0);" onclick="blockSender(\'' + data.success[i].SenderAddress + '\');" class="dropdown-item"><span>Block Sender</span></a></div></div></td></tr>')
                }
                clearInterval(interval);
            }
        }, function (err) {
            hidePageLoader();
            if (err.errors) showError(err.errors);
        })
    }, 13000);

}

function autocomplete(inp, arr) {
    if (arr) {
        arr = new Set(arr);
        arr = Array.from(arr);
        console.log("arr.length", arr)
        /*the autocomplete function takes two arguments,
        the text field element and an array of possible autocompleted values:*/
        var currentFocus;
        /*execute a function when someone writes in the text field:*/
        inp.addEventListener("input", function (e) {
            var a, b, i, val = this.value;
            /*close any already open lists of autocompleted values*/
            closeAllLists();
            if (!val) { return false; }
            currentFocus = -1;
            /*create a DIV element that will contain the items (values):*/
            a = document.createElement("DIV");
            a.setAttribute("id", this.id + "autocomplete-list");
            a.setAttribute("class", "autocomplete-items");
            /*append the DIV element as a child of the autocomplete container:*/
            this.parentNode.appendChild(a);
            /*for each item in the array...*/
            for (i = 0; i < arr.length; i++) {
                /*check if the item starts with the same letters as the text field value:*/
                if (arr[i].substr(0, val.length).toUpperCase() == val.toUpperCase()) {
                    /*create a DIV element for each matching element:*/
                    b = document.createElement("DIV");
                    /*make the matching letters bold:*/
                    b.innerHTML = "<strong>" + arr[i].substr(0, val.length) + "</strong>";
                    b.innerHTML += arr[i].substr(val.length);
                    /*insert a input field that will hold the current array item's value:*/
                    b.innerHTML += "<input type='hidden' value='" + arr[i] + "'>";
                    /*execute a function when someone clicks on the item value (DIV element):*/
                    b.addEventListener("click", function (e) {
                        /*insert the value for the autocomplete text field:*/
                        inp.value = this.getElementsByTagName("input")[0].value;
                        /*close the list of autocompleted values,
                        (or any other open lists of autocompleted values:*/
                        closeAllLists();
                    });
                    a.appendChild(b);
                }
            }
        });
    }
    /*execute a function presses a key on the keyboard:*/
    inp.addEventListener("keydown", function (e) {
        var x = document.getElementById(this.id + "autocomplete-list");
        if (x) x = x.getElementsByTagName("div");
        if (e.keyCode == 40) {
            /*If the arrow DOWN key is pressed,
            increase the currentFocus variable:*/
            currentFocus++;
            /*and and make the current item more visible:*/
            addActive(x);
        } else if (e.keyCode == 38) { //up
            /*If the arrow UP key is pressed,
            decrease the currentFocus variable:*/
            currentFocus--;
            /*and and make the current item more visible:*/
            addActive(x);
        } else if (e.keyCode == 13) {
            /*If the ENTER key is pressed, prevent the form from being submitted,*/
            e.preventDefault();
            if (currentFocus > -1) {
                /*and simulate a click on the "active" item:*/
                if (x) x[currentFocus].click();
            }
        }
    });
    function addActive(x) {
        /*a function to classify an item as "active":*/
        if (!x) return false;
        /*start by removing the "active" class on all items:*/
        removeActive(x);
        if (currentFocus >= x.length) currentFocus = 0;
        if (currentFocus < 0) currentFocus = (x.length - 1);
        /*add class "autocomplete-active":*/
        x[currentFocus].classList.add("autocomplete-active");
    }
    function removeActive(x) {
        /*a function to remove the "active" class from all autocomplete items:*/
        for (var i = 0; i < x.length; i++) {
            x[i].classList.remove("autocomplete-active");
        }
    }
    function closeAllLists(elmnt) {
        /*close all autocomplete lists in the document,
        except the one passed as an argument:*/
        var x = document.getElementsByClassName("autocomplete-items");
        for (var i = 0; i < x.length; i++) {
            if (elmnt != x[i] && elmnt != inp) {
                x[i].parentNode.removeChild(x[i]);
            }
        }
    }
    /*execute a function when someone clicks in the document:*/
    document.addEventListener("click", function (e) {
        closeAllLists(e.target);
    });
}

$(document).ready(function () {
    $("#senderID").focus();
    console.log("searchHistory", searchHistory)
    autocomplete(document.getElementById("senderID"), searchHistory);
});