function animateValue(id, start, end, duration) {
    // assumes integer values for start and end

    var obj = document.getElementById(id);
    if (obj != null) {
        var range = end - start;
        // no timer shorter than 50ms (not really visible any way)
        var minTimer = 50;
        // calc step time to show all interediate values
        var stepTime = Math.abs(Math.floor(duration / range));

        // never go below minTimer
        stepTime = Math.max(stepTime, minTimer);

        // get current time and calculate desired end time
        var startTime = new Date().getTime();
        var endTime = startTime + duration;
        var timer;

        function run() {
            var now = new Date().getTime();
            var remaining = Math.max((endTime - now) / duration, 0);
            var value = Math.round(end - (remaining * range));
            if (id.indexOf("percent") != -1) {
                let value1 = value;
                value1 += "%"
                // console.log("Value is", value1, value, end)
                obj.innerHTML = value1;
            } else {
                obj.innerHTML = value;
            }
            if (value == end) {
                clearInterval(timer);
            }
        }

        timer = setInterval(run, stepTime);
        run();
    }
}

var addReporter = function (r) {
    $('#reportersList').html('');
    for (var i = 0; i < r.length; i++) {
        var x = 0;
        if (r[i][2]) x = r[i][2];
        console.log(('<tr> <td>' + r[i][0] + '</td> <td>' + r[i][1] + '</td> <td>' + r[i][2] + '</td> </tr>'))
        $('#reportersList').append('<tr> <td>' + r[i][0] + '</td> <td>' + r[i][1] + '</td> <td>' + x + '</td> </tr>')
    }
}
var approvedReportCount;
var totalReportCount;
var percent;
var totalReport = function (startDate, endDate) {
    console.log("startDate endDate", startDate, endDate)
    api.home.totalReport({ startDate, endDate }, function (success) {
        if (success) {
            totalReportCount = success.reportedMailCount;
            approveReport(success.reportedMailCount, startDate, endDate)
            animateValue("totalReports", 0, success.reportedMailCount, 1000);
            topReport(startDate, endDate);
        }
    }, function (err) {
        console.log("loadInbox -> err", err)
    })
}
var pendingReport = function (startDate, endDate) {
    api.home.pendingCount({ startDate, endDate }, function (success) {
        if (success) {
            animateValue("pendingReport", 0, success.pendingMailCount, 1000);

        }
    }, function (err) {
        console.log("loadInbox -> err", err)
    })
}
var approveReport = function (total, startDate, endDate) {
    $('#percent').html(null)
    api.home.approveCount({ startDate, endDate }, function (success) {
        if (success) {
            var percent = 0;
            if (success.approveMailCount > 0) {
                percent = (Math.round(success.approveMailCount * 100) / total).toFixed(0);
            }
            console.log("approveReport", success, percent, startDate, endDate);
            // $('#approvedCount').html(success.approveMailCount)
            animateValue("approvedCount", 0, success.approveMailCount, 1000);
            animateValue("percent", 0, percent, 1000);
            // $('#percent').append('%')
        }
    }, function (err) {
        console.log("loadInbox -> err", err)
    })
}
var declineReport = function (startDate, endDate) {
    api.home.declineCount({ startDate, endDate }, function (success) {
        if (success) {
            var percent = 0;
            if (success.declineMailCount > 0) { }
            // $('#declinedCount').html(success.declineMailCount)
            animateValue("declinedCount", 0, success.declineMailCount, 1000);
        }
    }, function (err) {
        console.log("loadInbox -> err", err)
    })
}
var monthReport = function (startDate, endDate) {
    api.home.monthReport({ startDate, endDate }, function (success) {
        if (success) {
            monthlyThreats(success.monthlyReport);
        }
    }, function (err) {
        console.log("loadInbox -> err", err)
    })
}
var topReport = function (startDate, endDate) {
    console.log("Top report")
    api.home.topReport({ startDate, endDate }, function (success) {
        if (success) {
            $('#list').html('');
            success.topReportedMail.forEach(element => {
                console.log('((element.reportedByCount / totalReportCount) * 100).toFixed(0)', element.reportedByCount, totalReportCount, ((element.reportedByCount / totalReportCount) * 100).toFixed(0))
                // $('#list').append('<tr> <td>' + element.reportedBy + '</td> <td> <div class="badge badge-pass">' + element.reportedByCount + '</div></td> </tr>')
                $('#list').append('<p>' + element.reportedBy + ' <span class="float-right">' + ((element.reportedByCount / totalReportCount) * 100).toFixed(0) + '%</span></p><div class="progress mb-2" style="height: 8px;"><div class="progress-bar back_color" role="progressbar" style="width: ' + ((element.reportedByCount / totalReportCount) * 100) + '%;" aria-valuenow="' + ((element.reportedByCount / totalReportCount) * 100).toFixed(0) + '" aria-valuemin="0" aria-valuemax="100"></div></div>')
            });

        }
    },
        function (err) {
            console.log("loadInbox -> err", err)
        })
}

var recentReportedMails = function (startDate, endDate) {
    api.home.recentReportedMails({ startDate, endDate }, function (success) {
        if (success) {
            $('#recentReportedMails').html('');
            success.data.forEach(element => {
                let badge = "badge-warning";
                if (element.approvalStatus == 'declined')
                    badge = "badge-danger";
                else if (element.approvalStatus == 'approved')
                    badge = "badge-success";

                // $('#recentReportedMails').append('<tr> <td>' + element.subject + '</td> <td>' + element.senderId + ' </td> </tr>')
                $('#recentReportedMails').append('<tr><td>' + HtmlEncode(element.subject) + '</td><td><span class="badge  ' + badge + '">' + element.approvalStatus + '</span></td>  <td>' + element.senderId + '</td></tr>')
            });
        }
    }, function (err) {
        showErrors(err, "This is Error")
    })

}

var monthlyThreats = (data) => {
    try {
        Morris.Bar({
            element: 'bar-example',
            data: data,
            xkey: 'year',
            ykeys: ['reported', 'Approve', 'declined',],
            labels: ['reported', 'Approve', 'declined',],
            barColors: ['#cc910e', '#8a9615', '#8e2c0d',],
            gridLineColor: 'rgba(0,0,0,0.1)',
            gridTextColor: "#8A98AC",
            hideHover: 'auto',
            resize: true
        });

    } catch (err) { }

}




var spamOrHamp = function () {
    api.home.spamOrHamp(undefined, function (success) {
        if (success) {
            var spam = 0,
                ham = 0
            if (success.reportedMail) {
                console.log(success.reportedMail)
                success.reportedMail.forEach(element => {
                    if (element.Body) {
                        if (element.Body.spamOrHam == 'spam' && element.Body.spamOrHam != null) {
                            spam = spam + 1;
                        }
                        if (element.Body.spamOrHam == 'ham' && element.Body.spamOrHam != null) {
                            ham = ham + 1;
                        }
                    }
                });
                var ctx = document.getElementById('myChart').getContext('2d');
                var myChart = new Chart(ctx, {
                    type: 'pie',
                    data: {
                        labels: ['ham', 'spam'],
                        datasets: [{
                            label: '# of Votes',
                            data: [ham, spam],
                            backgroundColor: [
                                '#10c469',
                                '#b71c1c'
                            ]
                        }]
                    },
                });
            }
        }
    }, function (err) {
        console.log("loadInbox -> err", err)
    })
}

function setGraphValue(data) {
    console.log("(Number(data.mailboxSecured) / Number(data.totalMails) / 100)", (Number(data.mailboxSecured) / Number(data.totalMails) / 100));
    var options = {
        chart: {
            height: 300,
            type: 'radialBar',
        },
        plotOptions: {
            radialBar: {
                dataLabels: {
                    name: {
                        fontSize: '15px',
                        fontFamily: 'Muli',
                    },
                    value: {
                        fontSize: '16px',
                        fontFamily: 'Muli',
                    },
                    total: {
                        show: true,
                        label: 'Mailbox Secured',
                        formatter: function (w) {
                            return data.mailboxSecured != null ? data.mailboxSecured : 0
                        }
                    }
                }
            }
        },
        colors: ['#4fb68a', '#f1be64'],
        series: [(Number(data.mailboxSecured) / Number(data.totalMails) * 100).toFixed(0), (((Number(data.totalMails) - Number(data.mailboxSecured)) / (Number(data.totalMails))) * 100).toFixed(0)],
        labels: ['Mailbox Secured', 'In Progress'],
    }
    try {
        var chart = new ApexCharts(
            document.querySelector("#apex-radial-chart"),
            options
        );
        chart.render();
    } catch (err) { }
}

function mailboxSecuredCounts(startDate, endDate) {
    console.log("Inside mailboxSecuredCounts", startDate, endDate);
    // if (startDate != undefined && endDate != undefined)
    //     $("#apex-radial-chart").css({ display: "none" })
    api.aggregateReports.mailboxAnalysis({ startDate, endDate }, function (success) {
        if (success) {
            let securePercent = Math.ceil((Number(success.mailboxSecured) / Number(success.totalMails)) * 100);
            console.log("Response got mailboxSecuredCounts", success);
            $("#totalMailbox").html(Number(success.totalMails));
            $("#beforeTab").html(Number(success.totalMails));
            $("#mailboxSecured").html(Number(success.mailboxSecured));
            $("#mailboxNotSecured").html(Number(success.totalMails) - Number(success.mailboxSecured));
            $("#afterTab").html(Number(success.totalMails) - Number(success.mailboxSecured));
            $("#securePercent").html(securePercent + (securePercent >= 0 ? '% <span class="icon_up"><i class="fa fa-arrow-up" aria-hidden="true"></i></span>' : '%<span class="icon_down"><i class="fa fa-arrow-down" aria-hidden="true"></i></span>'))
            setGraphValue(success);
        }
    }, function (err) {
        showErrors(err, "This is Error")
    })
}

function drawGraph(data) {
    console.log("Graph data to plot", data);
    var options = {
        colors: ['#f3c578'],
        series: [{
            name: "Mails Reported",
            data: data.counts,
        }],
        chart: {
            type: 'area',
            backgroundColor: '#000',
            stacked: false,
            height: 335,
            toolbar: {
                show: false
            },
        },
        dataLabels: {
            enabled: false
        },
        stroke: {
            curve: 'straight'
        },
        title: {
            text: 'Daily Mail Reported',
            align: 'left'
        },
        markers: {
            size: 0,
        },
        grid: {
            row: {
                colors: ['#f3f3f3', 'transparent'], // takes an array which will be repeated on columns
                opacity: 0.5
            },
        },

        xaxis: {
            categories: data.dates,
        }
    };

    try {
        var chart = new ApexCharts(document.querySelector("#chart"), options);
        chart.render();
    } catch (err) { }
}

function dailyReportedMailCount(startDate, endDate) {
    console.log("Inside dailyReportedMailCount", startDate, endDate);
    // if (startDate != undefined && endDate != undefined)
    //     $("#chart").css({ display: "none" });
    api.aggregateReports.dailyReport({ startDate, endDate }, function (success) {
        if (success) {
            console.log("Response got dailyReportedMailCount", success);
            drawGraph(success);
            // $("#chart").css({ display: "flex" });
        }
    }, function (err) {
        showErrors(err, "This is Error")
    })
}

$(document).ready(function () {
    // var startDate = window.localStorage.getItem("startDate");
    // var endDate = window.localStorage.getItem("endDate");
    // if (window.location.href.indexOf("/reported") != -1 || window.location.href.indexOf("/approved") != -1 || window.location.href.indexOf("/declined") != -1 || window.location.href.indexOf("/header-analytics") != -1 || window.location.href.indexOf('/scanned-results-analytics') != -1 || window.location.href.indexOf('/gctx') != -1) {} else {
    console.log('window.location.href.indexOf("/")', window.location.href.indexOf("/gctx"));
    if (window.location.href.indexOf("/gctx") == -1 && window.location.href.indexOf("/blacklist") == -1 && window.location.href.indexOf("/settings") == -1 && window.location.href.indexOf("/users") == -1 && window.location.href.indexOf("/policy") == -1 && window.location.href.indexOf("/advance-search") == -1) {
        $("#infobar-settings-open").show();
    }
    if (!(window.location.href[window.location.href.lastIndexOf("/") + 1]) || window.location.href.indexOf("/home") != -1) {
        totalReport(startDate, endDate);
        pendingReport(startDate, endDate);
        declineReport(startDate, endDate);
        monthReport(startDate, endDate);
        recentReportedMails(startDate, endDate);
        mailboxSecuredCounts(startDate, endDate);
        dailyReportedMailCount(startDate, endDate);
    }
});