var email = null;
var alias = null;
var logindata = null;
let searchParams = new URLSearchParams(window.location.search)


var validate = function() {
    clearErrors();
    var data = new Object();
    data.email = $('#email').val();
    if (data.email.length == 0) {
        hidePageLoader()
        addError('email', 'Please Enter Email Id');
    }
    hasError() && showErrors();
    return data
}

var sendOtpLink = function() {
    var data = validate();
    !hasError() && api.auth.otpLink(data, function(success) {
        if (success.isNewUser == 1) {
            showSuccess(success.msg);
        }
    });
}

var validateLogin = function(employee) {
    clearErrors();
    var data = new Object();
    data.email = $('#email').val() ? $("#email").val() : $("#email-2").val();
    if (data.email.length == 0) {
        hidePageLoader()
        addError('email', 'Please Enter Email');
    }
    if (employee) {
        data.alias = $('#alias').val();
        if (data.alias.length == 0) {
            hidePageLoader()
            addError('Alias', 'Please Enter Alias');
        }
    }
    data.password = $('#password').val();
    if (data.password.length == 0) {
        hidePageLoader()
        addError('password', 'Please Enter Password');
    }
    hasError() && showErrors();
    return data;
}

var loginwithOTP = function(recoveryCodeLogin) {
    showPageLoader();
    var otp;
    logindata.otp = $('#otp').val();
    logindata.recovery_code = recoveryCodeLogin ? true : false;
    if (logindata.otp.length == 0) {
        showError('Please enter a OTP');
    }
    var newlogindata = logindata;
    api.auth.loginwithOTP(logindata, function(logindata) {
        !hasError() && api.auth.rootLogin(newlogindata, function(data) {
            hidePageLoader()
            window.location = '/';
        }, function(err) {
            hidePageLoader();
            if (err.errors) showError(err.errors);
            $('#otp').css({ 'border': '1px solid red' });
            $("#otp").focus();
        })
    }, function(err) {
        console.log("Error", err);
        hidePageLoader();
        if (err.errors) showError(err.errors);
        if (err.success != 1) showError(err.message)
        $('#otp').css({ 'border': '1px solid red' });
        $("#otp").focus();
    })
}


var checkOTP = function(email, done) {
    var data = new Object();
    data.email = email;
    !hasError() && api.auth.checkOTPforlogin(data, function(data) {
        if (data.success == 1) done(data.twoFA);
        else done(false);
    }, function(err) {
        console.log("Some error occured", err);
        hidePageLoader();
        if (err.errors) showError(err.errors);
    })
}


var resendOTP = function() {
    api.auth.OTPresend(logindata, function(data) {
        showError("OTP has been sent!")
        $("#resendOTP").click(function() {
            var that = this;
            $(this).attr("disabled", true);
            setTimeout(function() { enableSubmit(that) }, 50000);
        });

    }, function(err) {
        hidePageLoader();
        if (err.errors) showError(err.errors);
    })
}

var enableSubmit = function(ele) {
    $(ele).removeAttr("disabled");
}


var rootLogin = () => {
    showPageLoader();
    logindata = validateLogin(false);
    checkOTP(logindata.email, function(r) {
        if (r == 1) {
            api.auth.sendOTP(logindata, function(data) {
                $('#usersignin').html('<div class="text-center mb-4"><h4 class="mt-0">OTP Verification</h4><p>OTP sent to your email address.</p></div><div class="form-group mb-3"><label for="email">OTP (One Time Password)</label> <input class="form-control" type="text" id="otp" maxlength="7"required="" placeholder="Enter your otp"> </div><div class="form-group mb-0 text-center"><button type="button" class="btn btn-auth-l" onclick="loginwithOTP()">Continue</button><button type="button" id="resendOTP" class="btn btn-auth-l" onclick="resendOTP()">Resend OTP</button> </div>')
                hidePageLoader();
                $("#otp").focus();
            }, function(err) {
                hidePageLoader();
                if (err.errors) showError(err.errors);
            })
        } else if (r == 2) {
            $('#usersignin').html('<div class="text-center mb-4"><h4 class="mt-0">OTP Verification</h4><p>OTP on your google authenticator app</p></div><div class="form-group mb-3"><label for="email">OTP (One Time Password)</label> <input class="form-control" type="text" id="otp" maxlength="7"required="" placeholder="Enter your otp"> </div><div class="form-group mb-0 text-center"><button type="button" class="btn btn-auth-l" onclick="loginwithOTP()">Submit</button><button type="button" class="btn btn-auth-l" onclick="loginwithRecoveryCode()">Have recovery code?</button></div>')
            hidePageLoader();
            $("#otp").focus();
        } else {
            !hasError() && api.auth.rootLogin(logindata, function(data) {
                hidePageLoader()
                window.location = '/';
            }, function(err) {
                console.log("Some error occured", err);
                hidePageLoader();
                if (err.errors) showError(err.errors);
            })
        }
        $('#otp').keypress(function(event) {
            var keycode = (event.keyCode ? event.keyCode : event.which);
            if (keycode == '13') {
                loginwithOTP();
            }
        });
    });
}

function loginwithRecoveryCode() {
    $('#usersignin').html('<div class="text-center mb-4"><h4 class="mt-0">OTP Verification</h4><p>Please enter one recovery code</p></div><div class="form-group mb-3"><label for="email">Recovery Code</label> <input class="form-control" type="text" id="otp" required="" placeholder="Enter recovery code"> </div><div class="form-group mb-0 text-center"><button type="button" class="btn btn-auth-l" onclick="loginwithOTP(true)">Submit</button></div>')
}

function login() {
    showPageLoader();
    var data = validateLogin(true);
    !hasError() && api.auth.login(data, function(data) {
        hidePageLoader()
        window.location = '/';
    }, function(err) {
        hidePageLoader();
        if (err.errors) showError(err.errors);
    })
}

var step2 = function() {
    showPageLoader();
    var data = validate();
    !hasError() && api.auth.rootCheck(data, function(data) {
        console.log("data",data)
        hidePageLoader()
        if (data.success == true && data.redirect == false) {
            if (data.isNewUser) {
                return sendOtpLink();
            }
            email = data.email;
            // $('#usersignin').html('<div class="text-center mb-4"> <h4 class="mt-0">Root user sign in</h4> </div> <div class="form-group mb-3"> <label for="email">Email</label> <input class="form-control" type="email" disabled id="email" required="" placeholder="Enter your email"> </div> <div class="form-group mb-3"> <label for="password">Password</label> <input class="form-control" type="password" id="password" required="" placeholder="Enter your password"> </div> <div class="form-group mb-3"> <a href="/password/reset">Forgot Password ?</a> </div> <div class="form-group mb-0 text-center"> <button type="button"  onclick="rootLogin()" class="btn btn-auth-l">Log In</button> </div>')
            $("#usersignin-withpass").css({ "display": "block" })
            $("#usersignin").css({ "display": "none" })
            $("#password").focus()
            $('#email-2').val(email);

            $('#password').keypress(function(event) {
                var keycode = (event.keyCode ? event.keyCode : event.which);
                if (keycode == '13') {
                    rootLogin();
                }
            });
        } else if (data.success == false && data.redirect == true) {
            alias = data.alias;
            $('#usersignin').html('<div class="text-center mb-4"> <h4 class="mt-0">Sign in to your account</h4> </div> <div class="form-group mb-3"> <label for="alias">Account ID or alias</label> <input class="form-control" type="text" id="alias" required="" placeholder="Enter your alias"> </div> <div class="form-group mb-3"> <label for="email">Email</label> <input class="form-control" type="email" id="email" required="" placeholder="Enter your email"> </div> <div class="form-group mb-3"> <label for="password">Password</label> <input class="form-control" type="password" id="password" required="" placeholder="Enter your password"> </div> <div class="form-group mb-3"> <a href="/password/reset">Forgot Password ?</a> </div> <div class="form-group mb-0 text-center"> <button type="button" onclick="login()" class="btn btn-auth-l">Log In</button> </div>')
            $('#alias').val(alias);

            $('#password').keypress(function(event) {
                var keycode = (event.keyCode ? event.keyCode : event.which);
                if (keycode == '13') {
                    login();
                }
            });
        }
    }, function(err) {
        hidePageLoader();
        if (err.msg) showError(err.msg);
        else if (err.name) showError("Please Enter a valid Email ID")
    })
}

var step1 = function() {
    if (searchParams.get('alias') && searchParams.get('alias').length) {
        console.log("Inside link login",searchParams.get('alias'))
        $('#usersignin').html('<div class="text-center mb-4"> <h4 class="mt-0">Sign in to your account</h4> </div> <div class="form-group mb-3"> <label for="alias">Account ID or alias</label> <input class="form-control" type="text" id="alias" required="" placeholder="Enter your alias" > </div> <div class="form-group mb-3"> <label for="email">Email</label> <input class="form-control" type="email" id="email" required="" placeholder="Enter your email"> </div> <div class="form-group mb-3"> <label for="password">Password</label> <input class="form-control" type="password" id="password" required="" placeholder="Enter password"> </div> <div class="form-group mb-3"> <a href="/password/reset">Forgot Password ?</a> </div> <div class="form-group mb-0 text-center"> <button type="button" onclick="login()" class="btn btn-auth-l">Log In</button> </div>')
        $("#usersignin").css({ "display": "block" })
        $("#email").focus();
        $('#alias').val(searchParams.get('alias'));
        $('#password').keypress(function(event) {
            var keycode = (event.keyCode ? event.keyCode : event.which);
            if (keycode == '13') {
                login();
            }
        });
    } else {
        $("#usersignin").css({ "display": "block" })
        $("#email").focus();
        // $('#usersignin').html('<div class="text-center mb-4"> <h4 class="mt-0">Log in to Your Account</h4> <p>Log in to your account so you can continue securing <br> your valuable emails.</p> </div> <div class="form-group mb-3"> <label for="email">Email</label> <input class="form-control" type="email" id="email" required="" placeholder="Enter your email"> </div>  <div class="form-group mb-0 text-center"> <button type="button" class="btn btn-auth-l" onclick="step2()" >Next</button> </div>')
    }
}

$('#email').keypress(function(event) {
    var keycode = (event.keyCode ? event.keyCode : event.which);
    if (keycode == '13') {
        step2();
    }
});

$(document).ready(function() {
    step1();
});