var monthNames = ["Jan", "Feb", "Mar", "Apr", "May", "June", "July", "Aug", "Sept", "Oct", "Nov", "Dec"];
var count = 0;

var validate = function () {
    clearErrors();
    var data = new Object();
    data.search = $('#searchBar').val();
    if (data.search.length < 3) {
        data.search = undefined;
    }
    data.status="pending";
    data.sort = "recent";
    data.page = getPageNo();
    data.limit = getLimit();
    hasError() && showErrors();
    return data;
}
var clearInbox = function () {
    $('.message-list').html('')
}
var parseDate = function (mailDate) {
    var mailDate = new Date(mailDate);
    var year = mailDate.getFullYear();
    var todayYear = new Date().getFullYear();
    var month = mailDate.getUTCMonth();
    var todayMonth = new Date().getUTCMonth();
    var day = mailDate.getUTCDate();
    var todayDay = new Date().getUTCDate();
    mailDate = monthNames[mailDate.getMonth()] + ' ' + mailDate.getUTCDate();
    if (year != todayYear) mailDate = mailDate + ' ' + year;
    if (year == todayYear && month == todayMonth && day == todayDay) mailDate = new Date(mailDate).toLocaleString('en-US', { hour: 'numeric', minute: 'numeric', hour12: true })
    return mailDate;
}
var addMails = function (data) {
    if (data) {
        var mailDate = 'Feb 1';
        var sender= (data && data.Header && data.Header.SenderId &&  data.Header.SenderId.senderId) ? data.Header.SenderId.senderId : 'Sender not found.';
        var status = '<div class="status badge-pass">Processed</div>'
        var dmarc ='<div class="dmarc badge-fail">DMARC-Fail</div>';
        var dkim =  '<div class="dkim badge-fail">DKIM-FAIL</div>'
        var spf = '<div class="spf badge-fail">SPF-Fail</div>';
        if (data.status == 'processed') status = '<div class="status badge-pass">Processed</div>';
        else if (data.status == 'unprocessed') status = '<div class="status badge-fail">Unprocessed</div>';
        if (data.Header.mailTime) mailDate = parseDate(data.Header.mailTime)
        if(data.Header.dmarc && data.Header.dmarc == 'pass') dmarc ='<div class="dmarc badge-pass">DMARC-PASS</div>'
        if(data.Header.spf && data.Header.spf == 'pass' ) spf='<div class="spf badge-pass">SPF-PASS</div>'
        if( data.Header.dkim && data.Header.dkim == 'pass' ) dkim='<div class="dkim badge-pass">DKIM-PASS</div>';
        $('.message-list').append('<li class="inbox-item"> <div class="checkbox-wrapper-mail" onclick=" selectAction(`delete`,'+data.id+')" > <i class="mdi mdi-delete mx-auto"></i></div> <div class="li-data w-100" onclick="setMail('+data.id+')" id="inbox-5"> <div class="mail-col mail-col-1"><span class="dot"></span> <p class="title"> ' +sender+ ' </p> </div> <div class="mail-col mail-col-2"> <div class="subject">' + data.Header.subject + ' <span class="teaser"></span></div> ' + status + ' '+spf+dmarc+dkim+' <div class="date">' + mailDate + '</div>  </div> </div><div class="selectInput"> <select class="form-control" onclick="if (typeof(this.selectedIndex) != `undefined`) selectAction(this.value,'+ data.id+')" ><option selected="true" disabled="disabled" >Actions</option>  <option value="Block Domain" >Block Domain</option> <option value="Block Sender" >Block Sender</option> </select>  </div> </li>')
        // $('.message-list').append(' <li class="inbox-item"><div class="checkbox-wrapper-mail"  data-toggle="modal" onclick=selectDeleteMail('+data.id+') data-target="#deleteModal" > <i class="mdi mdi-delete mx-auto"></i></div><div class="li-data w-100" onclick="setMail(' + data.id + ')" id="inbox-'+data.id+'"><div class="mail-col mail-col-1"><span class="dot"></span><p class="title">' + data.Header.sender + '</p></div><div class="mail-col mail-col-2"><div class="subject">' + data.Header.subject + ' <span class="teaser"></span></div>'+dmarc+''+dkim+''+spf+'<div class="date">' + mailDate + '</div> ' + status + '</div></div></li>');
    }
}
var load = function () {
    var data = validate();
    showPageLoader();
    api.inbox.list(data, function (success) {
        hidePageLoader();
        clearInbox();
        for (var i = 0; i < success.mails.length; i++) {
            addMails(success.mails[i]); 
        }
        mailCount=success.count;
        addPagination(success.pages, success.count);
        inboxInit();
    }, function (err) {
        hidePageLoader();
        console.log("loadInbox -> err", err)
    })
}
$(document).ready(function () {
    load();
});
