var otptype = null;
var checkEnableApp = false;
var checkEnableEmail = false;

var makeid = () => {
    var text = "";
    var possible = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";
    for (var i = 0; i < 4; i++)
        text += possible.charAt(Math.floor(Math.random() * possible.length));
    return text;
}

var validateProfile = function() {
    clearErrors();
    var data = new Object();
    data.firstname = $('#firstName').val();
    if (data.firstname.length == 0) {
        addError('firstName', 'First Name is required field');
    }
    data.lastname = $('#lastName').val();
    if (data.lastname.length == 0) {
        addError('lastName', 'Last Name  is required field');
        data.html = undefined;
    }
    hasError() && showErrors();
    return data;
}

function validatePassword(password) {
    if (password.length < 8) {
        addError('password', 'Your password must be at least 8 characters');
    } else if (password.search(/[a-z]/i) < 0) {
        addError('password', 'Your password must contain at least one letter.');
    } else if (password.search(/[0-9]/) < 0) {
        addError('password', 'Your password must contain at least one digit.');
    }
}

var passwordValid = function() {
    clearErrors();
    var data = new Object();
    data.oldpassword = $('#oldpassword').val();
    if (data.oldpassword.length == 0) {
        addError('oldpassword', 'Please enter Current Password!');
    }
    data.password = $('#newpassword').val();
    if (data.password.length == 0) {
        addError('newpassword', 'Please enter New Password!');
        data.html = undefined;
    }
    var confirmpassword = $('#confirmpassword').val();
    if (data.password.length == 0) {
        addError('confirmpassword', 'Please enter Confirm Password!');
    }
    if (confirmpassword != data.password) {
        addError('confirmpassword', 'Password and Confirm Password do not match');
    }
    if (!hasError()) validatePassword(data.password)
    hasError() && showErrors();
    return data;
}

var changePassword = function() {
    var data = passwordValid();
    !hasError() && api.setting.changePassword(data, function(success) {
        showSuccess('Password has been updated!');
    }, function(err) {
        console.log(err);
    })
}

var metaAuthvalidate = function() {
    clearErrors();
    var data = new Object();
    data.metaAuth1 = $('#metaAuth').val()
    if (data.length == 0) {
        addError('metaAuth', ' Please enter SOC email ID!');
    }
    data.metaAuth2 = $('#metaAuth1').val()
    data.metaAuth3 = $('#metaAuth2').val()
    hasError() && showErrors();
    return data;
}

var MetaAuth = function() {
    var data = metaAuthvalidate();
    !hasError() && api.setting.metaAuth(data, function(success) {
        showSuccess(success.success);
    }, function(err) {
        console.log(err);
    })
}
var downloadkey = function() {
    fetch('dashapi/setting/downloadpem/')
        .then(function(resp) {
            resp.blob()
        })
        .then(function(blob) {
            const url = window.URL.createObjectURL(blob);
            const a = document.createElement('a');
            a.style.display = 'none';
            a.href = url;
            a.download = "public.txt";
            document.body.appendChild(a);
            a.click();
            window.URL.revokeObjectURL(url);
        })
        .catch();
}
var generatekey = function() {
    !hasError() && api.setting.generatekey(undefined, function(success) {
        showSuccess('Generated has been updated!');
    })
}



var enableSubmit = function(ele) {
    $(ele).removeAttr("disabled");
}


function saveProfile() {
    var data = validateProfile();
    !hasError() && api.setting.profileUpdate(data, function(success) {
        $("#Update_information_button").click(function() {
            var that = this;
            $(this).attr("disabled", true);
            setTimeout(function() { enableSubmit(that) }, 4000);
        });
        showSuccess('Profile has been updated!');
    })
}

$('.copy').on('click', function(event) {
    copyToClipboard(event);
});

function copyToClipboard(e) {
    var t = e.target,
        c = t.dataset.copytarget,
        inp = (c ? document.querySelector(c) : null);
    if (inp && inp.select) {
        inp.select();
        try {
            document.execCommand('copy');
            inp.blur();
            t.classList.add('copied');
            setTimeout(function() {
                t.classList.remove('copied');
            }, 1500);
        } catch (err) {
            alert('please press Ctrl/Cmd+C to copy');
        }
    }
}

$('form').submit(function(e) { e.preventDefault(); });

var validateExchange = function() {
    clearErrors();
    var data = new Object();
    data.eId = $('#exchange_id').val();
    if (data.eId.length == 0) {
        addError('exchange_id', 'Please enter Exchange Id!')
    }
    data.epass = $('#exchange_password').val();
    if (data.epass.length == 0) {
        addError('exchange_password', 'Please enter Exchange Password!');
    }
    if (data.epass == "****") data.epass = "";
    data.eBackupId = $('#exchange_backup_id').val();
    if (data.eBackupId.length == 0) {
        addError('exchange_backup_id', 'Please enter Backup Mail ID!');
    }
    data.eMailFolder = $('#exchange_mail_folder').val();
    if (data.eMailFolder.length == 0) {
        addError('exchange_mail_folder', 'Please enter Backup Mail Folder!');
    }
    hasError() && showErrors();
    return data;
}
var updateExchangeKey = function() {
    var data = validateExchange();
    !hasError() && api.setting.setExchange(data, function(success) {
        load();
        outlookSignin();
        showSuccess("Exchange credentials updated.")
    }, function(err) {
        showErrors(err);
    })
}

function outlookSignin() {
    let host = "http://localhost:4007"
    if (window.location.host.indexOf("localhost") == -1)
        host = window.location.protocol + "//" + window.location.host;
    console.log("host is", host)
    window.open(host + '/outlook/graph/generate-access-token', 'popUpWindow', 'height=500,width=400,left=100,top=100,resizable=yes,scrollbars=yes,toolbar=yes,menubar=no,location=no,directories=no, status=yes')
}

var load = function() {
    console.log("Inside load");
    api.setting.getExchange(undefined, function(success) {
        if (success && success.success) {
            // console.log("Exchange data", success);
            for (var i = 0; i < success.data.length; i++) {
                if (success && success.data[i] && success.data[i]['key']) {
                    if (success.data[i]['key'] == 'userName') { $('#exchange_id').val(success.data[i]['value']) }
                    if (success.data[i]['key'] == 'password') { $('#exchange_password').val("****") }
                    if (success.data[i]['key'] == 'targetMailbox') { $('#exchange_backup_id').val(success.data[i]['value']) }
                    if (success.data[i]['key'] == 'targetFolder') { $('#exchange_mail_folder').val(success.data[i]['value']) }
                    if (success.data[i]['key'] == 'socEmailAlert0') { $('#metaAuth').val(success.data[i]['value']) }
                    if (success.data[i]['key'] == 'socEmailAlert1') { $('#metaAuth1').val(success.data[i]['value']) }
                    if (success.data[i]['key'] == 'socEmailAlert2') { $('#metaAuth2').val(success.data[i]['value']) }
                    if (success.data[i]['key'] == 'hackButton' && success.data[i]['value'] == "true") { $('#hackButton').prop("checked", success.data[i]['value']) }
                    if (success.data[i]['key'] == 'spf' && success.data[i]['value'] == "true") { $('#serverButton').prop("checked", success.data[i]['value']) }
                    if (success.data[i]['key'] == 'dkim' && success.data[i]['value'] == "true") { $('#dkimButton').prop("checked", success.data[i]['value']) }
                    if (success.data[i]['key'] == 'dmarc' && success.data[i]['value'] == "true") { $('#emailButton').prop("checked", success.data[i]['value']) }
                    if (success.data[i]['key'] == 'content' && success.data[i]['value'] == "true") { $('#contentButton').prop("checked", success.data[i]['value']) }
                    if (success.data[i]['key'] == 'dkimalign' && success.data[i]['value'] == "true") { $('#dkimalignButton').prop("checked", success.data[i]['value']) }
                    if (success.data[i]['key'] == 'spfalign' && success.data[i]['value'] == "true") { $('#spfalignButton').prop("checked", success.data[i]['value']) }
                    if (success.data[i]['key'] == 'gctx' && success.data[i]['value'] == "true") { $('#gctxButton').prop("checked", success.data[i]['value']) }
                    if (success.data[i]['key'] == 'reportedby' && success.data[i]['value'] == "true") { $('#reportedbyButton').prop("checked", success.data[i]['value']) }
                    if (success.data[i]['key'] == 'country' && success.data[i]['value'] == "true") { $('#countryButton').prop("checked", success.data[i]['value']) }
                    if (success.data[i]['key'] == 'attachments' && success.data[i]['value'] == "true") { $('#scanAttachments').prop("checked", success.data[i]['value']) }
                    if (success.data[i]['key'] == 'score' && success.data[i]['value'] == "true") { $('#mailScore').prop("checked", success.data[i]['value']) }

                    if (success.data[i]['key'] == 'outlookAccessToken' && success.data[i]['value'] == "true") {
                        $('#exchangeCredForm').css({ "display": "none" });
                        $("#outllookLoginBtn").css({ "display": "none" });
                        $("#outlookBtn").css({ "display": "none" });
                        $("#outlookLoggedIn").css({ "display": "block" });
                        $("#outlookBtnLogout").css({ "display": "block" });
                        $("#outlookLoggedIn").html("Logged In With " + window.localStorage.getItem("outlook-user"));
                    } else {
                        $('#exchangeCredForm').fadeIn("fast");
                        $("#outllookLoginBtn").fadeIn("fast");
                        $("#outlookBtn").fadeIn("fast");
                        $("#outlookLoggedIn").fadeOut("fast");
                        $("#outlookBtnLogout").fadeOut("fast");
                    }
                }
            }
        } else {
            $('#exchangeBtn').html('Create Exchnage Credential ')
        }

        $('#twofactorshow').show();
        if (success && success.twoFA && success.twoFA != 0) {
            setTotpType(success.twoFA)
            $('#enable').hide();
            $('#disable').show();
            if (success.twoFA == 2) checkEnableApp = true
            if (success.twoFA == 1) checkEnableEmail = true
            console.log("checkEnable", checkEnableEmail, checkEnableApp);
        } else {
            $(`#app-type`).removeClass('active_verify');
        }
    }, function(err) {
        showErrors(err);
    })
}

$(document).ready(function() {
    load();
});

$(".toggle-password").click(function() {
    $(this).toggleClass("fa-eye fa-eye-slash");
    var input = $($(this).attr("toggle"));
    if (input.attr("type") == "password") {
        input.attr("type", "text");
    } else {
        input.attr("type", "password");
    }
});

var validateImap = function() {
    clearErrors();
    var data = new Object();
    $('#imap_imap').each(function() {
        this.checked;
        data.imap = this.checked;
    });
    data.imap_userID = $('#imap_userID').val();
    if (data.imap_userID.length == 0 && data.imap) {
        addError('imap_userID', 'User ID is required field');
    }
    data.imap_password = $('#imap_password').val();
    if (data.imap_password.length == 0 && data.imap) {
        addError('imap_password', 'Password is required field');
        data.html = undefined;
    }
    data.imap_host = $('#imap_host').val();
    if (data.imap_host.length == 0 && data.imap) {
        addError('imap_host', 'Host is required field');
        data.html = undefined;
    }
    data.imap_port = $('#imap_port').val();
    if (data.imap_port.length == 0 && data.imap) {
        addError('imap_port', 'Port is required field');
        data.html = undefined;
    }
    $('#imap_tls').each(function() {
        this.checked;
        data.imap_tls = this.checked;
    });
    hasError() && showErrors();
    return data;
}

function updateImap() {
    var data = validateImap();
    if (data.imap) {
        !hasError() && api.setting.imapUpdate(data, function(success) {
            showSuccess('IMAP has been updated!');
        }, function(err) {
            showErrors(err);
        })
    } else {
        !hasError() && api.setting.imapDisable(data, function(success) {
            showSuccess('IMAP has been Disbled!');
        }, function(err) {
            showErrors(err);
        })
    }
}

function validateReportConfig() {
    var data = new Object();
    $('#hackButton').each(function() {
        this.checked;
        data.hackButton = this.checked;
    });

    $('#serverButton').each(function() {
        this.checked;
        data.spf = this.checked;
    });

    $('#dkimButton').each(function() {
        this.checked;
        data.dkim = this.checked;
    });

    $('#emailButton').each(function() {
        this.checked;
        data.dmarc = this.checked;
    });

    $('#contentButton').each(function() {
        this.checked;
        data.content = this.checked;
    });

    $('#dkimalignButton').each(function() {
        this.checked;
        data.dkimalign = this.checked;
    });

    $('#spfalignButton').each(function() {
        this.checked;
        data.spfalign = this.checked;
    });

    $('#gctxButton').each(function() {
        this.checked;
        data.gctx = this.checked;
    });

    $('#reportedbyButton').each(function() {
        this.checked;
        data.reportedby = this.checked;
    });

    $('#countryButton').each(function() {
        this.checked;
        data.country = this.checked;
    });

    $('#scanAttachments').each(function() {
        this.checked;
        data.attachments = this.checked;
    });

    $('#mailScore').each(function() {
        this.checked;
        data.score = this.checked;
    });

    hasError() && showErrors();
    return data;
}


function reportConfig() {
    var data = validateReportConfig();
    !hasError() && api.setting.reportButtonConfig(data, function(success) {
        showSuccess('Report Button has been Configured!');
    }, function(err) {
        showErrors(err);
    })
}

function twoFactor() {
    $('#twoWayModal').modal('show');
    $('#twofactor').prop("checked", true);
}


function setTotpType(type) {
    otptype = type;
    if (type == 1) {
        $(`#mail-type`).addClass('active_verify');
        $(`#app-type`).removeClass('active_verify');
        if (checkEnableEmail) {
            console.log('if' + checkEnableEmail)
            $('#enable').hide();
            $('#disable').show();
        } else {
            console.log('else', checkEnableEmail)
            $('#enable').show();
            $('#disable').hide();
        }

    } else {
        $(`#app-type`).addClass('active_verify');
        $(`#mail-type`).removeClass('active_verify');
        if (checkEnableApp) {
            $('#enable').hide();
            $('#disable').show();
        } else {
            $('#enable').show();
            $('#disable').hide();
        }

    }

}

function save2WayVerification(status) {
    console.log("Inside save2WayVerification", otptype, status);
    var bool = $('.verification_twoway > li').hasClass('active_verify');
    if (bool) {
        var data = {};
        data.twoFA = status;
        checkEnableApp = false;
        if (otptype == 2 && status) {
            generateQr()
        } else {
            showPageLoader();
            !hasError() && api.setting.verifyAndUpdateTwoFa({ emailOtp: status }, function(success) {
                console.log("2FA verified", success);
                hidePageLoader();
                if (success.status == 200) {
                    hideModal()
                    showSuccess(success.message)
                    setTimeout(() => {
                        window.location.href = "/settings"
                    }, 1000)
                }
            })
        }

    } else {
        addError('err', 'Please select one authentication type');
        hasError() && showErrors();
    }

}

function generateQr() {
    !hasError() && api.setting.generateVerifcationCode({}, function(success) {
        console.log("success", success);
        $(".modal-body").html('<div class="contentbar">\
            <div class="card">\
               <!-- Breadcrumbbar -->\
              <div class="breadcrumbbar">\
                <div class="row align-items-center">\
                  <div class="col-md-8 col-lg-8">\
                    <h4 class="page-title">Authentication With Mobile <i class="mdi mdi-help-circle" aria-hidden="true" data-toggle="tooltip" title="" data-original-title="Setting"></i></h4>\
                  </div>\
                </div>\
              </div>\
              <!-- Breadcrumbbar -->\
              <div class="card-body">\
                <div class="authencation_mobile_verification">\
                  <a class="back_auth" onclick="showMainModal()"> <i class="fas fa-long-arrow-alt-left"></i> Back</a>\
                <h5 class="auth_ver_mobile">Authentication steps:</h5>\
                <ul class="auth_steps">\
                  <li>\
                    <p>1. Install an authenticator app on your mobile device</p>\
                  </li>\
                   <li>\
                     <p>2. Scan the following QR code in your authenticator app <b>(1 min validity)</b></hp>\
                     <img src="' + success.qrCode + '">\
                    </li>\
                   <li>\
                     <div class="form-group">\
                       <label>3. Enter the code from your authenticator app below<span id="error" style="color : red;"></span></label>\
                       <input type="text" class="form-control w-30" placeholder="Enter your code" id="otp">\
                     </div>\
                  </li>\
                </ul>\
                <button type="button" class="btn btn-success" onclick="verifyFormattedkeyToken()" style="background: #872E3C;outlone:none;border:1px solid #872E3C;">Enable</button>\
                </div>\
            </div>\
        </div>\
    </div>\
    <!-- End Contentbar -->');
        $("#otp").focus();
    }, function(err) {
        showErrors(err);
    });
}

function showMainModal() {
    $(".modal-body").html('<ul class="verification_twoway">\
            <li id="mail-type" onclick="setTotpType(1)">\
              <img src="/static/assets/images/email-img.png">\
              <h5 id="mailVer">Mail Verification</h5>\
            </li>\
            <li id="app-type" onclick="setTotpType(2)">\
              <img src="/static/assets/images/mobile-img.png">\
              <h5 id="authVer">Authentication with Mobile</h5>\
            </li>\
          </ul>\
          <div class="btn_ver">\
            <button type="button" class="btn btn-primary verify_way_btn" id="disable"\
              onclick="save2WayVerification(false)" style="display: none;">Disable</button>\
            <button type="button" class="btn btn-success verify_way_btn" id="enable"\
              onclick="save2WayVerification(true)"  style="background: #872E3C;outlone:none;border:1px solid #872E3C;">Enable</button>\
          </div>');
    setTotpType(otptype)
}

function verifyFormattedkeyToken() {
    clearErrors();
    let data = {}
    data.otp = $('#otp').val();
    if (data.otp.length == 0) {
        $('#otp').css({ 'border': '1px solid red' });
        $("#otp").focus();
        $("#error").html("<br>Code Required!")
    } else {
        $('#otp').css({ 'border': '1px solid black' });
        $("#error").html("")
        showPageLoader();
        !hasError() && api.setting.verifyAndUpdateTwoFa(data, function(success) {
            console.log("2FA verified", success);
            hidePageLoader();
            if (success.status == 200) {
                showRecoveryCodes(success)
            } else {
                $('#otp').css({ 'border': '1px solid red' });
                $("#otp").focus();
                $("#error").html("<br>Invalid Code!")
            }
        })
    }
}

function showRecoveryCodes(data) {
    var list = "";
    data.recoveryCodes.forEach(code => {
        list += "<li>" + code + "</li>"
    });
    console.log("Li formed", list)
    $(".modal-body").html('<div class="contentbar">\
            <div class="card">\
               <!-- Breadcrumbbar -->\
              <div class="breadcrumbbar">\
                <div class="row align-items-center">\
                  <div class="col-md-8 col-lg-8">\
                    <h4 class="page-title">Recovery Codes <i class="mdi mdi-help-circle" aria-hidden="true" data-toggle="tooltip" title="Use these codes if you are having trouble with google auth codes or it gets deleted from the app" data-original-title="Setting"></i>\
                    <span id="copy-code-msg">Codes Copied</span></h4>\
                  </div>\
                </div>\
              </div>\
              <!-- Breadcrumbbar -->\
              <div class="card-body">\
                <div class="authencation_mobile_verification">\
                <h5 class="auth_ver_mobile">SAVE YOUR BACKUP CODES<br>\
                Keep these backup codes somewhere safe but accessible.<br><br></h5>\
                <ul>' + list + '</ul>\
                <p><br>* You can only use each backup code once.</p>\
                <button type="button" class="btn btn-success" onclick="saveRecoveryCodes(' + "'" + data.recoveryCodes.toString() + "'" + ')">Copy</button>\
                <button type="button" class="btn btn-success" onclick="closeModal()">Done</button>\
                </div>\
            </div>\
        </div>\
    </div>\
    <!-- End Contentbar -->');
}

var codeCopied = false;

function saveRecoveryCodes(codes) {
    codes = codes.replace(/[ ,]/g, "\n");

    console.log("codes", codes)
    navigator.clipboard.writeText(codes).then(function() {
        console.log('Async: Copying to clipboard was successful!');
        codeCopied = true;
        console.log("codeCopied", codeCopied)
        $("#copy-code-msg").fadeIn();
        // After 3 seconds, remove the show class from DIV
        setTimeout(function() { $("#copy-code-msg").fadeOut() }, 2000);
    }, function(err) {
        console.error('Async: Could not copy text: ', err);
    });
}

function closeModal() {
    if (!codeCopied) {
        confirm("Kindly make sure that you have copied the code")
        return;
    }
    modalHide()
}

function modalHide() {
    hideModal()
    showSuccess("2FA Enabled Successfully")
    console.log("Show message done")
    setTimeout(() => {
        window.location.href = "/settings"
    }, 1000)
}

function hideModal() {
    $('#twoWayModal').modal('toggle');
}