import express from 'express';
import { jwtStrategy } from '../../../../middleware/strategy';
import { userImplant } from '../../../../middleware/auth';
import { tabLite } from '../../../../middleware/tabLite';
import { userPermission } from '../../../../middleware/userPermission';
import aggregateReportsController from './aggregateReports.controller';

export const aggregateReportsRouter = express.Router();
// aggregateReportsRouter.route('/header-analytics').get(loginCheck(), aggregateReportsController.headerAnalytics);
aggregateReportsRouter.route('/header-analytics').get(jwtStrategy, tabLite(), userImplant, userPermission('user-read'), aggregateReportsController.headerAnalytics);
aggregateReportsRouter.route('/scanned-results-analytics').get(jwtStrategy, tabLite(), userImplant, userPermission('user-read'), aggregateReportsController.scannedResultsAnalytics);