import { db } from "../../../../models";
import Audit from '../../../../modules/Audit';
var parser = require('ua-parser-js');

export default {
    async register(req, res) {
        res.render('register', { layout: 'auth' });
    },
    async login(req, res) {
        res.render('login', { layout: 'auth' });
    },
    async loginredirect(req, res) {
        res.redirect('/');
    },
    async change(req, res) {
        res.redirect('/')
    },
    async changepassword(req, res) {
        res.render('change-password', { layout: 'auth' });
    },
    async logout(req, res) {
        if (req.user) {
            req.user.update({ loggedOutAt: new Date() });
            try {
                await new Audit().saveAuditLog({ email: req.user.email, userId: req.user.id, companyId: "", EmployeeId: "", oldData: {}, newData: {}, metaData: parser(req.headers['user-agent']), activity: `user ${req.user.email} successfully logged out`, IP: req.headers['x-real-ip'] || req.connection.remoteAddress.split(`:`).pop() })
            } catch (err) {
                console.log("Error occured while saving audit", err);
            }
        }
        res.clearCookie("XSRF-token-tab");
        return res.redirect('/login');
    },
    async verifyMessage(req, res) {
        res.render('verify', { layout: 'auth' });
    },
    async sendReset(req, res) {
        res.render('sendReset', { layout: 'auth' });
    },
    async verify(req, res) {
        db.User.findOne({ where: { email: req.params.email, verf_key: req.params.token } })
            .then(user => {
                if (user) {
                    return db.User.update({ valid: 1 }, { where: { id: user.id } })
                } else {
                    throw {
                        name: 'PRAException',
                        msg: 'Invalid Request!'
                    }
                }
            })
            .then(r => {
                var verified = 0;
                if (r && r[0]) verified = r[0];
                return res.render('verifySuccess', { layout: 'auth', verified: verified, message: "Email Verified Successfully" });
            })
            .catch(err => {
                if (err && err.name && err.name == 'PRAException') {
                    return res.render('verifySuccess', { layout: 'auth', verified: 0, message: "Invalid token received" });
                } else {
                    console.log(err);
                    return res.render('verifySuccess', { layout: 'auth', verified: 0, message: "Invalid token received" });
                }
            })
    },

    async myRedirect(req, res) {
        return res.redirect('/reported');
    },
    async reset(req, res) {
        // db.User.findOne({where: {email: req.params.email, verf_key: req.params.token}})
        // .then(user => {
        //     if(user){
        return res.render('reset', { email: req.params.email, verf_key: req.params.token, layout: 'auth' });
        //         }else{
        //             throw {
        //                 name: 'PRAException',
        //                 msg: 'Invalid Request!'
        //             }
        //         }
        //     })
        //     .catch(err => {
        //         if(err && err.name && err.name == 'PRAException'){
        //             return res.status(500).send(err.msg);
        //         }else{
        //             console.log(err);
        //             return res.status(500).send('Error!');
        //         }
        //     })
    },
};