import express from 'express';
import { jwtStrategy } from '../../../../middleware/strategy';
import homeController from './home.controller';
import { userImplant } from '../../../../middleware/auth';
import { tabLite } from '../../../../middleware/tabLite'
import { userPermission } from '../../../../middleware/userPermission';

export const homeRouter = express.Router();
homeRouter.route(['/', '/home']).get(jwtStrategy, tabLite(), userPermission('reported-mail-read'), userImplant, homeController.index);
homeRouter.route('/reported').get(jwtStrategy, userPermission('reported-mail-read'), userImplant, homeController.reported);
homeRouter.route('/reported/:id').get(jwtStrategy, userPermission('reported-mail-read'), userImplant, homeController.reported);
homeRouter.route('/approved').get(jwtStrategy, tabLite(), userPermission('reported-mail-read'), userImplant, homeController.approved);
homeRouter.route('/declined').get(jwtStrategy, tabLite(), userPermission('reported-mail-read'), userImplant, homeController.declined);
homeRouter.route('/blacklist').get(jwtStrategy, tabLite(), userPermission('blacklist-tab-read'), userImplant, homeController.blacklist);
homeRouter.route('/gctx').get(jwtStrategy, tabLite(), userPermission('gctx-tab-read'), userImplant, homeController.gctx);