from flask import Flask, request
from redis import Redis
from rq import Queue
from kue import for_unblocking_Sender,for_deletingsingle_mail,for_unblocking_domain,for_unblocking_domain,for_blocking_domain,for_blocking_domain,for_blocking_domain,for_blocking_sender , for_blocking_sender ,for_scanning_mail ,for_deleting_mail,for_restore_single_mail,for_restore_emails, for_advanceScan
import sqlite3
from sqlite3 import Error
import os

from dotenv import load_dotenv
load_dotenv()

q = Queue(connection=Redis(),default_timeout=300)
app = Flask(__name__)


def sql_fetch(con,filename,mail):
    cursorObj = con.cursor()
    cursorObj.execute('SELECT status="completed" FROM Scans where fileName=? and emailId=?' , (filename,mail))
    rows = cursorObj.fetchone()
    if rows:
        return 1
    else:
        return 0
for_restore_emails

def sql_insert(con, entities):
    cursorObj = con.cursor()
    cursorObj.execute("INSERT INTO Scans(fileName,status,emailId) VALUES(?,?,?)",entities)
    con.commit()

def sql_table(conn):
    cursorObj = conn.cursor()
    cursorObj.execute("CREATE TABLE IF NOT EXISTS Scans(id integer PRIMARY KEY, fileName text, status text, emailId text)")
    conn.commit()

def sql_connection():   
    try:
        con = sqlite3.connect('database.db')
        sql_table(con)
        print("Connection is established: Database is created in memory")

    except Error:
        print(Error)

    finally:
        con.close()
        return con


@app.route('/api/deleteSingleMail', methods=['POST',])
def deleteSingleMail():
    req_data = request.get_json()
    print("req_data",req_data)
    subject = req_data['subject']
    startDate = req_data['startDate']
    endDate = req_data['endDate']
    mail= req_data['mail']
    frrom = req_data['from']
    filename= req_data['filename']
    try:
        userName= req_data['options']['userName']
        password= req_data['options']['password']
        targetMailbox= req_data['options']['targetMailbox']
        targetFolder= req_data['options']['targetFolder']
    except:
    #     userName = os.getenv("userName")
    #     password = os.getenv("password")
    #     targetMailbox = os.getenv("targetMailbox")
    #     targetFolder =os.getenv("targetFolder")
    # q.enqueue(for_deletingsingle_mail, userName, password,targetMailbox,targetFolder,subject,startDate,endDate,mail,frrom,filename)
        return ('false', 500)

@app.route('/api/scan', methods=['POST',])
def scan():
    req_data = request.get_json()
    sender = req_data['sender']
    startDate = req_data['startDate']
    endDate = req_data['endDate']
    filename= req_data['filename']
    try:
        userName= req_data['options']['userName']
        password= req_data['options']['password']
        q.enqueue(for_scanning_mail,userName, password,sender,startDate,endDate,filename)
        return ('success', 200)
    except:
        # userName = os.getenv('userName')
        # password = os.getenv('password')
        # q.enqueue(for_scanning_mail,userName, password,sender,startDate,endDate,filename)
        return ('Exchange Credentials Not Found', 500)

@app.route('/api/advanceScan',  methods=['POST',])
def advanceScan():
    req_data = request.get_json()
    sender = req_data['data']['senderID']
    startDate = req_data['data']['startDate']
    endDate = req_data['data']['endDate']
    filename= req_data['data']['fileName']
    print("advanceScan",req_data)
    try:
        userName= req_data['options']['userName']
        password= req_data['options']['password']
        q.enqueue(for_advanceScan,userName, password,sender,startDate,endDate,filename)
        return ('success', 200)
    except:
        # userName = os.getenv('userName')
        # password = os.getenv('password')
        # q.enqueue(for_advanceScan,userName, password,sender,startDate,endDate,filename)
        return ('Exchange Credentials Not Found', 500)


@app.route('/api/blockSender', methods=['POST',])
def blockSender():
    req_data = request.get_json()
    sender = req_data['sender']
    try:
        userName= req_data['options']['userName']
        password= req_data['options']['password']
        targetMailbox= req_data['options']['targetMailbox']
        targetFolder= req_data['options']['targetFolder']
        print("Creds",userName, password,targetMailbox,targetFolder,sender)
        q.enqueue(for_blocking_sender,userName, password,targetMailbox,targetFolder,sender)
        return ('success', 200)
    except:
        # userName = os.getenv("userName")
        # password = os.getenv("password")
        # targetMailbox = os.getenv("targetMailbox")
        # targetFolder =os.getenv("targetFolder")
        # q.enqueue(for_blocking_sender,userName, password,targetMailbox,targetFolder,sender)    
        return ('Exchange Credentials Not Found', 500)

@app.route('/api/blockDomain', methods=['POST',])
def blockDomain():
    req_data = request.get_json()
    domain = req_data['domain']
    try:
        userName= req_data['options']['userName']
        password= req_data['options']['password']
        targetMailbox= req_data['options']['targetMailbox']
        targetFolder= req_data['options']['targetFolder']
        q.enqueue(for_blocking_domain,userName, password,targetMailbox,targetFolder,domain)
        return ('success', 200)
    except:
        # userName = os.getenv("userName")
        # password = os.getenv("password")
        # targetMailbox = os.getenv("targetMailbox")
        # targetFolder =os.getenv("targetFolder")
        # q.enqueue(for_blocking_domain,userName, password,targetMailbox,targetFolder,domain)
        return ('Exchange Credentials Not Found', 500)

@app.route('/api/unblockDomain', methods=['POST',])
def unBlockDomain():
    req_data = request.get_json()
    print("req_data",req_data)
    domain = req_data['domain']
    try:
        userName= req_data['options']['userName']
        password= req_data['options']['password']
        targetMailbox= req_data['options']['targetMailbox']
        targetFolder= req_data['options']['targetFolder']
        q.enqueue(for_unblocking_domain,userName, password,targetMailbox,targetFolder,domain)
        return ('success', 200)
    except:
        # userName = os.getenv("userName")
        # password = os.getenv("password")
        # targetMailbox = os.getenv("targetMailbox")
        # targetFolder =os.getenv("targetFolder")
        # print("Creds",userName, password,targetMailbox,targetFolder,sender)
        # q.enqueue(for_unblocking_domain,userName, password,targetMailbox,targetFolder,domain)
        return ('Exchange Credentials Not Found', 500)


@app.route('/api/unblockSender', methods=['POST',])
def unblockSender():
    req_data = request.get_json()
    sender = req_data['sender']
    try:
        userName= req_data['options']['userName']
        password= req_data['options']['password']
        targetMailbox= req_data['options']['targetMailbox']
        targetFolder= req_data['options']['targetFolder']
        q.enqueue(for_unblocking_Sender,userName, password,targetMailbox,targetFolder,sender)
        return ('success', 200)
    except:
        # userName = os.getenv("userName")
        # password = os.getenv("password")
        # targetMailbox = os.getenv("targetMailbox")
        # targetFolder =os.getenv("targetFolder")
        # print("Creds",userName, password,targetMailbox,targetFolder,sender)
        # q.enqueue(for_unblocking_Sender,userName, password,targetMailbox,targetFolder,sender)
        return ('Exchange Credentials Not Found', 500)


@app.route('/api/deleteMail', methods=['POST',])
def deleteMail():
    con = sqlite3.connect('database.db')
    req_data = request.get_json()
    print("req_data",req_data)
    subject = req_data['subject']
    startDate = req_data['startDate']
    endDate = req_data['endDate']
    mail= req_data['mail']
    frrom = req_data['from']
    filename= req_data['filename']
    try:
        userName= req_data['options']['userName']
        password= req_data['options']['password']
        targetMailbox= req_data['options']['targetMailbox']
        targetFolder= req_data['options']['targetFolder']
    except:
    #     userName = os.getenv("userName")
    #     password = os.getenv("password")
    #     targetMailbox = os.getenv("targetMailbox")
    #     targetFolder =os.getenv("targetFolder")
    # q.enqueue(for_deleting_mail, userName, password,targetMailbox,targetFolder,subject,startDate,endDate,mail,frrom,filename)
    # for i in mail:
    #     entities = (filename, 'completed',i) 
    #     sql_insert(con,entities)
        return ('Exchange Credentials Not Found', 500)

@app.route('/api/restoreMail', methods=['POST',])
def restoreMail():
    req_data = request.get_json()
    subject = req_data['subject']
    startDate = req_data['startDate']
    endDate = req_data['endDate']
    mail= req_data['mail']
    try:
        userName= req_data['options']['userName']
        password= req_data['options']['password']
        targetMailbox= req_data['options']['targetMailbox']
        targetFolder= req_data['options']['targetFolder']
        q.enqueue(for_restore_emails, userName, password,targetMailbox,targetFolder,subject,startDate,endDate,mail)
        return ('success', 200)
    
    except:
        # userName = os.getenv("userName")
        # password = os.getenv("password")
        # targetMailbox = os.getenv("targetMailbox")
        # targetFolder =os.getenv("targetFolder")
        # q.enqueue(for_restore_emails, userName, password,targetMailbox,targetFolder,subject,startDate,endDate,mail)
        # return ('success', 200)
        return ('Exchange Credentials Not Found', 500)

@app.route('/api/recoverSingleMail', methods=['POST',])
def recoverSingleMail():
    req_data = request.get_json()
    subject = req_data['subject']
    startDate = req_data['startDate']
    endDate = req_data['endDate']
    mail= req_data['mail']
    try:
        userName= req_data['options']['userName']
        password= req_data['options']['password']
        targetMailbox= req_data['options']['targetMailbox']
        targetFolder= req_data['options']['targetFolder']
        q.enqueue(for_restore_single_mail, userName, password,targetMailbox,targetFolder,subject,startDate,endDate,mail)
        return ('success', 200)
    
    except:
        # userName = os.getenv("userName")
        # password = os.getenv("password")
        # targetMailbox = os.getenv("targetMailbox")
        # targetFolder =os.getenv("targetFolder")
        # q.enqueue(for_restore_single_mail, userName, password,targetMailbox,targetFolder,subject,startDate,endDate,mail)
        # return ('success', 200)
        return ('Exchange Credentials Not Found', 500)


if __name__ == '__main__':
    con=sql_connection()
    app.run(port=os.getenv("port"), host='0.0.0.0', debug=True)

