import sqlite3
import requests

con = sqlite3.connect('mydatabase.db')

def sql_table(con):
    cursorObj = con.cursor()
    cursorObj.execute("CREATE TABLE IF NOT EXISTS indicators(id integer PRIMARY KEY AUTOINCREMENT, indicator text, description text, title text, content text, type text, id_otx text)")
    con.commit()

def add_data_to_sql(con, results):
    cursorObj = con.cursor()
    values = ""
    fisttime = True
    for result in results:
        cursorObj.execute("INSERT INTO indicators VALUES (NULL,?,?,?,?,?,?)", (result['indicator'], result['description'], result['title'], result['content'], result['type'], result['id']))
    con.commit()

def fetch_data(page, con):
    print(page)
    response = requests.get("https://otx.alienvault.com/api/v1/indicators/export?modified_since=2000-01-01T12%3A35%3A00+00%3A00&limit=100&page={}".format(page), headers={"X-OTX-API-KEY":"9f797dcbda27eddd59392fea59abca33044dafbb2a271bbfe8beb89a1e522651"})
    data = response.json()
    nextAPI = data["next"]
    count = data["count"]
    results = data["results"]
    add_data_to_sql(con, results)
    if nextAPI:
        return page+1
    else:
        return False

def main():
    sql_table(con)
    tempPage = 1
    while True:
        nextPage = fetch_data(tempPage, con)
        if nextPage:
            tempPage = nextPage
        else:
            break


if __name__=="__main__":
    main()