import cron from 'node-cron';
import request from 'request';
import fs from 'fs';
import db from '../src/models';
import connection from './db'

cron.schedule('*/1 * * * *', async () => {
    console.log('Indicators cron will run every minute');
    var url = fs.readFileSync('/home/kratikal/Desktop/Kratikal BackUp/Products/TAB/AlertButton/GCTX/indicatorsCron/last_url.txt');
    const data = await getIndicatorsData(url.toString());
    await saveDataToDatabase(data.results);
    if (data.next != undefined)
        fs.writeFileSync('/home/kratikal/Desktop/Kratikal BackUp/Products/TAB/AlertButton/GCTX/indicatorsCron/last_url.txt', data.next);
});

const getIndicatorsData = async (url) => {
    return new Promise(resolve => {
        const options = {
            url: url,
            headers: {
                "X-OTX-API-KEY": "9f797dcbda27eddd59392fea59abca33044dafbb2a271bbfe8beb89a1e522651",
                'Content-Type': 'application/json'
            }
        };

        console.log("Url formed", options.url);
        request.get(options, (error, response, body) => {
            try{
                console.log("Response", JSON.parse(body));
                resolve(JSON.parse(body));
            }catch(err) {
                console.log("Error while parsing data".err);
            }
        });
    });
}

const saveDataToDatabase = async (dataArr) => {
    if (dataArr.length > 0) {
        for (let i = 0; i < dataArr.length; i++) {
            await saveIndicators(dataArr[i]);
        }
    }
}

const saveIndicators = (data) => {
    return new Promise(resolve => {
        connection.query("insert into indicators values(default,?,?,?,?,?,?,current_timestamp,current_timestamp)", [data.indicator, data.description, data.title, data.content, data.type, data.id], (err, result) => {
            if (err) {
                // console.log("Error while inserting indicator",err);
                fs.appendFileSync('/home/kratikal/Desktop/Kratikal BackUp/Products/TAB/AlertButton/GCTX/indicatorsCron/error_data.txt', JSON.stringify(data));
                resolve(-1);
            }
            else
                resolve(1);
        })
    })
}