import stackTrace from 'stack-trace';

global.RequestError =  class RequestError extends Error {
    constructor(message, code, realError) {
        if(realError instanceof RequestError){
            super(realError.message, realError.code)
            return;
        }
        if(!code)
            code = 500;
        super(message, code);
        this.status = code;
        var trace = stackTrace.get();
        var consoleMessage = message;
        if(realError)
            consoleMessage = realError;
        console.error('\x1b[31mRequestError\x1b[0m', '\x1b[35m'+trace[1].getFileName().replace(__dirname, '')+'\x1b[0m', '\x1b[32m'+trace[1].getLineNumber()+':'+trace[1].getColumnNumber()+'\x1b[0m', consoleMessage);
    }
};