import { TSESTree } from "@typescript-eslint/typescript-estree";

export = {
  name: "test-for-null-using-isNullObject",
  meta: {
    type: <"problem" | "suggestion" | "layout">"problem",
    messages: {
      useIsNullObject: "Test for null using isNullObject.",
    },
    docs: {
      description: "",
      category: <"Best Practices" | "Stylistic Issues" | "Variables" | "Possible Errors">"Best Practices",
      recommended: <false | "error" | "warn">false,
      url: "https://docs.microsoft.com/en-us/office/dev/add-ins/develop/application-specific-api-model?view=powerpoint-js-1.1#ornullobject-methods-and-properties",
    },
    schema: [],
  },
  create: function (context: any) {
    return {
      ":matches(VariableDeclaration, ExpressionStatement) CallExpression[callee.property.name=/.+OrNullObject/]"(
        node: TSESTree.VariableDeclaration
      ) {
        context.report({
          node: node,
          messageId: "useIsNullObject",
        });
      },
    };
  },
};
