import * as commander from "commander";
import * as devSettings from "./dev-settings";
export declare function appcontainer(manifestPath: string, command: commander.Command): Promise<void>;
export declare function clear(manifestPath: string): Promise<void>;
export declare function debugging(manifestPath: string, command: commander.Command): Promise<void>;
export declare function disableDebugging(manifestPath: string): Promise<void>;
export declare function disableLiveReload(manifestPath: string): Promise<void>;
export declare function disableRuntimeLogging(): Promise<void>;
export declare function enableDebugging(manifestPath: string, command: commander.Command): Promise<void>;
export declare function enableLiveReload(manifestPath: string): Promise<void>;
export declare function enableRuntimeLogging(path?: string): Promise<void>;
export declare function getSourceBundleUrl(manifestPath: string): Promise<void>;
export declare function isDebuggingEnabled(manifestPath: string): Promise<void>;
export declare function isLiveReloadEnabled(manifestPath: string): Promise<void>;
export declare function isRuntimeLoggingEnabled(): Promise<void>;
export declare function liveReload(manifestPath: string, command: commander.Command): Promise<void>;
export declare function parseWebViewType(webViewString?: string): devSettings.WebViewType | undefined;
export declare function register(manifestPath: string, command: commander.Command): Promise<void>;
export declare function registered(command: commander.Command): Promise<void>;
export declare function runtimeLogging(command: commander.Command): Promise<void>;
export declare function sideload(manifestPath: string, type: string | undefined, command: commander.Command): Promise<void>;
export declare function setSourceBundleUrl(manifestPath: string, command: commander.Command): Promise<void>;
export declare function sourceBundleUrl(manifestPath: string, command: commander.Command): Promise<void>;
export declare function unregister(manifestPath: string, command: commander.Command): Promise<void>;
export declare function webView(manifestPath: string, webViewString?: string): Promise<void>;
