#!/usr/bin/env node
import { DebuggingMethod, RegisteredAddin, SourceBundleUrlComponents, WebViewType } from "./dev-settings";
import * as registry from "./registry";
export declare const OutlookSideloadManifestPath: string;
export declare function clearDevSettings(addinId: string): Promise<void>;
export declare function deleteDeveloperSettingsRegistryKey(addinId: string): Promise<void>;
export declare function disableRuntimeLogging(): Promise<void>;
export declare function enableDebugging(addinId: string, enable?: boolean, method?: DebuggingMethod, openDevTools?: boolean): Promise<void>;
export declare function enableLiveReload(addinId: string, enable?: boolean): Promise<void>;
export declare function enableRuntimeLogging(path: string): Promise<void>;
export declare function getDeveloperSettingsRegistryKey(addinId: string): registry.RegistryKey;
export declare function getEnabledDebuggingMethods(addinId: string): Promise<DebuggingMethod[]>;
export declare function getOpenDevTools(addinId: string): Promise<boolean>;
export declare function getRegisteredAddIns(): Promise<RegisteredAddin[]>;
export declare function getRuntimeLoggingPath(): Promise<string | undefined>;
export declare function getSourceBundleUrl(addinId: string): Promise<SourceBundleUrlComponents>;
export declare function getWebView(addinId: string): Promise<WebViewType | undefined>;
export declare function isDebuggingEnabled(addinId: string): Promise<boolean>;
export declare function isLiveReloadEnabled(addinId: string): Promise<boolean>;
export declare function registerAddIn(addinId: string, manifestPath: string): Promise<void>;
export declare function setSourceBundleUrl(addinId: string, components: SourceBundleUrlComponents): Promise<void>;
export declare function setWebView(addinId: string, webViewType: WebViewType | undefined): Promise<void>;
export declare function toWebViewTypeName(webViewType?: WebViewType): string | undefined;
export declare function unregisterAddIn(addinId: string, manifestPath: string): Promise<void>;
export declare function unregisterAllAddIns(): Promise<void>;
