// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT license.
Object.defineProperty(exports, "__esModule", { value: true });
const defaults = require("./defaults");
const usageData_1 = require("./usageData");
const jsonData = require("./usageDataSettings");
function listUsageDataSettings() {
    const usageDataSettings = jsonData.readUsageDataSettings(defaults.groupName);
    if (usageDataSettings) {
        for (const value of Object.keys(usageDataSettings)) {
            console.log(`${value}: ${usageDataSettings[value]}\n`);
        }
    }
    else {
        console.log(`No usage data settings.`);
    }
}
exports.listUsageDataSettings = listUsageDataSettings;
function turnUsageDataOff() {
    setUsageDataLevel(usageData_1.UsageDataLevel.off);
}
exports.turnUsageDataOff = turnUsageDataOff;
function turnUsageDataOn() {
    setUsageDataLevel(usageData_1.UsageDataLevel.on);
}
exports.turnUsageDataOn = turnUsageDataOn;
function setUsageDataLevel(level) {
    try {
        jsonData.modifyUsageDataJsonData(defaults.groupName, "usageDataLevel", level);
        switch (level) {
            case usageData_1.UsageDataLevel.off:
                console.log("Usage data has been turned off.");
                break;
            case usageData_1.UsageDataLevel.on:
                console.log("Usage data has been turned on.");
                break;
        }
    }
    catch (err) {
        throw new Error(`Unable to set the usage data level.\n${err}`);
    }
}
//# sourceMappingURL=command.js.map