'use strict';

module.exports = {
  up: async (queryInterface, Sequelize) => {
    try {
      await queryInterface.addColumn('Users', 'outlook_access_token', {
        type: Sequelize.TEXT
      });
      await queryInterface.addColumn('Users', 'outlook_refresh_token', {
        type: Sequelize.TEXT
      });
      await queryInterface.addColumn('Users', 'outlook_token_expiry', {
        type: Sequelize.TEXT
      });
      return Promise.resolve();
    } catch (e) {
      return Promise.reject(e);
    }
  },

  down: async (queryInterface, Sequelize) => {
    try {
      await queryInterface.removeColumn('Users', 'outlook_access_token');
      await queryInterface.removeColumn('Users', 'outlook_refresh_token');
      await queryInterface.removeColumn('Users', 'outlook_token_expiry');
      return Promise.resolve();
    } catch (e) {
      return Promise.reject(e);
    }
  }
};
