import express from 'express';
import mailOperationsController from './mailOperations.controller';
import { validateBody, schemas } from '../../../middleware/validator';
import { outlookLogin_v2, jwtStrategy } from '../../../middleware/strategy';

export const mailOperationsRouter = express.Router();
mailOperationsRouter.route('/message-trace').post(validateBody(schemas.credentials), mailOperationsController.getMessageTrace);
mailOperationsRouter.route('/generate-access-token').get(outlookLogin_v2);
mailOperationsRouter.route('/callback-outlook').get(jwtStrategy, outlookLogin_v2, mailOperationsController.callbackToken);
mailOperationsRouter.route('/callback-outlook-v2').get(jwtStrategy, outlookLogin_v2, mailOperationsController.callbackTokenV2);
mailOperationsRouter.route('/delete-mail').post(mailOperationsController.deleteMail);
mailOperationsRouter.route('/recover-mail').post(mailOperationsController.recoverMail);
mailOperationsRouter.route('/get-mail-header').post(mailOperationsController.getMailHeader);
mailOperationsRouter.route('/movetojunk').post(mailOperationsController.movetojunk);