import BaseJoi from 'joi';
import DateExtension from 'joi-date-extensions';
const Joi = BaseJoi.extend(DateExtension);

export var validateBody = (schema) => {
    return (req, res, next) => {
        console.log("Inside validateBody", req.body, req.query, req.method);
        const result = req.method != 'GET' ? Joi.validate(req.body, schema) : Joi.validate(req.query, schema);
        if (result.error) {
            return res.status(400).json(result.error);
        }

        if (!req.value) {
            req.value = {};
        }
        req.value['body'] = result.value;
        next();
    }
}

export var schemas = {
    credentials: Joi.object().keys({
        username: Joi.string().required().error((err) => {
            return 'Username is required'
        }),
        password: Joi.string().required().error((err) => {
            return 'Password is required'
        }),
        sender: Joi.string().regex(/^([a-zA-Z0-9_\-\.]+)@([a-zA-Z0-9_\-\.]+)\.([a-zA-Z]{2,5})$/).required().error((err) => {
            return 'Please send a valid email'
        }),
        startDate: Joi.string().optional(),
        endDate: Joi.string().optional(),
        subject: Joi.string().optional(),
        senderIP: Joi.string().optional()
    }),
}