'use strict';
import bcrypt from 'bcrypt-nodejs';
module.exports = (sequelize, DataTypes) => {
    const User = sequelize.define('User', {
        firstName: DataTypes.STRING,
        lastName: DataTypes.STRING,
        email: DataTypes.STRING,
        password: DataTypes.STRING,
        status: DataTypes.ENUM('active', 'inactive'),
        valid: DataTypes.INTEGER,
        attempt: DataTypes.INTEGER,
        verf_key: DataTypes.STRING,
        phone: DataTypes.STRING,
        loggedOutAt: DataTypes.DATE,
        otpExpiry: DataTypes.DATE,
        otp: DataTypes.STRING,
        twoFA: DataTypes.INTEGER,
        companyId: DataTypes.INTEGER,
        isNewUser: DataTypes.INTEGER,
        profileImage: DataTypes.STRING,
        fcmKey: DataTypes.STRING,
        outlook_access_token: DataTypes.STRING,
        outlook_refresh_token: DataTypes.STRING,
        outlook_token_expiry: DataTypes.STRING
    }, {});
    User.associate = function (models) {
        // associations can be defined here
        models.User.belongsTo(models.Company, { foreignKey: 'companyId' });
        User.prototype.comparePassword = function (password) {
            var dbPass = this.getDataValue('password');
            // console.log("User.prototype.comparePassword -> dbPass", dbPass)
            return bcrypt.compareSync(password, dbPass);
        }
    };
    return User;
};