'use strict';
module.exports = (sequelize, DataTypes) => {
  const userPolicy = sequelize.define('UserPolicy', {
    policyId: DataTypes.INTEGER,
    userId: DataTypes.INTEGER,
    deletedAt: DataTypes.DATE
  }, { timestamps: true,
    paranoid: true,
  });
  userPolicy.associate = function(models) {
    models.UserPolicy.belongsTo(models.Policy, { foreignKey: 'policyId' });
    models.UserPolicy.belongsTo(models.Employee, { foreignKey: 'userId' });
  };
  return userPolicy;
};