import API from './API';
import config from '../config';

export default class Dashboard extends API {
    constructor() {
        super(config.dashboard.url)
    }

    isValidDomain(data) {
        return super.get(config.dashboard.url + `/dashapi/auth/isvaliddomain`, data);
    }

    findImapEnabled(data) {
        return super.get(config.dashboard.url + `/dashapi/setting/findImapEnabled`, data);
    }

    findImapConfig(data) {
        return super.get(config.dashboard.url + `/dashapi/setting/findImapConfig`, data);
    }

    checkConfig(data) {
        return super.get(config.dashboard.url + `/dashapi/setting/checkConfig`, data);
    }

    sendFcmToAdmin(data) {
        return super.get(config.dashboard.url + `/dashapi/fcm/newMailReportedFcm`, data)
    }

    sendFcmToAdminOutlookLogin(data) {
        return super.get(config.dashboard.url + `/dashapi/fcm/outlookLoginSuccess`, data)
    }
}