import passport from 'passport';
import OutlookStrategy from 'passport-outlook';
import config from './config';
import { Strategy as JwtStrategy } from 'passport-jwt';
import { db } from './models';

const MicrosoftStrategy = require('passport-microsoft').Strategy;
// var MICROSOFT_GRAPH_CLIENT_ID = "9af8ab4e-307c-4cf9-bf83-8f95c629c45f"
// var MICROSOFT_GRAPH_CLIENT_SECRET = ".RB4opZKiJ5u.5ma7BexQ~ld_weqzT3w6~";

var MICROSOFT_GRAPH_CLIENT_ID = "6ca11785-f2a9-486b-b462-ad75e637cd76"
var MICROSOFT_GRAPH_CLIENT_SECRET = "_30TpyE4g7-MxD~ILH.7P7n71Mz~Kg60ta";

var TokenExtractor = function(req) {
    var token = null;
    console.log("req.cookies['XSRF-token-tab'];", req.cookies['XSRF-token-tab'])
    if (req && req.cookies) {
        token = req.cookies['XSRF-token-tab'];
    }
    return token;
}

// JSON WEB TOKENS STRATEGY
passport.use(new JwtStrategy({
    jwtFromRequest: TokenExtractor,
    secretOrKey: config.app.secret,
}, async(payload, done) => {
    try {
        console.log("Inside passport", payload)
        var user = null;
        if (payload.iam == "employee") user = await db.Employee.findOne({ where: { id: payload.sub }, required: true, include: [{ model: db.Company, include: [{ model: db.MetaAuth }] }] });
        else if (payload.iam == "root") {
            user = await db.User.findOne({ where: { id: payload.sub }, required: true, include: [{ model: db.Company, include: [{ model: db.MetaAuth }] }] });
            console.log("user found", JSON.parse(JSON.stringify(user)));
        }
        if (user) {
            user.type = payload.iam;
            const tokenDate = new Date(payload.iat);
            // console.log("(tokenDate.getTime() - user.loggedOutAt.getTime())",(tokenDate.getTime() - user.loggedOutAt.getTime()),tokenDate)
            if (user.loggedOutAt != null && (tokenDate.getTime() - user.loggedOutAt.getTime()) < 0) {
                return done('invalid', false);
            }

            if (new Date(payload.exp) < new Date()) {
                return done('expired', false);
            }
            user.type = payload.iam

            if (user.isNewUser) {
                return done(null, user, 'isNewUser/' + user.email);
            }
            if (!user) {
                return done('user', false);
            }
        }
        done(null, user);
    } catch (error) {
        done(error, false);
    }
}));


passport.use(new OutlookStrategy({
        clientID: "9af8ab4e-307c-4cf9-bf83-8f95c629c45f",
        clientSecret: ".RB4opZKiJ5u.5ma7BexQ~ld_weqzT3w6~",
        callbackURL: config.app.url + '/outlook/search/callback-outlook',
        passReqToCallback: false,
        name: 'msgraph'
    },
    function(accessToken, refreshToken, profile, done) {
        console.log("Access token", accessToken);
        console.log("refreshToken", refreshToken);
        console.log("profile", profile);

        var user = {
            outlookId: profile.id,
            name: profile.DisplayName,
            email: profile.EmailAddress,
            accessToken: accessToken
        };
        if (refreshToken)
            user.refreshToken = refreshToken;
        if (profile.MailboxGuid)
            user.mailboxGuid = profile.MailboxGuid;
        if (profile.Alias)
            user.alias = profile.Alias;
        return done(user);
    }
));

passport.use(new MicrosoftStrategy({
        clientID: MICROSOFT_GRAPH_CLIENT_ID,
        clientSecret: MICROSOFT_GRAPH_CLIENT_SECRET,
        callbackURL: config.app.url + "/outlook/graph/callback-outlook-v2",
        // callbackURL: "http://localhost:4007/outlook/graph/callback-outlook-v2",
        scope: [
            'user.read',
            'openid',
            'profile',
            'offline_access',
            'mail.readwrite',
        ],
        passReqToCallback: true,
    },
    function(req, accessToken, refreshToken, profile, done) {
        console.log("access token", accessToken);
        console.log("refresh token", refreshToken);
        console.log("req.cookies['XSRF-token-tab']", req.cookies['XSRF-token-tab']);
        // asynchronous verification, for effect...
        process.nextTick(function() {

            // To keep the example simple, the user's Microsoft Graph profile is returned to
            // represent the logged-in user. In a typical application, you would want
            // to associate the Microsoft account with a user record in your database,
            // and return that user instead.
            return done(null, profile, { accessToken, refreshToken });
        });
    }
));