import express from 'express';
import virunScanController from './virunScan.controller';
import { sanitize } from '../../../middleware/sanitizer';
import { validateBody, schemas } from '../../../middleware/validator';

export const virunScanRouter = express.Router();
virunScanRouter.route('/').get(sanitize(), validateBody(schemas.reportSchema), virunScanController.index);
virunScanRouter.route('/attachmentRisk').get(sanitize(), virunScanController.attachmentRisk);
virunScanRouter.route('/urlRisk').get(sanitize(), virunScanController.urlRisk);
virunScanRouter.route('/').post(sanitize(), validateBody(schemas.scanSchema), virunScanController.scan);