import BaseJoi from 'joi';
import DateExtension from 'joi-date-extensions';
const Joi = BaseJoi.extend(DateExtension);

export var validateBody = (schema) => {
	return (req, res, next) => {
		const result = req.method != 'GET' ? Joi.validate(req.body, schema) : Joi.validate(req.query, schema);
		if (result.error) {
			return res.status(400).json(result.error);
		}
		if (!req.value) {
			req.value = {};
		}
		req.value['body'] = result.value;
		next();
	}
}

export var schemas = {
    scanSchema: Joi.object().keys({
        name: Joi.string().required(),
        type: Joi.string().valid('file', 'url').required(),
        options: Joi.object().required()
    }),
    reportSchema: Joi.object().keys({
		name: Joi.string().required(),
        type: Joi.string().valid('file', 'url').required(),
		apiKey: Joi.string().required().optional().allow(null).empty('')
    }),
}