'use strict';
module.exports = {
  up: (queryInterface, Sequelize) => {
    return queryInterface.createTable('ReportedMails', {
      id: {
        allowNull: false,
        autoIncrement: true,
        primaryKey: true,
        type: Sequelize.INTEGER
      },
      companyCode:{
        type:Sequelize.STRING
      },
      status: {
        type: Sequelize.STRING
      },
      approvalStatus: {
        type: Sequelize.STRING,
        defaultValue: 'reported'
      },
      approvedBy: {
        type: Sequelize.INTEGER
      },
      fileName: {
        type:  Sequelize.STRING
      },
      body:{
        type: Sequelize.TEXT
      },
      linkStatus:{
        type: Sequelize.STRING
      },
      attachmentStatus:{
        type: Sequelize.STRING
      },
      headerId: {
        type: Sequelize.INTEGER
      },
      bodyId:{
        type: Sequelize.INTEGER
      },
      mailScanResultName:{
        type: Sequelize.STRING
      },
      isDeleted:{
        type: Sequelize.BOOLEAN,
        defaultValue: 0
      },
      createdAt: {
        allowNull: false,
        type: Sequelize.DATE
      },
      updatedAt: {
        allowNull: false,
        type: Sequelize.DATE
      }
    });
  },
  down: (queryInterface, Sequelize) => {
    return queryInterface.dropTable('ReportedMails');
  }
};