'use strict';
module.exports = {
  up: (queryInterface, Sequelize) => {
    return queryInterface.createTable('ReportedMailResults', {
      id: {
        allowNull: false,
        autoIncrement: true,
        primaryKey: true,
        type: Sequelize.INTEGER
      },
      fileName:{
        type: Sequelize.STRING
      },
      name: {
        type: Sequelize.STRING
      },
      reportedMailId: {
        type: Sequelize.INTEGER
      },
      senderAddress: {
        type: Sequelize.TEXT
      },
      recipientAddress: {
        type: Sequelize.TEXT
      },
      subject: {
        type: Sequelize.TEXT
      },
      size: {
        type: Sequelize.STRING
      },
      fromIp: {
        type: Sequelize.STRING
      },
      status: {
        type: Sequelize.STRING
      },
      recieved: {
        type: Sequelize.DATE
      },
      isDeleted:{
        type: Sequelize.BOOLEAN,
        defaultValue: 0
      },
      createdAt: {
        allowNull: false,
        type: Sequelize.DATE
      },
      updatedAt: {
        allowNull: false,
        type: Sequelize.DATE
      }
    });
  },
  down: (queryInterface, Sequelize) => {
    return queryInterface.dropTable('ReportedMailResults');
  }
};