import { db } from '../../../models';
import { queue } from '../../../kue';
import { validateMetaKeys } from '../../../functions';
import { Dashboard } from '../../../modules/Dashboard';

function filterData(metaAuths) {
    let cred = {};
    for (let i = 0; i < metaAuths.length; i++) {
        // console.log("cred", metaAuths[i])
        if (metaAuths[i].key == "userName")
            cred.userName = metaAuths[i].value
        else
            cred.password = metaAuths[i].value
    }

    return cred;
}

export default {
    // async parseEmail(req, res, next) {
    //     console.log("Inside parseEmail", req.user, req.body)
    //     let metaAuths = await new Dashboard().metaAuths({ companyCode: req.body.companyCode });
    //     let creds = {};
    //     // console.log("metaAuths", metaAuths)
    //     // if (metaAuths)
    //     //     creds = await filterData(metaAuths);
    //     creds = await validateMetaKeys(metaAuths)
    //     // console.log("credentials", creds);
    //     var total = (req.body.attachments.length) * 10
    //     return db.ReportedMail.create({
    //         companyCode: req.body.companyCode,
    //         status: "queued",
    //         fileName: req.body.fileName,
    //         reportedBy: req.body.to,
    //         total: total,
    //     })
    //         .then(reportedMail => {
    //             if (reportedMail) {
    //                 if (req.body.attachments.length && req.body.attachments) {
    //                     return req.body.attachments.reduce((p, value) => {
    //                         return db.Attachment.create({
    //                             name: value.name,
    //                             originalName: value.originalName,
    //                             type: value.type,
    //                             reportedMailId: reportedMail.id,
    //                             status: "queued"
    //                         })
    //                     }, Promise.resolve())
    //                 }
    //             } else throw new RequestError('Failed to save report')
    //         })
    //         .then(r => {
    //             return queue.create('report', { fileName: req.body.fileName, companyCode: req.body.companyCode, reciever: req.body.to, sender: req.body.from, credentials: creds, subject: req.body.subject }).save();
    //         })
    //         .then(r => {
    //             if (r) res.status(200).json({ success: true })
    //             else throw new Error("Coundt send mail to Kue for Parsing")
    //         })
    //         .catch(err => {
    //             console.log(err);
    //             next(err);
    //         })
    // },

    async parseEmail(req, res, next) {
        console.log("Inside parseEmail")
        var total = (req.body.attachments.length) * 10;
        let metaAuths = await new Dashboard().metaAuths({ companyCode: req.body.companyCode });
        let creds = {};
        if (metaAuths)
            creds = await filterData(metaAuths);
        creds = await validateMetaKeys(metaAuths)
        return db.ReportedMail.create({
            companyCode: req.body.companyCode,
            status: "queued",
            fileName: req.body.fileName,
            reportedBy: req.body.to,
            total: total,
        })
            .then(reportedMail => {
                if (reportedMail) {
                    if (req.body.attachments.length && req.body.attachments) {
                        return req.body.attachments.reduce((p, value) => {
                            return db.Attachment.create({
                                name: value.name,
                                originalName: value.originalName,
                                type: value.type,
                                reportedMailId: reportedMail.id,
                                status: "queued"
                            })
                        }, Promise.resolve())
                    }
                } else throw new RequestError('Failed to save report')
            })
            .then(r => {
                // return queue.create('report', { fileName: req.body.fileName, companyCode: req.body.companyCode, reciever: req.body.to, sender: req.body.from, subject: req.body.subject }).save();
                return queue.create('report', { fileName: req.body.fileName, companyCode: req.body.companyCode, reciever: req.body.to, sender: req.body.from, credentials: creds, subject: req.body.subject }).save();
            })
            .then(r => {
                if (r) res.status(200).json({ success: true })
                else throw new Error("Coundt send mail to Kue for Parsing")
            })
            .catch(err => {
                console.log(err);
                next(err);
            })
    },

    async getReportedEmail(req, res, next) {
        db.ReportedMail.findOne({
            attributes: ['companyCode', 'approvalStatus', 'status', 'approvedBy', 'createdAt'],
            where: { fileName: req.params.fileName, companyCode: req.query.token },
        })
            .then(r => {
                return res.status(200).json({ 'email': r });
            })
            .catch(err => {
                console.log(err)
                next(err);
            })
    },

    //List all the mails which are reported using TAB
    async listReportedMails(req, res, next) {
        console.log("Inside listReportedMails", req.query);
        let limit = 10;
        let offset = 0;
        let page = 1;
        let search = '%%';
        let sort = ['createdAt', 'DESC'];
        if (req.query.limit != undefined) {
            limit = parseInt(req.query.limit);
        }
        if (req.query.search) {
            search = '%' + req.query.search + '%';
        }
        if (req.query.page) {
            page = req.query.page;
            if (page < 1)
                page = 1;
        }
        if (req.query.sort) {
            if (req.query.sort == 'name') {
                sort = ['name'];
            }
        }
        var condition = { companyCode: req.query.companyCode, approvalStatus: req.query.type };
        var headerFilter = {};
        if (search) headerFilter = { $or: { mailHeader: { like: search }, subject: { like: search } } }
        if (req.query.status) {
            condition['status'] = req.query.status;
        }
        if (req.query.startDate != 'undefined' && req.query.endDate != 'undefined') {
            let startDate = new Date(req.query.startDate);
            let endDate = new Date(req.query.endDate);
            endDate.setDate(endDate.getDate() + 1);
            condition['createdAt'] = { $between: [startDate, endDate] }
        }
        console.log("Condition formed", condition)
        db.ReportedMail.count({
            where: condition,
            include: [{ model: db.Header, where: headerFilter, required: true }]
        })
            .then((count) => {
                console.log("Total reported found", count);
                let pages = Math.ceil(count / limit);
                offset = limit * (page - 1);
                return db.ReportedMail.findAll({
                    attributes: ['id', 'body', 'status', 'approvedBy', 'headerId', 'isDeleted'],
                    where: condition,
                    limit: limit,
                    offset: offset,
                    order: [sort],
                    include: [{
                        model: db.Body,
                        required: false,
                        attributes: ['spamOrHam', 'spamValue', 'hamValue']
                    },
                    {
                        model: db.Header,
                        required: true,
                        where: headerFilter,
                        include: [{ model: db.SenderId }],
                        attributes: ['subject', 'senderId', 'mailTime', 'reciever', 'ccId', 'bccId', 'dmarc', 'dkim', 'spf']
                    }
                    ]
                })
                    .then(mails => {
                        return res.status(200).json({ 'mails': mails, 'count': count, 'pages': pages });
                    })
                    .catch(function (error) {
                        next(error);
                    });
            })
            .catch(function (error) {
                console.log(error);
                next(error)
            });

    },

    async updateExchange(req, res, next) {
        var fileName = req.query.filename;
        return db.ReportedMail.findOne({
            where: { fileName: fileName },
            attributes: ['body', 'fileName', 'id'],
            include: [{ model: db.ReportedMailResult, attributes: ['id', 'recipientAddress'], required: false }, { model: db.Attachment, attributes: ['id', 'name', 'originalName', 'type'] }, { model: db.Header, required: true, attributes: ['spf', 'dkim', 'dmarc', 'ccId', 'bccId', 'mailTime', 'mailHeader'] }, { model: db.Urls, attributes: ['status', 'url', 'id'] }]
        })
            .then(reportedMail => {
                if (reportedMail && reportedMail['fileName'] && (!reportedMail['ReportedMailResults'] || (reportedMail['ReportedMailResults'] && !reportedMail['ReportedMailResults'].length))) {
                    queue.create('exchange-read-who-else', { fileName: reportedMail['fileName'], reportedMailId: reportedMail.id }).save();
                } else if (reportedMail) return res.status(200).json({ reportedMail });
                throw new RequestError('No Mails for this company Code and Report ID');
            })
            .catch(err => {
                console.log(err)
                next(err)
            })
    },


    async totalReport(req, res, next) {
        // console.log("Inside totalReport", req.query);
        var companyCode = req.query.companyCode;
        let condition = { companyCode: companyCode };

        if (req.query.startDate != 'undefined' && req.query.endDate != 'undefined' && req.query.startDate != null && req.query.endDate != null && req.query.startDate != '' && req.query.endDate != '') {
            req.query.endDate = new Date(req.query.endDate);
            req.query.endDate.setDate(req.query.endDate.getDate() + 1)
            condition["createdAt"] = { $gte: req.query.startDate, $lte: req.query.endDate }
        }

        return db.ReportedMail.count({
            where: condition,
            include: [{
                model: db.Header,
                required: true,
                attributes: ['senderId']
            }],
            // logging: console.log
        })
            .then(reportedMail => {
                return res.status(200).json({ reportedMailCount: reportedMail });
            })
            .catch(err => {
                console.log(err)
                next(err)
            })
    },

    async pendingReport(req, res, next) {
        var companyCode = req.query.companyCode;
        let condition = { companyCode: companyCode, approvalStatus: 'reported' };
        if (req.query.startDate != 'undefined' && req.query.endDate != 'undefined' && req.query.startDate != null && req.query.endDate != null && req.query.startDate != '' && req.query.endDate != '') {
            req.query.endDate = new Date(req.query.endDate);
            req.query.endDate.setDate(req.query.endDate.getDate() + 1)
            condition["createdAt"] = { $gte: req.query.startDate, $lte: req.query.endDate }
        }
        return db.ReportedMail.count({
            where: condition,
            include: [{
                model: db.Header,
                required: true,
                attributes: ['senderId']
            }]
        })
            .then(reportedMail => {
                return res.status(200).json({ pendingMailCount: reportedMail });
            })
            .catch(err => {
                console.log(err)
                next(err)
            })
    },

    async declinedReport(req, res, next) {
        var companyCode = req.query.companyCode;
        let condition = { companyCode: companyCode, approvalStatus: "declined" };
        if (req.query.startDate != 'undefined' && req.query.endDate != 'undefined' && req.query.startDate != null && req.query.endDate != null && req.query.startDate != '' && req.query.endDate != '') {
            req.query.endDate = new Date(req.query.endDate);
            req.query.endDate.setDate(req.query.endDate.getDate() + 1)
            condition["createdAt"] = { $gte: req.query.startDate, $lte: req.query.endDate }
        }

        return db.ReportedMail.count({ where: condition })
            .then(reportedMail => {
                return res.status(200).json({ declineMailCount: reportedMail });
            })
            .catch(err => {
                console.log(err)
                next(err)
            })
    },

    async approveReport(req, res, next) {
        var companyCode = req.query.companyCode;
        let condition = { companyCode: companyCode, approvalStatus: "approved" };
        if (req.query.startDate != 'undefined' && req.query.endDate != 'undefined' && req.query.startDate != null && req.query.endDate != null && req.query.startDate != '' && req.query.endDate != '') {
            req.query.endDate = new Date(req.query.endDate);
            req.query.endDate.setDate(req.query.endDate.getDate() + 1)
            condition["createdAt"] = { $gte: req.query.startDate, $lte: req.query.endDate }
        }

        return db.ReportedMail.count({ where: condition })
            .then(reportedMail => {
                return res.status(200).json({ approveMailCount: reportedMail });
            })
            .catch(err => {
                console.log(err)
                next(err)
            })
    },

    async topReportedMail(req, res, next) {
        console.log("Inside topReportedMail", req.query);
        var companyCode = req.query.companyCode;
        let condition = { companyCode: companyCode };
        if (req.query.startDate != 'undefined' && req.query.endDate != 'undefined' && req.query.startDate != null && req.query.endDate != null && req.query.startDate != '' && req.query.endDate != '') {
            req.query.endDate = new Date(req.query.endDate);
            req.query.endDate.setDate(req.query.endDate.getDate() + 1)
            condition["createdAt"] = { $gte: req.query.startDate, $lte: req.query.endDate }
        }
        console.log("Query formed", condition, req.query);
        return db.ReportedMail.findAll({
            attributes: [
                [db.sequelize.fn('count', db.sequelize.col('id')), 'reportedByCount'],
                'reportedBy'
            ],
            where: condition,
            raw: true,
            limit: 5,
            order: [
                [db.sequelize.fn('count', db.sequelize.col('id')), 'DESC'],
            ],
            group: ['reportedBy'],
            // logging: console.log
        })
            .then(reportedMail => {
                return res.status(200).json({ topReportedMail: reportedMail });
            })
            .catch(err => {
                console.log(err)
                next(err)
            })
    },
    async fetchReportedMail(req, res, next) {
        console.log("Inside fetchReportedMail");
        var reportId = req.query.id;
        var companyCode = req.query.companyCode;
        return db.ReportedMail.findOne({
            where: { id: reportId, companyCode: companyCode },
            attributes: ['body', 'fileName', 'id', 'reportedBy'],
            include: [{
                model: db.ReportedMailResult,
                attributes: ['id', 'recipientAddress', 'recieved', 'status', 'fromIp', 'isDeleted', 'deleteStatus'],
                required: false
            }, {
                model: db.Attachment,
                attributes: ['id', 'name', 'originalName', 'type']
            }, {
                model: db.Header,
                required: true,
                attributes: ['spf', 'dkim', 'dmarc', 'ccId', 'bccId', 'mailTime', 'mailHeader'],
                include: [{
                    model: db.SenderId,
                    required: true,
                    attributes: ['senderId']
                }]
            }, {
                model: db.Urls,
                attributes: ['status', 'url', 'id', 'deceptive']
            }]
        })
            .then(async reportedMail => {
                if (!reportedMail) throw new RequestError('No Mails for this company Code and Report ID');
                else if (reportedMail['fileName'] && (!reportedMail['ReportedMailResults'] || (reportedMail['ReportedMailResults'] && !reportedMail['ReportedMailResults'].length))) {
                    console.log("Queue created");
                    queue.create('exchange-read-who-else', { fileName: reportedMail['fileName'], reportedMailId: reportedMail.id }).save();
                }
                // console.log("ReportedMail", reportedMail.Header.SenderId.senderId);
                return res.status(200).json({ reportedMail });
            })
            .catch(err => {
                console.log(err)
                next(err)
            })
    },

    async analyticsDomainAuthRisk(req, res, next) {
        var reportId = req.query.id;
        var companyCode = req.query.companyCode;
        return db.ReportedMail.findOne({
            where: { id: reportId, companyCode: companyCode },
            attributes: ['id'],
            include: [{ model: db.Header, required: true, attributes: ['spf', 'dkim', 'dmarc'] }]
        })
            .then(reportedMailHeder => {
                return res.status(200).json({ 'AnalyticsDomainAuthRisk': reportedMailHeder });
            })
            .catch(err => {
                next(err)
            })
    },
    async monthReportedMail(req, res, next) {
        var companyCode = req.query.companyCode;
        var tempDate = new Date();
        tempDate.setMonth(tempDate.getMonth() - 12);
        return db.ReportedMail.findAll({
            attributes: [
                [db.sequelize.fn('count', db.sequelize.col('ReportedMail.id')), 'Approve'],
            ],
            include: [{
                model: db.Header,
                required: true,
                attributes: [
                    [db.sequelize.literal("CASE month(`Header`.`mailTime`) WHEN 1 THEN 'January' WHEN 2 THEN 'February' WHEN 3 THEN 'March' WHEN 4 THEN 'April' WHEN 5 THEN 'May' WHEN 6 THEN 'June' WHEN 7 THEN 'July' WHEN 8 THEN 'August' WHEN 9 THEN 'September' WHEN 10 THEN 'October' WHEN 11 THEN 'November' WHEN 12 THEN 'December' END"), 'year',]
                ],
                where: { mailTime: { $gte: tempDate } },
                group: ['mailTime'],
                order: ['year'],
                raw: true,
                nest: true,
            }],
            where: { approvalStatus: 'approved', companyCode: companyCode },
            group: ['ReportedMail.id']
        })
            .then(approve => {
                // console.log("Arrroved data",approve);
                return db.ReportedMail.findAll({
                    attributes: [
                        [db.sequelize.fn('count', db.sequelize.col('ReportedMail.id')), 'reported'],
                    ],
                    include: [{
                        model: db.Header,
                        required: true,
                        attributes: [
                            [db.sequelize.literal("CASE month(`Header`.`mailTime`) WHEN 1 THEN 'January' WHEN 2 THEN 'February' WHEN 3 THEN 'March' WHEN 4 THEN 'April' WHEN 5 THEN 'May' WHEN 6 THEN 'June' WHEN 7 THEN 'July' WHEN 8 THEN 'August' WHEN 9 THEN 'September' WHEN 10 THEN 'October' WHEN 11 THEN 'November' WHEN 12 THEN 'December' END"), 'year',]
                        ],
                        where: { mailTime: { $gte: tempDate } },
                        group: ['mailTime'],
                        order: ['year'],

                    }],
                    raw: true,
                    nest: true,
                    group: ['ReportedMail.id'],
                    where: { approvalStatus: 'reported', companyCode: companyCode },
                }).then(reported => [reported, approve])
            })
            .then(([reported, approve]) => {
                return db.ReportedMail.findAll({
                    attributes: [
                        [db.sequelize.fn('count', db.sequelize.col('ReportedMail.id')), 'declined'],
                    ],
                    include: [{
                        model: db.Header,
                        required: true,
                        attributes: [
                            [db.sequelize.literal("CASE month(`Header`.`mailTime`) WHEN 1 THEN 'January' WHEN 2 THEN 'February' WHEN 3 THEN 'March' WHEN 4 THEN 'April' WHEN 5 THEN 'May' WHEN 6 THEN 'June' WHEN 7 THEN 'July' WHEN 8 THEN 'August' WHEN 9 THEN 'September' WHEN 10 THEN 'October' WHEN 11 THEN 'November' WHEN 12 THEN 'December' END"), 'year',]
                        ],
                        where: { mailTime: { $gte: tempDate } },
                        group: ['mailTime'],
                        order: ['year'],
                    }],
                    raw: true,
                    nest: true,
                    group: ['ReportedMail.id'],
                    where: { approvalStatus: 'declined', companyCode: companyCode },
                }).then(decliend => [decliend, reported, approve])
            })
            .then(([decliend, reported, approve]) => {
                var data = json(reported.concat(approve, decliend));
                var obj = {};
                for (var i = 0; i < data.length; i++) {
                    // console.log("data[i]", data[i]);
                    if (data[i].Header != null) { // data[i].Header is 
                        var date = data[i].Header.year;
                        var p_date = obj[date] || {};
                        obj[date] = Object.assign(p_date, data[i]);
                    }
                }
                var result = Object.values(obj);
                var collection = [];
                for (var i = 0; i < result.length; i++) {
                    collection[i] = new Object();
                    var year = result[i].Header.year
                    if (result[i].reported && !result[i].Approve && result[i].declined) collection[i] = { "reported": result[i].reported, "year": year, "declined": result[i].declined }
                    if (result[i].Approve && !result[i].reported && result[i].declined) collection[i] = { "year": year, "Approve": result[i].Approve, "declined": result[i].declined }
                    if (result[i].Approve && result[i].reported && result[i].declined == undefined) collection[i] = { "reported": result[i].reported, "year": year, "Approve": result[i].Approve };
                    if (result[i].reported && !result[i].Approve && !result[i].declined) collection[i] = { "reported": result[i].reported, "year": year }
                    if (!result[i].reported && result[i].Approve && !result[i].declined) collection[i] = { "Approved": result[i].Approve, "year": year }
                    if (!result[i].reported && !result[i].Approve && result[i].declined) collection[i] = { "declined": result[i].declined, "year": year }
                    if (result[i].reported && result[i].Approve && result[i].declined) collection[i] = { "reported": result[i].reported, "year": year, "Approve": result[i].Approve, "declined": result[i].declined };
                }
                if (result) {
                    return res.status(200).json({ 'monthlyReport': collection });
                } else throw new RequestError('Error fetching monthly monthlyReport');
            })
            .catch(err => {
                console.log(err)
                next(err)
            })
    },


    async spamOrHamp(req, res, next) {
        var companyCode = req.query.companyCode;
        return db.ReportedMail.findAll({
            where: { companyCode: companyCode },
            attributes: ['id'],
            include: [{
                model: db.Body,
                required: false
            },]
        })
            .then(reportedMail => {
                if (reportedMail)
                    return res.status(200).json({ reportedMail });
                else throw new RequestError('Error Record Not Found');
            })
            .catch(err => {
                console.log(err)
                next(err)
            })
    },

    async getWhoElseMails(req, res, next) {
        console.log("Inside getWhoElseMails", req.body);
        return db.ReportedMailResult.findAll({ where: req.body.condition })
            .then(r => {
                console.log(JSON.parse(JSON.stringify(r)));
                return res.send(r);
            }).catch(err => {
                console.log("Error while getting who else mails from the database", err);
                throw new RequestError('Something went wrong!');
            })
    },
    async updateMailStatus(req, res, next) {
        console.log("Inside updateMailStatus", req.body);
        return db.ReportedMailResult.update({
            isDeleted: req.body.isDeleted,
            deleteStatus: req.body.deleteStatus
        }, {
            where: { id: req.body.id }
        }).then(async r => {
            console.log("Mail status updated");
            await new Dashboard().updateMailboxSecuredReport({ reportedMailId: req.body.reportedMailId, isDeleted: req.body.isDeleted });
            return r;
        }).then(r => {
            return res.send(r)
        }).catch(err => {
            console.log("Error while updating mail status", err);
            throw new RequestError('Something went wrong!');
        })
    },
    async updateBaseMailStatus(req, res, next) {
        console.log("Insde updateBaseMailStatus", req.body)
        return db.ReportedMail.update({
            isDeleted: req.body.condition.isDeleted
        }, {
            where: { id: req.body.condition.reportedMailId }
        }).then(r => {
            console.log("Base mail status updated");
            return res.send(r)
        }).catch(err => {
            console.log("Error while updating mail status", err);
            throw new RequestError('Something went wrong!');
        })
    },
    async headerFileName(req, res, next) {
        console.log("Inside headerFileName", req.body);
        return db.ReportedMail.findOne({
            where: { id: req.body.id },
            attributes: ['fileName']
        }).then(r => {
            if (r)
                res.send({ file: r.fileName })
            else
                res.send({ file: null })
        }).catch(err => {
            console.log("Error while getting file name", err);
            res.send({ file: null })
        })
    },
    async dnsblReport(req, res, next) {
        console.log("Inside dnsblReport", req.body);
        return db.dnsblIpScanneds.findAll({ where: { ip: req.body.ip } })
            .then(r => {
                res.send(r);
            }).catch(err => {
                console.log("Error while fetching data of dnsbl", err);
                res.status(500).send({});
            })
    },
    async depceptiveDomainCheck(req, res, next) {
        console.log("Inside depceptiveDomainCheck", req.body);
        return db.deceptiveDomains.findOne({
            where: { domain: req.body.domain },
            attributes: ['deceptive']
        }).then(r => {
            console.log("Result is", JSON.parse(JSON.stringify(r)))
            if (r)
                res.send(r)
            else
                res.send({ deceptive: false })
        }).catch(err => {
            console.log("Error while checking for deceptive domain", err);
            res.status(500).send({});
        })
    }
}