import express from 'express';
// import parseEmail from './parseEmail.controller';
import parseEmailController from './parseEmail.controller';

export const parseEmailRouter = express.Router();
parseEmailRouter.route('/').post(parseEmailController.parseEmail);
parseEmailRouter.route('/').get(parseEmailController.listReportedMails);
parseEmailRouter.route('/exchange').patch(parseEmailController.updateExchange);
parseEmailRouter.route('/reportedmails').get(parseEmailController.fetchReportedMail);
parseEmailRouter.route('/totalReport').get(parseEmailController.totalReport);
parseEmailRouter.route('/pendingReport').get(parseEmailController.pendingReport);
parseEmailRouter.route('/approveReport').get(parseEmailController.approveReport);
parseEmailRouter.route('/declinedReport').get(parseEmailController.declinedReport)
parseEmailRouter.route('/topReportedMail').get(parseEmailController.topReportedMail);
parseEmailRouter.route('/monthReport').get(parseEmailController.monthReportedMail);
parseEmailRouter.route('/spamOrHamp').get(parseEmailController.spamOrHamp);
parseEmailRouter.route('/analyticsDomainAuthRisk').get(parseEmailController.analyticsDomainAuthRisk);
parseEmailRouter.route('/:fileName').get(parseEmailController.getReportedEmail);
// parseEmailRouter.route('/fetchAttachmentName').get(parseEmailController.fetchAttachmentName);
parseEmailRouter.route('/who-else-mails').post(parseEmailController.getWhoElseMails);
parseEmailRouter.route('/update-mail-status').post(parseEmailController.updateMailStatus);
parseEmailRouter.route('/update-base-mail-status').post(parseEmailController.updateBaseMailStatus);
parseEmailRouter.route('/headerFileName').post(parseEmailController.headerFileName);
parseEmailRouter.route('/dnsblReport').post(parseEmailController.dnsblReport);
parseEmailRouter.route('/depceptiveDomainCheck').post(parseEmailController.depceptiveDomainCheck);