import express from 'express';
import scanController from './scan.controller';
import multer from 'multer';

export const scanRouter = express.Router();
scanRouter.route('/').get(scanController.fetchAttachmentResult);
scanRouter.route('/linkScan').get(scanController.fetchLinkResult);
scanRouter.route('/linkScanAggregate').post(scanController.fetchLinkResult_aggregate);
scanRouter.route('/deleteMail').post(scanController.deleteMail);
scanRouter.route('/deleteSingleMail').post(scanController.deleteSingleMail)
scanRouter.route('/file').post(scanController.scanAttachment)
scanRouter.route('/mailRisk').post(scanController.mailRisk)
scanRouter.route('/unblockSender').post(scanController.unBlockSender)
scanRouter.route('/unblockDomain').post(scanController.unBlockDomain)
scanRouter.route('/approvalStatus').post(scanController.approvalStatus)
scanRouter.route('/blockSender').post(scanController.blockSender)
scanRouter.route('/attachmentRisk').get(scanController.attachmentFind)
scanRouter.route('/urlRisk').get(scanController.urlRisk)
scanRouter.route('/gctxRisk').get(scanController.gctxRisk)
scanRouter.route('/blacklisted').get(scanController.listblacklisted)
scanRouter.route('/blockSender').post(scanController.blockSender)
scanRouter.route('/blockDomain').post(scanController.blockDomain)
scanRouter.route('/recoverMail').post(scanController.recoverMail)
scanRouter.route('/recoverSingleMail').post(scanController.recoverSingleMail)
scanRouter.route('/gctxscore').post(scanController.gctxScore)
scanRouter.route('/recentReportedMails').get(scanController.recentReportedMails)
scanRouter.route('/advanceScan').post(scanController.advanceScan_v2)
    // scanRouter.route('/resultAdvanceScan').post(scanController.resultAdvanceScan)
scanRouter.route('/checkSpamHam').post(scanController.checkSpamHam)
scanRouter.route('/notSpam').post(scanController.notSpam)