'use strict';
module.exports = (sequelize, DataTypes) => {
  const ReportedMail = sequelize.define('ReportedMail', {
    companyCode:DataTypes.STRING,
    status: DataTypes.STRING,
    approvedBy: DataTypes.INTEGER,
    approvalStatus: DataTypes.STRING,
    fileName: DataTypes.STRING,
    body: DataTypes.TEXT,
    linkStatus:DataTypes.STRING,
    attachmentStatus:DataTypes.STRING,
    headerId: DataTypes.INTEGER,
    bodyId:DataTypes.INTEGER,
    reportedBy: DataTypes.STRING,
    score:DataTypes.INTEGER,
    total:DataTypes.INTEGER,
    isDeleted: DataTypes.BOOLEAN,
    mailScanResultName: DataTypes.STRING,
  }, {
    timestamps: true,
    paranoid: true,
  });
  ReportedMail.associate = function(models) {
    models.ReportedMail.belongsTo(models.Header,{foreignKey: 'headerId'})
    models.ReportedMail.belongsTo(models.Body,{foreignKey: 'bodyId'})
    models.ReportedMail.hasMany(models.Attachment,{foreignKey: 'reportedMailId'})  
    models.ReportedMail.hasMany(models.ReportedMailResult,{foreignKey: 'reportedMailId'})  
    models.ReportedMail.hasMany(models.Urls,{foreignKey: 'reportedMailId'})  
  };
  return ReportedMail;
};