'use strict';
module.exports = {
  up: (queryInterface, Sequelize) => {
    return queryInterface.createTable('VirusTotals', {
      id: {
        allowNull: false,
        autoIncrement: true,
        primaryKey: true,
        type: Sequelize.INTEGER
      },
      scanId: {
        type: Sequelize.STRING
      },
      status: {
        type: Sequelize.ENUM('pending', 'completed', 'failed'),
				defaultValue: 'pending'
      },
      contentId: {
        type: Sequelize.INTEGER,
        references: {
					model: 'Contents',
					key: 'id'
				}
      },
      result: {
        type: Sequelize.TEXT
      },
      virusCount: {
        type: Sequelize.INTEGER
      },
      totalScan: {
        type: Sequelize.INTEGER
      },
      createdAt: {
        allowNull: false,
        type: Sequelize.DATE
      },
      updatedAt: {
        allowNull: false,
        type: Sequelize.DATE
      }
    });
  },
  down: (queryInterface, Sequelize) => {
    return queryInterface.dropTable('VirusTotals');
  }
};